(* Mathematica Test File *)

(*	QACommutatorExpand with real Commutator
*)
Test[
	QACommutatorExpand[Commutator[Operator[P], Operator[Q]]],
	Operator[P] ** Operator[Q] - Operator[Q] ** Operator[P],
	TestID->"Simplify-20160704-G8G7C6"
]

(*	QACommutatorExpand with arbitrary expression
*)
Test[
	QACommutatorExpand[Ket[m]],
	Ket[m],
	TestID->"Simplify-20160704-U5X7S1"
]

(*	QACommutatorContract with default ordering
*)
Test[
	QACommutatorContract[Operator[P] ** Operator[Q] - Operator[Q] ** Operator[P]],
	Commutator[Operator[P], Operator[Q]],
	TestID->"Simplify-20160704-T6P7K8"
]

(*	QACommutatorContract with specified ordering
*)
Test[
	QACommutatorContract[Operator[P] ** Operator[Q] - Operator[Q] ** Operator[P], {Operator[Q], Operator[P]}],
	-Commutator[Operator[Q], Operator[P]],
	TestID->"Simplify-20160704-G2V2E4"
]

(*	QACommutatorContract with extracted commutator
*)
Test[
	QACommutatorContract[Operator[P] ** Operator[Q], {Operator[P], Operator[Q]}],
	Commutator[Operator[P], Operator[Q]] + Operator[Q] ** Operator[P],
	TestID->"Simplify-20160704-N6Y1X0"
]

(*	QACommutatorContract with multiple specifications
*)
Test[
	QACommutatorContract[
		Operator[P] ** Operator[Q] ** Operator[R], 
		{{Operator[P], Operator[Q]}, {Commutator[Operator[P], Operator[Q]], Operator[R]}}],
	Commutator[Commutator[Operator[P], Operator[Q]], Operator[R]] + 
		Operator[R] ** Commutator[Operator[P], Operator[Q]] + 
		Operator[Q] ** Operator[P] ** Operator[R],
	TestID->"Simplify-20160704-G4E0P9"
]

(*	QAOrdering - brings multiplied Operators in a given order, rest is expressed as Commutator
*)
Test[
	QAOrdering[Operator[P] ** Operator[Q], {Operator[Q], Operator[P]}],
	Commutator[Operator[P], Operator[Q]] + Operator[Q] ** Operator[P],
	TestID->"Simplify-20160704-C8T8D7"
]

Test[
	QAPowerExpand[(Operator[A] + Operator[B])^2],
	Operator[A] ** Operator[A] + 
		Operator[B] ** Operator[B] + 
		Operator[A] ** Operator[B] + 
		Operator[B] ** Operator[A],
	TestID->"Simplify-20160704-O9M4N7"
]

Test[
	QAPowerExpand[Operator[A]^2],
	Operator[A] ** Operator[A],
	TestID->"Simplify-20160704-G9M5C9"
]

Test[
	QAPowerContract[Operator[A]^3 ** Operator[A]^4],
	Operator[A]^7,
	TestID->"Simplify-20160704-S8L4O3"
]

