(* Wolfram Language Test file *)
(* This file is generated, do not change it by hand *)

(* ::Section:: *)
(* Custom Tests *)


(* ::Section:: *)
(* Prototype: For testing commutator rules *)

(*
   Generated test data:

	dimension: 2 
	upper indices: True 
	normal ordering: True 
	continuous case: False 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = True; 
	normal = True; 
	continuous = False; 
	anti = False; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000001"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: False 
	normal ordering: False 
	continuous case: True 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = False; 
	normal = False; 
	continuous = True; 
	anti = False; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000002"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: False 
	normal ordering: True 
	continuous case: True 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = False; 
	normal = True; 
	continuous = True; 
	anti = False; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000003"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: True 
	normal ordering: True 
	continuous case: True 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
	normal = True; 
	continuous = True; 
	anti = False; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000004"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: False 
	normal ordering: True 
	continuous case: False 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = False; 
	normal = True; 
	continuous = False; 
	anti = True; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000005"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: True 
	normal ordering: True 
	continuous case: False 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = True; 
	normal = True; 
	continuous = False; 
	anti = True; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000006"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: True 
	normal ordering: False 
	continuous case: True 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
	normal = False; 
	continuous = True; 
	anti = True; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000007"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: False 
	normal ordering: False 
	continuous case: True 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = False; 
	normal = False; 
	continuous = True; 
	anti = False; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000008"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: False 
	normal ordering: True 
	continuous case: True 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = False; 
	normal = True; 
	continuous = True; 
	anti = False; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000009"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: True 
	normal ordering: True 
	continuous case: True 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = True; 
	normal = True; 
	continuous = True; 
	anti = False; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000010"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: True 
	normal ordering: True 
	continuous case: True 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
	normal = True; 
	continuous = True; 
	anti = False; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000011"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: True 
	normal ordering: False 
	continuous case: False 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
	normal = False; 
	continuous = False; 
	anti = True; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000012"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: True 
	normal ordering: True 
	continuous case: False 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = True; 
	normal = True; 
	continuous = False; 
	anti = True; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000013"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: False 
	normal ordering: False 
	continuous case: True 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = False; 
	normal = False; 
	continuous = True; 
	anti = True; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000014"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: True 
	normal ordering: True 
	continuous case: True 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 1 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
	normal = True; 
	continuous = True; 
	anti = True; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 1; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000015"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: False 
	normal ordering: True 
	continuous case: False 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = False; 
	normal = True; 
	continuous = False; 
	anti = False; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000016"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: True 
	normal ordering: True 
	continuous case: False 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
	normal = True; 
	continuous = False; 
	anti = False; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000017"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: False 
	normal ordering: False 
	continuous case: True 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = False; 
	normal = False; 
	continuous = True; 
	anti = False; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000018"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: True 
	normal ordering: False 
	continuous case: True 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = True; 
	normal = False; 
	continuous = True; 
	anti = False; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000019"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: False 
	normal ordering: True 
	continuous case: True 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = False; 
	normal = True; 
	continuous = True; 
	anti = False; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000020"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: False 
	normal ordering: False 
	continuous case: False 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = False; 
	normal = False; 
	continuous = False; 
	anti = True; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000021"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: True 
	normal ordering: False 
	continuous case: False 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
	normal = False; 
	continuous = False; 
	anti = True; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000022"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: False 
	normal ordering: True 
	continuous case: False 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = False; 
	normal = True; 
	continuous = False; 
	anti = True; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000023"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: False 
	normal ordering: True 
	continuous case: False 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = False; 
	normal = True; 
	continuous = False; 
	anti = True; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000024"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: True 
	normal ordering: True 
	continuous case: True 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: p 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = True; 
	normal = True; 
	continuous = True; 
	anti = True; 
	on1 = p; 
	on2 = p; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000025"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: False 
	normal ordering: False 
	continuous case: False 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = False; 
	normal = False; 
	continuous = False; 
	anti = False; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000026"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: False 
	normal ordering: True 
	continuous case: False 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = False; 
	normal = True; 
	continuous = False; 
	anti = False; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000027"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: True 
	normal ordering: True 
	continuous case: False 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
	normal = True; 
	continuous = False; 
	anti = False; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000028"
]

(*
   Generated test data:

	dimension: 2 
	upper indices: True 
	normal ordering: True 
	continuous case: True 
	use anti-commutation: False 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = True; 
	normal = True; 
	continuous = True; 
	anti = False; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000029"
]

(*
   Generated test data:

	dimension: 3 
	upper indices: True 
	normal ordering: False 
	continuous case: False 
	use anti-commutation: True 
	name of operator 1: p 
	name of operator 2: q 
	upper index 1: 1 
	upper index 2: 2 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
	normal = False; 
	continuous = False; 
	anti = True; 
	on1 = p; 
	on2 = q; 
	ui1 = 1; 
	ui2 = 2; 
																				 			(* calculation *)
	
	delta = If[continuous, DiracDelta, DiscreteDelta];
	sgnanti = If[anti, -1, +1];
	sgndelta = Piecewise[{{ +1, anti }, { +1, normal }}, -1];
	com = If[
		Order[on1, on2] == 0 && Order[ui1, ui2] == 0, 
		delta@@Table[QASimplescript[l, i, up] - QASimplescript[k, i, up], {i, 1, dim}] Operator[1], 
		0];
	op1 = Operator[on1, Table[QASimplescript[k, i, up], {i, 1, dim}], { ui1 }];
	op2 = Operator[on2, "H", Table[QASimplescript[l, i, up], {i, 1, dim}], { ui2 }];
	{ op1, op2 } = If[normal, { op1, op2 }, { op2, op1 }];
	
	(op1 ** op2) /. DefineCommutatorRule[anti, continuous, normal, dim] ),	
																							(* intended outcome *)
	
	sgnanti (op2 ** op1) + sgndelta com ,
	
	TestID->"Commutator_20190523_000030"
]


