(* Wolfram Language Test file *)
(* This file is generated, do not change it by hand *)

(* ::Section:: *)
(* Custom Tests *)

(*	TODO: Problems with QAIntegrate
	- DiracDelta: integration variable left over is merely a convention
	- Product of Integrals: automatically rename integration variables?
	- Integration maybe equivalent with different integration variables -> impose rule?
	- Integral about DiracDelta and 2 integration ranges only valid for Infinity? - shrink validity?
	  (also for one integration range)
*)

(* Integrate about 0 *)
Test[
	QAIntegrate[0, V, 3, x],
	0,
	TestID->"Integrate-20181213-S5W1J8"
]

(* Integrate about constant *)
Test[
	QAIntegrate[Pi, V, 3, x],
	Pi V,
	TestID->"Integrate-20181213-D4I4H9"
]

(* Put constant outside Integrate *)
Test[
	QAIntegrate[E QASimplescript[x, 1, True], V, 3, x],
	E QAIntegrate[QASimplescript[x, 1, True], V, 3, x],
	TestID->"Integrate-20181213-O9I5B4"
]

(* Combine product of Integrations *)
Test[
	QAIntegrate[QASimplescript[x, 1, True], U, 3, x] QAIntegrate[QASimplescript[y, 2, True], V, 3, y],
	QAIntegrate[QASimplescript[x, 1, True] QASimplescript[y, 2, True], AngleBracket[U, V], 3, x, y],
	TestID->"Integrate-20181213-P3R4W5"
]


(* ::Section:: *)
(* Prototype: Apply DiracDelta in Integrate about 2 integration ranges *)

(*
   Generated test data:

	dimension: 2 
	use upper indices: False 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = False; 
																				 			(* calculation *)
	
	QAIntegrate[
		QASimplescript[x, 1, up] QASimplescript[y, 2, up] * 
		DiracDelta@@Table[QASimplescript[x, i, up] - QASimplescript[y, i, up], { i, 1, dim }], 
		Infinity, dim, x, y] ),	
																							(* intended outcome *)
	
	QAIntegrate[QASimplescript[x, 1, up] QASimplescript[x, 2, up], Infinity, dim, x] ,
	
	TestID->"Integrate_20190523_000001"
]

(*
   Generated test data:

	dimension: 3 
	use upper indices: False 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = False; 
																				 			(* calculation *)
	
	QAIntegrate[
		QASimplescript[x, 1, up] QASimplescript[y, 2, up] * 
		DiracDelta@@Table[QASimplescript[x, i, up] - QASimplescript[y, i, up], { i, 1, dim }], 
		Infinity, dim, x, y] ),	
																							(* intended outcome *)
	
	QAIntegrate[QASimplescript[x, 1, up] QASimplescript[x, 2, up], Infinity, dim, x] ,
	
	TestID->"Integrate_20190523_000002"
]

(*
   Generated test data:

	dimension: 2 
	use upper indices: True 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = True; 
																				 			(* calculation *)
	
	QAIntegrate[
		QASimplescript[x, 1, up] QASimplescript[y, 2, up] * 
		DiracDelta@@Table[QASimplescript[x, i, up] - QASimplescript[y, i, up], { i, 1, dim }], 
		Infinity, dim, x, y] ),	
																							(* intended outcome *)
	
	QAIntegrate[QASimplescript[x, 1, up] QASimplescript[x, 2, up], Infinity, dim, x] ,
	
	TestID->"Integrate_20190523_000003"
]

(*
   Generated test data:

	dimension: 3 
	use upper indices: True 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
																				 			(* calculation *)
	
	QAIntegrate[
		QASimplescript[x, 1, up] QASimplescript[y, 2, up] * 
		DiracDelta@@Table[QASimplescript[x, i, up] - QASimplescript[y, i, up], { i, 1, dim }], 
		Infinity, dim, x, y] ),	
																							(* intended outcome *)
	
	QAIntegrate[QASimplescript[x, 1, up] QASimplescript[x, 2, up], Infinity, dim, x] ,
	
	TestID->"Integrate_20190523_000004"
]


(* ::Section:: *)
(* Prototype: Integrate about Exponential resolved to DiracDelta *)

(*
   Generated test data:

	dimension: 2 
	use upper indices: False 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = False; 
																				 			(* calculation *)
	
	QAIntegrate[
		Power[E, I Plus@@Table[QASimplescript[k, i, up] (QASimplescript[x, i, up] - QASimplescript[y, i, up]), { i, 1, dim }]], 
		Infinity, dim, k] ),	
																							(* intended outcome *)
	
	DiracDelta@@Table[QASimplescript[x, i, up] - QASimplescript[y, i, up], { i, 1, dim }] (2 Pi)^dim ,
	
	TestID->"Integrate_20190523_000005"
]

(*
   Generated test data:

	dimension: 3 
	use upper indices: False 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = False; 
																				 			(* calculation *)
	
	QAIntegrate[
		Power[E, I Plus@@Table[QASimplescript[k, i, up] (QASimplescript[x, i, up] - QASimplescript[y, i, up]), { i, 1, dim }]], 
		Infinity, dim, k] ),	
																							(* intended outcome *)
	
	DiracDelta@@Table[QASimplescript[x, i, up] - QASimplescript[y, i, up], { i, 1, dim }] (2 Pi)^dim ,
	
	TestID->"Integrate_20190523_000006"
]

(*
   Generated test data:

	dimension: 2 
	use upper indices: True 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = True; 
																				 			(* calculation *)
	
	QAIntegrate[
		Power[E, I Plus@@Table[QASimplescript[k, i, up] (QASimplescript[x, i, up] - QASimplescript[y, i, up]), { i, 1, dim }]], 
		Infinity, dim, k] ),	
																							(* intended outcome *)
	
	DiracDelta@@Table[QASimplescript[x, i, up] - QASimplescript[y, i, up], { i, 1, dim }] (2 Pi)^dim ,
	
	TestID->"Integrate_20190523_000007"
]

(*
   Generated test data:

	dimension: 3 
	use upper indices: True 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
																				 			(* calculation *)
	
	QAIntegrate[
		Power[E, I Plus@@Table[QASimplescript[k, i, up] (QASimplescript[x, i, up] - QASimplescript[y, i, up]), { i, 1, dim }]], 
		Infinity, dim, k] ),	
																							(* intended outcome *)
	
	DiracDelta@@Table[QASimplescript[x, i, up] - QASimplescript[y, i, up], { i, 1, dim }] (2 Pi)^dim ,
	
	TestID->"Integrate_20190523_000008"
]


(* ::Section:: *)
(* Prototype: Integrate about Exponential resolved to DiscreteDelta *)

(*
   Generated test data:

	dimension: 2 
	use upper indices: False 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = False; 
																				 			(* calculation *)
	
	QAIntegrate[
		Power[E, -I Plus@@Table[If[i == 0, +1, -1] QASimplescript[x, i, up] (QASimplescript[j, i, up] + QASimplescript[k, i, up]), { i, 0, dim }]], 
		A, dim, x] ),	
																							(* intended outcome *)
	
	DiscreteDelta@@Table[-QASimplescript[j, i, up] + -QASimplescript[k, i, up], { i, 1, dim }] * 
		A Exp[-I (QASimplescript[x, 0, up] (QASimplescript[j, 0, up] + QASimplescript[k, 0, up]))] ,
	
	TestID->"Integrate_20190523_000009"
]

(*
   Generated test data:

	dimension: 3 
	use upper indices: False 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = False; 
																				 			(* calculation *)
	
	QAIntegrate[
		Power[E, -I Plus@@Table[If[i == 0, +1, -1] QASimplescript[x, i, up] (QASimplescript[j, i, up] + QASimplescript[k, i, up]), { i, 0, dim }]], 
		A, dim, x] ),	
																							(* intended outcome *)
	
	DiscreteDelta@@Table[-QASimplescript[j, i, up] + -QASimplescript[k, i, up], { i, 1, dim }] * 
		A Exp[-I (QASimplescript[x, 0, up] (QASimplescript[j, 0, up] + QASimplescript[k, 0, up]))] ,
	
	TestID->"Integrate_20190523_000010"
]

(*
   Generated test data:

	dimension: 2 
	use upper indices: True 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = True; 
																				 			(* calculation *)
	
	QAIntegrate[
		Power[E, -I Plus@@Table[If[i == 0, +1, -1] QASimplescript[x, i, up] (QASimplescript[j, i, up] + QASimplescript[k, i, up]), { i, 0, dim }]], 
		A, dim, x] ),	
																							(* intended outcome *)
	
	DiscreteDelta@@Table[-QASimplescript[j, i, up] + -QASimplescript[k, i, up], { i, 1, dim }] * 
		A Exp[-I (QASimplescript[x, 0, up] (QASimplescript[j, 0, up] + QASimplescript[k, 0, up]))] ,
	
	TestID->"Integrate_20190523_000011"
]

(*
   Generated test data:

	dimension: 3 
	use upper indices: True 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
																				 			(* calculation *)
	
	QAIntegrate[
		Power[E, -I Plus@@Table[If[i == 0, +1, -1] QASimplescript[x, i, up] (QASimplescript[j, i, up] + QASimplescript[k, i, up]), { i, 0, dim }]], 
		A, dim, x] ),	
																							(* intended outcome *)
	
	DiscreteDelta@@Table[-QASimplescript[j, i, up] + -QASimplescript[k, i, up], { i, 1, dim }] * 
		A Exp[-I (QASimplescript[x, 0, up] (QASimplescript[j, 0, up] + QASimplescript[k, 0, up]))] ,
	
	TestID->"Integrate_20190523_000012"
]


(* ::Section:: *)
(* Prototype: Integrate about Exponential resolved to DiscreteDelta with expanded subexpressions *)

(*
   Generated test data:

	dimension: 2 
	use upper indices: False 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = False; 
																				 			(* calculation *)
	
	QAIntegrate[
		Power[E, -I Plus@@Table[If[i == 0, +1, -1] (QASimplescript[x, i, up] QASimplescript[j, i, up] + QASimplescript[x, i, up] QASimplescript[k, i, up]), { i, 0, dim }]], 
		A, dim, x] ),	
																							(* intended outcome *)
	
	DiscreteDelta@@Table[-QASimplescript[j, i, up] + -QASimplescript[k, i, up], { i, 1, dim }] * 
		A Exp[-I (QASimplescript[x, 0, up] (QASimplescript[j, 0, up] + QASimplescript[k, 0, up]))] ,
	
	TestID->"Integrate_20190523_000013"
]

(*
   Generated test data:

	dimension: 3 
	use upper indices: False 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = False; 
																				 			(* calculation *)
	
	QAIntegrate[
		Power[E, -I Plus@@Table[If[i == 0, +1, -1] (QASimplescript[x, i, up] QASimplescript[j, i, up] + QASimplescript[x, i, up] QASimplescript[k, i, up]), { i, 0, dim }]], 
		A, dim, x] ),	
																							(* intended outcome *)
	
	DiscreteDelta@@Table[-QASimplescript[j, i, up] + -QASimplescript[k, i, up], { i, 1, dim }] * 
		A Exp[-I (QASimplescript[x, 0, up] (QASimplescript[j, 0, up] + QASimplescript[k, 0, up]))] ,
	
	TestID->"Integrate_20190523_000014"
]

(*
   Generated test data:

	dimension: 2 
	use upper indices: True 
*)
Test[
	(																						(* parameters *)

	dim = 2; 
	up = True; 
																				 			(* calculation *)
	
	QAIntegrate[
		Power[E, -I Plus@@Table[If[i == 0, +1, -1] (QASimplescript[x, i, up] QASimplescript[j, i, up] + QASimplescript[x, i, up] QASimplescript[k, i, up]), { i, 0, dim }]], 
		A, dim, x] ),	
																							(* intended outcome *)
	
	DiscreteDelta@@Table[-QASimplescript[j, i, up] + -QASimplescript[k, i, up], { i, 1, dim }] * 
		A Exp[-I (QASimplescript[x, 0, up] (QASimplescript[j, 0, up] + QASimplescript[k, 0, up]))] ,
	
	TestID->"Integrate_20190523_000015"
]

(*
   Generated test data:

	dimension: 3 
	use upper indices: True 
*)
Test[
	(																						(* parameters *)

	dim = 3; 
	up = True; 
																				 			(* calculation *)
	
	QAIntegrate[
		Power[E, -I Plus@@Table[If[i == 0, +1, -1] (QASimplescript[x, i, up] QASimplescript[j, i, up] + QASimplescript[x, i, up] QASimplescript[k, i, up]), { i, 0, dim }]], 
		A, dim, x] ),	
																							(* intended outcome *)
	
	DiscreteDelta@@Table[-QASimplescript[j, i, up] + -QASimplescript[k, i, up], { i, 1, dim }] * 
		A Exp[-I (QASimplescript[x, 0, up] (QASimplescript[j, 0, up] + QASimplescript[k, 0, up]))] ,
	
	TestID->"Integrate_20190523_000016"
]


