(* Wolfram Language Test file *)

(* An Operator "Constant" can be excluded from Integrate *)
Test[
	QAIntegrate[Operator[a] ** Operator[b, { Subscript[x, 1] }, {}], s, 1, x],
	Operator[a] ** QAIntegrate[Operator[b, { Subscript[x, 1] }, {}], s, 1, x],
	TestID->"IntegrateOperators-20181216-V2H9C3"
]

Test[
	QAIntegrate[Operator[b, { Subscript[x, 1] }, {}] ** Operator[a], s, 1, x],
	QAIntegrate[Operator[b, { Subscript[x, 1] }, {}], s, 1, x] ** Operator[a],
	TestID->"IntegrateOperators-20181216-Z4D9M9"
]

(* Apply a Hermitian operation inside an Integrate *)
Test[
	Hermitian[QAIntegrate[Operator[b, { Subscript[x, 1] }, {}], s, 1, x]],
	QAIntegrate[Operator[b, "H", { Subscript[x, 1] }, {}], s, 1, x],
	TestID->"IntegrateOperators-20181216-C1K5V6"
]

(* Combine Integrates with Operators as integrand *)
Test[
	QAIntegrate[Operator[a, { Subscript[x, 1] }, {}], A, 2, x] ** QAIntegrate[Operator[b, { Subscript[y, 2] }, {}], B, 2, y],
	QAIntegrate[Operator[a, { Subscript[x, 1] }, {}] ** Operator[b, { Subscript[y, 2] }, {}], AngleBracket[A, B], 2, x, y],
	TestID->"IntegrateOperators-20181216-D2M1P6"
]