(* Wolfram Language Test file *)

(* Summation about 0 *)
Test[
	QASum[0, k],
	0,
	TestID->"Sum-20181216-D9X4O7"
]

(* Summation about Constant *)
Test[
	QASum[Pi, k],
	Pi QASum[1, k],
	TestID->"Sum-20181216-B4H1A8"
]

(* Summation about Constant Times Expression *)
Test[
	QASum[Pi 1 / k ^ 2, k],
	Pi QASum[1 / k ^ 2, k],
	TestID->"Sum-20181216-E2N3P4"
]

(* Combine product of Sums *)
Test[
	QASum[1 / j ^ 3, j] QASum[1 / k ^ 2, k],
	QASum[1 / j ^ 3 * 1 / k ^ 2, j, k],
	TestID->"Sum-20181216-H7N0D5"
]

(* Apply DiscreteDelta in Sum about 2 summation ranges *)
Test[
	QASum[QASimplescript[j, 1, True] QASimplescript[k, 2, True] DiscreteDelta[QASimplescript[j, 1, True] - QASimplescript[k, 1, True], QASimplescript[j, 2, True] - QASimplescript[k, 2, True]], 
		k, j],
	QASum[QASimplescript[k, 1, True] QASimplescript[k, 2, True], k],
	TestID->"Sum-20181216-S5D0O7"
]

(* Apply DiscreteDelta in Sum about 2 summation ranges *)
Test[
	QASum[QASimplescript[j, 1, True] QASimplescript[k, 2, True] DiscreteDelta[QASimplescript[j, 1, True] + QASimplescript[k, 1, True], QASimplescript[j, 2, True] + QASimplescript[k, 2, True]], 
		k, j],
	- QASum[QASimplescript[k, 1, True] QASimplescript[k, 2, True], k],
	TestID->"RulesSupplement-20181227-J6H2Q3"
]

(* Summation about "Summation Variable"
   This assumption is correct, but the rule was removed because it enables very large expressions.  

Test[
	QASum[QASimplescript[k, 2, True], k],
	0,
	TestID->"Sum-20181216-Z1T6I1"
]
*)

