(* Wolfram Language Test file *)

(* An Operator "Constant" can be excluded from Sum *)
Test[
	QASum[Operator[a] ** Operator[b, { QASimplescript[x, 1, True] }, {}], x],
	Operator[a] ** QASum[Operator[b, { QASimplescript[x, 1, True] }, {}], x],
	TestID->"SumOperators-20181216-V2H9C3"
]

Test[
	QASum[Operator[b, { QASimplescript[x, 1, True] }, {}] ** Operator[a], x],
	QASum[Operator[b, { QASimplescript[x, 1, True] }, {}], x] ** Operator[a],
	TestID->"SumOperators-20181216-Z4D9M9"
]

(* Apply a Hermitian operation inside a Sum *)
Test[
	Hermitian[QASum[Operator[b, { QASimplescript[x, 1, True] }, {}], x]],
	QASum[Operator[b, "H", { QASimplescript[x, 1, True] }, {}], x],
	TestID->"SumOperators-20181216-C1K5V6"
]

(* Combine Sums with Operators as summation expressions *)
Test[
	QASum[Operator[a, { QASimplescript[x, 1, True] }, {}], x] ** QASum[Operator[b, { QASimplescript[y, 2, True] }, {}], y],
	QASum[Operator[a, { QASimplescript[x, 1, True] }, {}] ** Operator[b, { QASimplescript[y, 2, True] }, {}], x, y],
	TestID->"SumOperators-20181216-D2M1P6"
]

(* Distribution Law with Sums and Operators *)
Test[
	(QASum[Operator[a, { QASimplescript[x, 1, True] }, {}], x] + QASum[Operator[b, { QASimplescript[x, 2, True] }, {}], x]) ** 
	(QASum[Operator[a, { QASimplescript[x, 1, True] }, {}], x] + QASum[Operator[b, { QASimplescript[x, 2, True] }, {}], x]),
	
	QASum[Operator[a, { QASimplescript[x, 1, True] }, {}], x] ** QASum[Operator[a, { QASimplescript[x, 1, True] }, {}], x] + 
	QASum[Operator[a, { QASimplescript[x, 1, True] }, {}], x] ** QASum[Operator[b, { QASimplescript[x, 2, True] }, {}], x] +
	QASum[Operator[b, { QASimplescript[x, 2, True] }, {}], x] ** QASum[Operator[a, { QASimplescript[x, 1, True] }, {}], x] + 
	QASum[Operator[b, { QASimplescript[x, 2, True] }, {}], x] ** QASum[Operator[b, { QASimplescript[x, 2, True] }, {}], x],
	TestID->"SumOperators-20181217-F7C5J3"
]
