(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    118741,       3021]
NotebookOptionsPosition[     86634,       2235]
NotebookOutlinePosition[    114234,       2868]
CellTagsIndexPosition[    114191,       2865]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Dirac Equation", "Title",
 CellChangeTimes->{{3.7379060270276327`*^9, 3.7379060309720855`*^9}}],

Cell[CellGroupData[{

Cell["Initialization", "Section",
 CellChangeTimes->{{3.746514322396964*^9, 3.746514325484739*^9}, {
  3.749185788173243*^9, 3.7491857925271187`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "QuantumAlgebra`"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7464441987103815`*^9, 3.746444236622961*^9}, {
  3.7467845915842257`*^9, 3.7467846033962855`*^9}, {3.746784661775163*^9, 
  3.746784664075014*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellChangeTimes->CompressedData["
1:eJwVzn001XccB/DUTYZdae6YCsUhatdD5O4qfDFRmduD0sNVCuvkJrWoFkNC
HkpChx7YkaOHK91Zt9Qo1I7aLBHVaTnNZB5+v3m4k8fS3p8/Pud13ud9zvt8
Fuzcty5ca9q0aT/hdEPyf1b0cSxLpe20F54dLKskY7wqZhVCrYvTuSIYfTBy
XxV8E+i7vA6ONoVY98Mic9GrHRzHVt2rsM2GGd2WM85CpdWkTSGc/pWb8CZ8
a6cnUMPUhNKFv8IgxxCOPMFCqx7BuMqKpFyeYzP6Xp7Jh+2f3v7nAtQVv0m5
D7elbQ/vg1OunnJRP8cqtc4Xh8L1xg2OO2FG+g7PMFiv3N9CPlxduzocjs9a
UkbKBvT+Jfd6e/pGwM1LurIU0KFhnnYybHasXUpKXDcZZMKc6qkVpERQE0oK
6npvk3ucRnpIk7xnwgJow4SN5bBv68CyO7SzeExGbiwfPE2u22a64S70vy6o
Ipdli9trYOKpvEmy1lsqvwffrvi8mLxyfqqB9DL7w+RPqFgVnPE3bD2pStca
4Fh5ye5OXTh0wKdRH1p1buo2glsd7S+5QLOnQQ4SuDEvtDII9ouCZ2+GpgGv
K8kt9tESOXw0kn04Dy6+dpi7C1OdTPY8g6ua1L/8BY/81uTaC/0igz9+gDcT
DQIMBzm21MWs2QbOlvbW2cPjrVKBM9S9tELqCuMiegQSuFBpstoNdtY8eU9W
+89v2wKt0vIn46Fzh+zhdXgrOTbw5iD9v8A4fYhjF66I5GTHSOtB8myn7o/k
sRHzF2T9dW+/DHjrqGkHqXB6Pi8T7h8ajiTjhqquklNTOf+dgt/xSR2lMKXY
iKuAfuc0wTfg7+Pxp8idud0GKti4MuPLmRqOvYzSNAqhabumrQzyPYoYi3cc
i1jSrLGFsn6p74FRjoUEH4o5B+MuqlUD4xwLsy5oG4H1csvMUdgyfOvqnAmO
GamPjLjCb+5crI+E8sEWrSzYs97R/iSM0p0YnyXkmd3Q4zodGNakowqCxjdS
Ap4Y8kx6+W5fP4wQ6OiMwZKejMfjcM23Rc/Jt+4v3pG7bS4YTcDuqhtSst/G
qYTMCvRZ+x4mH/VrJO3sFpaYzkF/qGbtXHh/VFlsCRPs5g+Ru0IVM62gx2E9
iQ3U3i6OI8N6lE/IkjBl4yK4qOO8eI8Rz2T2LrUxZMLYBLkh1dMhFrbwuQVH
4JpODyVZVZic/j10N9nncxRqpp/+LA5u9Ch8X03ZXdY6DG3zkz6eFvFM3/r4
LuMveBYZVqPO9eHZHbF5aR48I24QVULtV+1CNdxW//pE6Nc8E+sZ2UZDi7mj
KtLuk6ePSWdDjVcKTGTjD05SDozQ6PjyTJJ72dsZ/pC69jkZYlJn5Q6jwqcS
yIGya7M94NgVuYIUqpbpe0JvB9kOssIitoiMTVw+n9Eec+siqweGOXL3rhwv
b9iq01YQDOPTUmvL4YPUqCA1dO76IMpcidx6L9van2f/A9YQ+l0=
  "]],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellChangeTimes->CompressedData["
1:eJwVzn0w1HkcB/DUJofbHs4ep+cYIrceInur8MWJHs6qSGWVwjXZ9HBRXTpK
tjyUCg09cCMjtR72nJU6hLpRdy4l1HSZzsl5+P3Ow548Vbr354/PvOY975n3
fBbv3LchXGfKlCk/4fRDMn9W9HEsVa3rsBdeGiwoI6M9SmZkQ51rU7kcuP9Q
5L5K+NrPe2UdHG0KseiHOQtFL3dwHFtTU2KVBpO7zaZdgirzd5bZcOpXLsJy
+MbaQKCByrj8Jb/CAPsQjjzDQisfwtiykhPpPMem9b24mAnbP739z1WoL36d
eA8Gn94e3gcnnd3lon6OlelcyQ2FG40b7HfC5KQd7mGwXnWgmXywtnZtOByf
YVNAygYM/iX3erp7R8AtNl2pCmjXME83AT61r11OSpw3z0yBF6omV5ESQXUo
KajrvU3ucRjpIU0yngmzoCUTNhbBvm0DK+7QzrIxGRlYNHie3BBsuuku9C0W
VJIr0sTt1TD+XMY7stZTKq+Bb1Z9nksWXplsID0W/GHyJ1SsCUr+G7acVSfp
DHCsKG93pz4cOujVaAjNOzd3G8Ft9rbXneCCJwF2EhiYEVoWAPtFQbO2QNP1
r8rIrbb7JXL4cCTtSAZcdusIdxcqHUz2PINrmjS//AWP/tbk3At9IoM+foDl
8TPXzx7k2HKnBU8t4Sxpb50tPNUiFThC/eurpM4wNqJHIIFLVCZrXWBn9eP3
ZJXv/Nat0Px05rvj0LFD9qAYViTE+JUP0v+LjZOGOHa1UCQnO0ZaDpGXOvV/
JE+OLHxO1hd7+iTDimOmHaTCoW1eCjwwNBxJxg5V3iQnJy/8dw5+x5/oyIeJ
uUZcCfS5rA0qhb+PHz9H7kzvnqmGjauTv5yu5diLKG2jEJq2a1sLIN+jiF70
lmMRNk+1VlDWL/U+OMqxkKDD0Zdh7DWNemCcY2EWWa0jsF5uljIKm4crbs6Z
4JiR5uiIM/zmzrX6SCgfbNZJhT0b7W3Pwij9ifEZQp5ZDz2q04NhTXrqAGhc
mrj+8WyeSW/c7euHEQI9vTGY15P8aByu+zanjXzj+vwtudvyqtEE7K4slZL9
lg55ZKqfl/97mHDMp5G0tl6SZzoH/eFq/7nw3qgq1wzGWc8fIneFKqabQ7cj
BhJLqLtdHEuG9agek3lhqsalcGnHFfEeI57JbJ1qo8m4sQlyk9LdLgY28+lZ
R+G6TjcVWZmdkPQ9dDXZ53UMaqee/ywWBrplv6+i7CprGYZWmSc+nhfxzNDi
1C7jL3gWGVatSffi2R3xwvwMeFHcICqDui/bhRoYXP/qTOjXPBMbGFnth4vm
jqpJ60+ePCIdZ2s9EmE8G79/lrJfhFbPm2eS9BuejvAHpX8bGWJSZ+4Ko8In
48iBgluz3OBYoVxBCtUrDN2hp51sB1myKCaHjIlfOZ/RHnPpIqsGhjly964L
Hp6wRa81KwgeP62sLYL3lVEBGujY9UGUsppnpl01aRa+PPsf0T/5xQ==
  "]],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellChangeTimes->CompressedData["
1:eJwVzn0w1HkcB/Bok6Nb6uxxSnowNurWQ8reVvjiJHJWpfSwSuGabHq4qC4d
EuVZeRhS3MjoYaU915Y6CnWj7lxKVNNlOkdn8/udhz15qnTvzx+fec173jPv
+czdvmdNhN6kSZN+whmF5v+s7OVYhtrAeTcsGKioJmM8q6YWQb1z+lwJ3Hsg
ak8NfBXos7wBjrSE2vbBEmvRi20cx/xuV9llw7Se+ZMLoMrmnbgI6n+1THgN
dtsbCzQwJb583q8w2CmUI0+ysJr7MK66KjGX59jk3uen82HHpzf+OQuNJK+S
78AtJ7ZG9MIJVw+FqI9j1XrFpWFwrXmT03aYlrrNIxw2qva1kvf86/0j4NjU
RRWkvN/4X3K3l4dPJNy46HWGEjo2zTJIgo+d6heTUtcNJunwVO3EClIqqAsj
BQ1vbpC7nIe1pEXeE2EhFDNhcyXs3dy/9CbtLByVk+srB3LINVss192Cq64I
asil2ZKOOpiQlfeOrPeSKW7D7hWfl5IXiyeaSM/Zf1j8CZV+IWl/w7ZMdape
P8cqy3Z2GcHB/d7N06BN14YeM7jZyeH8Ejj7UbCjFK7PC6sOhn2iENON0DLg
ZTW5yWGvVAHvD2cfyoMLLx/ibsEUZ4tdT6Bfi+aXv+Dh31pc30DfqJCPH+C1
BJOA6QMcW7xk9mMxNJW9aXCAx9tkAhdodH6FzBXGRWoFUjhPZeG/DHbVPXxP
1q6yat8EbU7kvzsKXTrl967A60mxgdcG6P+55qmDHDt7UaQgO4fbDpAFXUY/
kseGrZ+RjVe8fNPg9SOWnaTS+emsdLhvcCiKjBusuUROTJz6Lwt+xyd2lsPk
UjOuCvqe0YVchb+PHc0it+f2mKhh88q0L6foOPY8WtcshJYduvYKyGuVMXPe
cixy0WOdHZT3yXz2j3AsNORgzBkYd06j7h/jWLhtYfswbFTMTx+BrUPXL80Y
55iZ5vCwK/zm5rnGKKgYaNXLgNq1Tg6ZMNpofGyqkGf2gw8aDGF4i6E6GJpf
TQ54OJ1nsgu3evtgpMDQcBSWadMejMHV35Y8Jbvdnr0ld4rPmo3DnpqrMrJP
7FxGZgR6B72HSUd8m0l7+3llljPQH6wLmgnvjKhK58N4e6tBckeYcooNdD9k
LBVDg62SODJcq3pIloWrmhfABZ3Fkl1mPJM7LKmPIeNHx8l1KR6OsbCVzy08
DFd3uavImqKk1O+hm8Ue7yNQp5/zWRxc7170vpaym7xtCNrlJ37MEfFsmu3x
HeZf8CwqvE6T682zmxLr8jx4WtIkqoYGLzqEGril8eXJsK95JjE2s9sL58wc
UZP2nzx6QLpM13kmwwQ2djeTcmCkztCHZ9LcC14u8IeUoKdkqEWDjRuMjpiI
J/srLpu6w9GLCiUpVC+d5gG9HOXbyKo5sSVkbMJyK0Z7bNlrsrZ/iCN37jjl
6QXbDNsLQ+DREyn1lfBuSnSwBrq8/iBKX8mzkg+3s21X8ex/1gf6YQ==
  "]],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellChangeTimes->CompressedData["
1:eJwVzn0w1HkcB/DUJke3PZw9TpHKEHXrIWVvy8MXJ6XO9qD0sErhmmx6uChH
h4QsodDQAzdqpFbac21tHYW6kTuXEtV0mc7R2fx+52FPnpLu/fnjM695z3vm
PZ+5O/etCzeYMGHCTzjjkPyfFd0cy1QbuuyFZ/pKK8lo74ophdDgwkSuCO4/
FLlPC18H+i2vhUNNIbY9sGiO6OUOjmOr7lbYZ0Nl1/xJZ6DK5r1dIZz41TLh
DdjpYCLQwNSES/N+hUHOIRx5goVqH8L4yoqkXJ5jk7pfnM6HbZ/e+uc8NBa/
TrkHt6VtD++G425eclEPxyoNzhWHwvVm9c47oTJ9h1cYrFMdaCYfBNQEhMOR
KYtKSVmvyb/kXh8vvwi4edGbTAV0qp9tmAyfONcsJiVum6ZlwFNV4+6kRFAd
Sgpq394i97gM6kjzvKfCAmjHhI3lsHtr79LbtLNwWEZuLO/LIddts9hwB668
JtCSS7PFbdUwMSvvPVnjI5XfhZ3unxeTZefG60lvqz/M/4SKVcHKv2HLSXW6
QS/Hykt2dxjD/oO+jVOhTcemLlO41dnx4hJo9TjISQI35oVWBsEeUfD0zdBi
zatKcovjfokcPhzMPpIHF149wt2BqS7me57CVU2aX/6Csb81ub2F/pHBHz/A
G4nT1szo49jiJVZP7OB06dtaR3i8RSpwhcYX3aVuMD5CJ5DAeSrzgGWwo/rR
GFm10rJ1C7RJy39/FLq2yx5cgzeTYwJv9NH/c83S+zl2vkwkJ9sHWw6RZzqM
fySPDc55TtZd8/FXwptxFu2kwuXZ7Ax4oH8gkozv114hx8dP/ZcFv+OT2i/B
lGJTrgL6n9UHX4e/jxzNInfmdk1Tw8YVyi8n6zn2IkrfKIQWbfrWUsjrFNHW
7zgWseiJ3h7KeqR+B4c4FhJ8OPosjL+gUfeOcCzMtqB1ENbJ52cMweaBm1dm
jnLMVBM76Aa/uX2hLhLK+5oNMqFuvbPjSRhlPDoyRcgzh/6GWiMY1mSkDoJm
11PWPJrBM+nlO909MEJgZDQMS3TKhhG4+tuiZ2Snx/N35G6786ajsEt7XUr2
2LmUkJmBvmvHYHKcfyPp4DCvxGIm+sPVa2fBe0Oq4vkwwcGyn9wVqphsAz2P
mEjsoOF2cTwZplM9IkvCVI0L4IL2c+I9pjyTOS6piSYThkfJDaleTjGwmc8t
iIWrOzxVpLYwOf176GG+zzcO6ifmfBYPN3oWjlVR9pC1DED7/KSPOSKeTbU9
vsvsC55FhlVrcn15dls851IePC2uF1VCw5dtQg3cVvfqROjXPBObmNrvh9az
htSkwyePG0jXGXrvFJjIRu6fpBwYoTfy45kk97KPK/whde0zMsS81sYDRoWP
J5C9pVene8LhMrmCFKqXTvWCPk6yHWSFdUwRGZO43JLRHlv2hqzqHeDI3btO
efvAFqPWgmB4NC21phzeT40K0kDXNx9EGSt4FmB1L9t2Jc/+B81c+TA=
  "]],

Cell[BoxData["\<\"ALIASES:\\nESC op(du) ESC - Operator with or without \
indices\\nESC hop(du) ESC - Hermitian Operator with or without indices\\nESC \
ket(du) ESC - Ket with or without indices\\nESC (du)bra ESC - Bra with or \
without indices\\nESC (du)braket(du) ESC - BraKet with (left and / or right) \
subscript(s) and / or superscript(s).\\nLetters in parenthesis signify \
optional indices (u - up, d - down) and must be given in that \
order.\\nExample: use opd for an Operator with lower index.\"\>"], "Print",
 CellChangeTimes->CompressedData["
1:eJwVzn001XccB/DUTYbdHuaOKT06RO16iNzdCl9MSuaqSOUqeVgnNz0sYjQk
ykOp0CHFjhypK+7MlYxC7ajNKFGdltNMjfx+83AnT5X2/vzxOa/zPu9z3uez
ZM+BzaFa06ZN+wmnG5jzs6KfYxkqbdv98MJQSSUZ6VI+Kw9qXZ7OFcCDR8IP
1MCX3u5rG+FYW6DZACxYJHq+m+PYxtvlFpkwrXfZjAtQafrOPA9O/2qNsAq+
stQTqGFKfPHSX6GvTSBHnmJBNfdhXGV5YhbPsRn9z87nwK5Pb/5zCeqKXybf
gQEnd4X2wykHZ7logGOVWvmFQXCLYbPNHpiWuts5BDYpD7WT9zwbPEPhxKyV
JaRsUO9fcr+rs3sY3L7ydYYCWjcv0E6Cj2waVpESh22z0+G5uql1pERQH0QK
Gt/cJPfZjvaRRtmPhbnQnAlbymD/zsHVt2hnxbiM9CsbOktuDjDeWgs33BDU
kKszxV31MOFM9juywVUqvw1frfu8kCzNn2omXRb+YfQnVGz0T/sbdpxWpWoN
cqysaG+PLhw+7NaiD017tvUawJ02Vlfs4cKHvtYS6JcdVOkLB0T+c7ZDY68X
leQOq4MSObw/mhmdDVdcj+ZqYYqt0b7HcGOb+pe/YMxvbQ5voEe4/8cPsCph
ttfcIY6tsl/4yBzOkb5ptIInOqQCO6h7ZZ3UAcaF9QkkcKnSyHMN7KlvfU/W
bTDp3AFNT+a8OwbtumX3bsDqpCjvqiH6f4lh6jDHLpWK5GT3aMcR8kKP7o/k
8dFFT8mmG64eabA61ribVNg+WZAODw2PhJNxwzXXyKmpc/+dgd/xid3FMLnQ
gCuHHhc1/hXw94ljZ8g9Wb2zVbBlfdqXMzUcexahaRFC4y5NZwnk+xSRi99y
LGzlI40FlA1I3Q+PcSzQ/2jkRRh3Wa0anOBYiFlu5yhski9LH4PtI9XX5k1y
zEAdM+oAv7l1uSkcyofatTJg3xYbq9MwQndyYpaQZ5bDDxp1YEibjsoXGlYk
e7XO5Zn0am3/AAwT6OiMw6K+tAcTcNO3BU/IV45P35J7zS8ZTMLemgopOWBu
W0RmeLv5vIdJsR4tpKXl0iLjeeiP1vvMh3fGlIXLYLylyTAZHKSYaQqdovUk
5lB7lziODOlTtpJFIcqW5XB5d754nwHPZFb2DZFk/PgkuTXF2ToKtvNZuTFw
U4+TkqzJS0r9HjoaHXCLhZrpZz+Lg35Oee/rKDvKOkagRU7ix7MinumbnQg2
/IJn4SH16iw3nt0SLyrOhufFzaJKqP28S6iGAU0vTgV9zTOxnoHFQbh4/piK
tPzk4QPSbq7GJRkmsIm7pyl7h2l03Hkmybrqagd/SPF5QgYaNZo6wojQqXhy
sOT6HCc4XipXkELVan1n6Got202WL44qIKMS1pow2mNrXpN1gyMcuTf4nIsr
7NDpzPWHx06mNJTBuykRvmpo9/qDKH09z4aUI5lmG3j2P9ed+pc=
  "]]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"SetNotebookStyles", "[", "]"}]], "Input",
 CellChangeTimes->{
  3.7464465350782166`*^9, {3.7467867818666573`*^9, 3.746786794272455*^9}, {
   3.7488646165231347`*^9, 3.7488646349727516`*^9}, {3.749185776721876*^9, 
   3.7491857781261196`*^9}}],

Cell[CellGroupData[{

Cell["Rules", "Subsection",
 CellChangeTimes->{{3.749209839205864*^9, 3.7492098401413436`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Declare", " ", "a", " ", "name", " ", "for", " ", "a", " ", "set", " ", 
    "of", " ", "assumptions"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"QASelectDefault", "[", "\"\<Dirac\>\"", "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Define", " ", "the", " ", "Index", " ", "Character", " ", "in", " ", 
     "the", " ", "calculated", " ", "expressions"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QASetIndexCharacter", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<Mixed\>\"", ",", 
       RowBox[{"{", "}"}]}], "}"}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Define", " ", "the", " ", "Index", " ", "Character", " ", "in", " ", 
     "the", " ", "calculated", " ", "expressions"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"QASetIndexCharacter", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<Contravariant\>\"", ",", 
        RowBox[{"{", 
         RowBox[{"p", ",", "p1"}], "}"}]}], "}"}], "]"}], ";"}], " ", "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "Define", " ", "the", " ", "TIME", " ", "COMPONENT", " ", "OF", " ", 
      "MOMENTUM", " ", "as", " ", "being", " ", "integration", " ", 
      "variables"}], ",", " ", 
     RowBox[{"not", " ", "constants"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAResetExplicitIntegrationVariables", "[", "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAAddExplicitIntegrationVariables", "[", 
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["p", "0"], ",", " ", 
       SubscriptBox["p1", "0"]}], "}"}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Define", " ", "Not", " ", "Scripted", " ", "Symbols"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAResetNotScriptedSymbols", "[", "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAAddNotScriptedSymbols", "[", 
     RowBox[{"{", 
      RowBox[{"m", ",", "V"}], "}"}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Define", " ", "variables", " ", "as", " ", "being", " ", "reals", " ", 
     "or", " ", "non", " ", "negative", " ", "reals"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAResetAssumptions", "[", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAAddAssumptions", "[", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "\[Element]", "Reals"}], "&"}], ",", 
       RowBox[{"Table", "[", " ", 
        RowBox[{
         SubscriptBox["p", "i"], " ", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "3"}], "}"}]}], "]"}]}], "]"}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAAddAssumptions", "[", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "\[Element]", "Reals"}], "&"}], ",", 
       RowBox[{"Table", "[", " ", 
        RowBox[{
         SuperscriptBox["x", "i"], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "3"}], "}"}]}], "]"}]}], "]"}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAAddAssumptions", "[", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "\[Element]", "Reals"}], "&"}], ",", 
       RowBox[{"Table", "[", " ", 
        RowBox[{
         SubscriptBox["p1", "i"], " ", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "3"}], "}"}]}], "]"}]}], "]"}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAAddAssumptions", "[", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "\[Element]", "Reals"}], "&"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "\[DoubleStruckCapitalE]", ",", "V", ",", "q"}], 
        "}"}]}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAAddAssumptions", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["p", "0"], "\[GreaterEqual]", "0"}], ",", 
       RowBox[{
        SubscriptBox["p1", "0"], "\[GreaterEqual]", "0"}], ",", " ", 
       RowBox[{"V", "\[GreaterEqual]", "0"}], ",", 
       RowBox[{"m", "\[GreaterEqual]", "0"}], ",", 
       RowBox[{"\[DoubleStruckCapitalE]", "\[GreaterEqual]", "0"}]}], "}"}], 
     "]"}], ";"}], "\[IndentingNewLine]", "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Define", " ", "a", " ", "replacement", " ", "rule", " ", "for", " ", 
     "the", " ", "mass", " ", 
     RowBox[{"invariant", ".", " ", "This"}], " ", "is", " ", "required", " ",
      "to", " ", "perform", " ", "adequate", " ", 
     RowBox[{"simplifications", ".", " ", "Without"}], " ", "giving", " ", 
     "it", " ", "a", " ", "name", " ", "the", " ", "default", " ", "name", 
     " ", "\"\<Dirac\>\"", " ", "is", " ", 
     RowBox[{"used", "."}]}], " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{"QAAddReplacementRules", "[", 
     RowBox[{"{", "  ", 
      RowBox[{
       RowBox[{"QASum", "[", 
        RowBox[{"exp_", ",", "p_"}], "]"}], "\[RuleDelayed]", 
       RowBox[{"QASum", "[", 
        RowBox[{
         RowBox[{"exp", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"m", "^", "n_Integer"}], ")"}], "/;", 
             RowBox[{"n", "\[GreaterEqual]", "2"}]}], "\[RuleDelayed]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"m", "^", 
               RowBox[{"(", 
                RowBox[{"n", "-", "2"}], ")"}]}], " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 SubscriptBox["p", "0"], "2"], "-", 
                SuperscriptBox[
                 SubscriptBox["p", "1"], "2"], "-", 
                SuperscriptBox[
                 SubscriptBox["p", "2"], "2"], "-", 
                SuperscriptBox[
                 SubscriptBox["p", "3"], "2"]}], ")"}]}], ")"}]}], "}"}]}], 
         ",", "p"}], "]"}]}], "}"}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Define", " ", "Anti", " ", "Commutator", " ", "Rules", " ", "and", " ", 
     "Name", " ", "Ordering", " ", 
     RowBox[{"rules", ".", " ", "We"}], " ", "have", " ", "2", " ", "sets", 
     " ", "here", " ", "with", " ", "different", " ", "names", " ", "each", 
     " ", "for", " ", "a", " ", "different", " ", "evaluation", " ", 
     RowBox[{"chain", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAAddReplacementRules", "[", 
     RowBox[{
      RowBox[{"{", " ", 
       RowBox[{
        RowBox[{"DefineNameOrderingRule", "[", 
         RowBox[{"True", ",", "3"}], "]"}], ",", 
        RowBox[{"DefineCommutatorRule", "[", 
         RowBox[{"True", ",", "False", ",", "True", ",", "3"}], "]"}]}], 
       "}"}], ",", "\"\<AntiCommutatorLocal-Dirac\>\""}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAAddReplacementRules", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"DefineNameOrderingRule", "[", 
         RowBox[{"True", ",", "3"}], "]"}], ",", 
        RowBox[{"DefineCommutatorRule", "[", 
         RowBox[{"True", ",", "False", ",", "False", ",", "3"}], "]"}]}], 
       "}"}], ",", "\"\<AntiCommutatorLocal-Reverse-Dirac\>\""}], "]"}], 
    ";"}], "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.748970308237199*^9, 3.7489703878332844`*^9}, {
   3.7489704228220263`*^9, 3.7489704701583986`*^9}, 3.748970505174759*^9, 
   3.7489706999186296`*^9, {3.7489713455338335`*^9, 3.7489714433490677`*^9}, {
   3.7489715074835024`*^9, 3.7489715207165184`*^9}, {3.749012846909777*^9, 
   3.749012872213085*^9}, {3.7490384008539915`*^9, 3.749038475563145*^9}, {
   3.749038552595388*^9, 3.749038565637499*^9}, {3.7492105637737045`*^9, 
   3.7492105929815745`*^9}, {3.749213588022809*^9, 3.7492135893213344`*^9}, {
   3.7492136347328587`*^9, 3.7492136509979506`*^9}, {3.750511250989771*^9, 
   3.7505112708626485`*^9}, {3.750512271611985*^9, 3.7505122853831177`*^9}, {
   3.750512577738172*^9, 3.750512578159047*^9}, 3.750786497598729*^9, 
   3.7549332230880985`*^9, {3.7549332534847555`*^9, 3.754933274109601*^9}, {
   3.7549358673256235`*^9, 3.7549358711523805`*^9}, {3.765452630921174*^9, 
   3.7654526587437468`*^9}, {3.7654526921613693`*^9, 
   3.7654527251132383`*^9}, {3.765453882574889*^9, 3.7654539515579653`*^9}, {
   3.76743156249013*^9, 3.76743158762293*^9}, {3.7674316250074744`*^9, 
   3.7674316443327885`*^9}, {3.7687995522714467`*^9, 3.768799583928298*^9}, {
   3.76882325265517*^9, 3.7688232689029627`*^9}, {3.768823692824069*^9, 
   3.768823696584011*^9}, {3.768823742350528*^9, 3.768823755332837*^9}, {
   3.7688241556837873`*^9, 3.7688241596441965`*^9}, {3.7688343037929306`*^9, 
   3.7688343120578475`*^9}, 3.76883434846342*^9, {3.768834382193814*^9, 
   3.768834383462452*^9}, {3.7688344264674067`*^9, 3.7688344589564533`*^9}, {
   3.7688344918035803`*^9, 3.7688345028021884`*^9}, 3.7688352507429914`*^9, {
   3.7688362275660706`*^9, 3.7688362385926056`*^9}, {3.771250974543264*^9, 
   3.771251048654283*^9}, {3.7712511108101187`*^9, 3.771251131858101*^9}, 
   3.7940493737213793`*^9, {3.7940494649109144`*^9, 3.7940494693161383`*^9}, {
   3.794049834357194*^9, 3.7940498852934866`*^9}, {3.7940500523290396`*^9, 
   3.794050114918697*^9}, {3.794050169808011*^9, 3.7940502211916213`*^9}, {
   3.794052319707897*^9, 3.7940523331629577`*^9}, {3.7941126393347864`*^9, 
   3.794112659758219*^9}, {3.7941170642154503`*^9, 3.7941170705724945`*^9}, {
   3.794118703147397*^9, 3.7941187201838503`*^9}, {3.7949298458947153`*^9, 
   3.7949298569182096`*^9}, {3.794930353679969*^9, 3.7949303821628323`*^9}, {
   3.7949308505250573`*^9, 3.7949308959116983`*^9}, {3.7949314610480947`*^9, 
   3.794931464653457*^9}, {3.7949774239450307`*^9, 3.794977456273615*^9}, {
   3.795150218930225*^9, 3.7951502254348755`*^9}, {3.795852593643931*^9, 
   3.7958525994703665`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "This", " ", "rule", " ", "is", " ", "used", " ", "for", " ", "the", " ", 
    "Dirac", " ", "Equation", " ", "alone"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{"QAAddReplacementRules", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"m", "^", "2"}], "\[RuleDelayed]", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          SubscriptBox["p", "0"], "2"], "-", 
         SuperscriptBox[
          SubscriptBox["p", "1"], "2"], "-", 
         SuperscriptBox[
          SubscriptBox["p", "2"], "2"], "-", 
         SuperscriptBox[
          SubscriptBox["p", "3"], "2"]}], ")"}]}], "}"}], ",", 
     "\"\<DiracEquation\>\""}], "]"}], ";"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7941285806840963`*^9, 3.7941286251163206`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Fields", "Subsection",
 CellChangeTimes->{{3.754937168936249*^9, 3.754937170143011*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Define", " ", "the", " ", "exponent", " ", "of", " ", "wave", " ", 
    "function", " ", "solutions"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"exp", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        SubscriptBox["p", "i"], " ", 
        SuperscriptBox["x", "i"]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "3"}], "}"}]}], "]"}]}], 
    "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.746790561237116*^9, 3.746790579017577*^9}, {
   3.746790624828087*^9, 3.7467906832289424`*^9}, {3.7467910806134157`*^9, 
   3.746791097648903*^9}, {3.7467912451504765`*^9, 3.746791359024001*^9}, {
   3.7472853208397675`*^9, 3.747285355043347*^9}, 3.7492106375024843`*^9, {
   3.767431661662439*^9, 3.767431700829702*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Normalization", " ", "Factor"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"nfac", ":=", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["p", "0"], "+", "m"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"2", "  ", "m"}], ")"}]}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Factor", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"fac", ":=", 
    RowBox[{
     SubscriptBox["p", "0"], "+", "m"}]}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{"Coefficient", " ", "Matrices", " ", "and", " ", "Spinors"}], " ",
     "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    SubscriptBox["\[GothicU]", "1"], ":=", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", 
      RowBox[{
       RowBox[{"-", 
        SubscriptBox["p", "3"]}], "/", "fac"}], ",", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["p", "1"], "+", 
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["p", "2"]}]}], ")"}]}], "/", "fac"}]}], "}"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    SubscriptBox["\[GothicU]", "2"], ":=", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["p", "1"], "-", 
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["p", "2"]}]}], ")"}]}], "/", "fac"}], ",", 
      RowBox[{
       SubscriptBox["p", "3"], "/", "fac"}]}], "}"}]}], "\[IndentingNewLine]", 
   RowBox[{
    SubscriptBox["\[GothicV]", "2"], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        SubscriptBox["p", "3"]}], "/", "fac"}], ",", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["p", "1"], "+", 
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["p", "2"]}]}], ")"}]}], "/", "fac"}], ",", "1", ",", 
      "0"}], "}"}]}], "\[IndentingNewLine]", 
   RowBox[{
    SubscriptBox["\[GothicV]", "1"], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["p", "1"], "-", 
          RowBox[{"\[ImaginaryI]", " ", 
           SubscriptBox["p", "2"]}]}], ")"}]}], "/", "fac"}], ",", 
      RowBox[{
       SubscriptBox["p", "3"], "/", "fac"}], ",", "0", ",", "1"}], "}"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    SubscriptBox["u", "1"], ":=", 
    RowBox[{"nfac", "*", 
     SubscriptBox["\[GothicU]", "1"]}]}], "\[IndentingNewLine]", 
   RowBox[{
    SubscriptBox["u", "2"], ":=", 
    RowBox[{"nfac", "*", 
     SubscriptBox["\[GothicU]", "2"]}]}], "\[IndentingNewLine]", 
   RowBox[{
    SubscriptBox["v", "2"], ":=", 
    RowBox[{"nfac", "*", 
     SubscriptBox["\[GothicV]", "2"]}]}], "\[IndentingNewLine]", 
   RowBox[{
    SubscriptBox["v", "1"], ":=", 
    RowBox[{"nfac", "*", 
     SubscriptBox["\[GothicV]", "1"]}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.738592316868593*^9, 3.738592339289065*^9}, {
   3.7385923760388412`*^9, 3.738592428063814*^9}, {3.738592469357442*^9, 
   3.7385925223866158`*^9}, 3.738592991515793*^9, {3.738593023124278*^9, 
   3.738593043582775*^9}, {3.73859341081429*^9, 3.7385934401927795`*^9}, {
   3.7385936251399508`*^9, 3.738593683110407*^9}, {3.7385942289269543`*^9, 
   3.738594241377874*^9}, {3.7385945438118773`*^9, 3.7385945457377276`*^9}, {
   3.738594615983533*^9, 3.7385946519438925`*^9}, {3.738594829714522*^9, 
   3.738594836917261*^9}, 3.7385948676269393`*^9, {3.7492111031361895`*^9, 
   3.7492111421689034`*^9}, {3.74921120454009*^9, 3.7492112102068996`*^9}, 
   3.749730021516445*^9, {3.7498083097507114`*^9, 3.749808328820673*^9}, {
   3.7510979617521963`*^9, 3.751097979568615*^9}, {3.7523973533199143`*^9, 
   3.75239736072806*^9}, {3.752415153744912*^9, 3.7524151682261586`*^9}, {
   3.7549193448569307`*^9, 3.754919347936687*^9}, {3.767432916814577*^9, 
   3.7674329553655043`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Plane", " ", "Wave", " ", "Solution"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"\[CapitalPsi]", ":=", 
    RowBox[{
     RowBox[{
      UnderscriptBox["\[Sum]", "p"], " ", 
      RowBox[{
       UnderoverscriptBox["\[Sum]", 
        RowBox[{"r", "=", "1"}], "2"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{"m", "/", 
           RowBox[{"(", 
            RowBox[{"V", " ", 
             SubscriptBox["p", "0"]}], ")"}]}], "]"}], 
         SubsuperscriptBox[
          OverscriptBox["c", "^"], 
          RowBox[{
           SubscriptBox["p", "1"], ",", 
           SubscriptBox["p", "2"], ",", 
           SubscriptBox["p", "3"]}], "r"], " ", 
         SubscriptBox["u", "r"], " ", 
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "exp"}], "]"}]}], ")"}]}]}], 
     "+", "\[IndentingNewLine]", 
     RowBox[{
      UnderscriptBox["\[Sum]", "p"], " ", 
      RowBox[{
       UnderoverscriptBox["\[Sum]", 
        RowBox[{"r", "=", "1"}], "2"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{"m", "/", 
           RowBox[{"(", 
            RowBox[{"V", " ", 
             SubscriptBox["p", "0"]}], ")"}]}], "]"}], 
         SubsuperscriptBox[
          OverscriptBox["d", "^"], 
          RowBox[{
           SubscriptBox["p", "1"], ",", 
           SubscriptBox["p", "2"], ",", 
           SubscriptBox["p", "3"]}], 
          RowBox[{"r", ",", "\[Dagger]"}]], " ", 
         SubscriptBox["v", "r"], " ", 
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"+", "\[ImaginaryI]"}], " ", "exp"}], "]"}]}], 
        ")"}]}]}]}]}], "\n", 
   RowBox[{
    OverscriptBox["\[CapitalPsi]_", "_"], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Hermitian", "[", "\[CapitalPsi]", "]"}], "\[CenterDot]", 
       TagBox[
        TemplateBox[{"\[Gamma]","0"},
         "Superscript"],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]]}], "\[InvisibleSpace]", ")"}], "//", 
     RowBox[{"QASimplify", "[", "]"}]}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.749728940273341*^9, 3.7497289887512493`*^9}, {
   3.7497290352767925`*^9, 3.749729061891636*^9}, 3.7497291496293216`*^9, {
   3.749729219926312*^9, 3.749729305279954*^9}, {3.7497293745776157`*^9, 
   3.749729427092954*^9}, {3.7497295567860117`*^9, 3.7497295688088202`*^9}, {
   3.749729602040923*^9, 3.749729647146406*^9}, 3.749729962284891*^9, 
   3.7497317328443346`*^9, {3.749731834020791*^9, 3.7497318439342723`*^9}, {
   3.749811819945609*^9, 3.7498118869487667`*^9}, {3.7498119786238403`*^9, 
   3.7498120051888075`*^9}, {3.7498121634110985`*^9, 3.749812166041068*^9}, {
   3.749812448356779*^9, 3.7498124644696765`*^9}, {3.7498145307137403`*^9, 
   3.74981453936061*^9}, {3.749830226327797*^9, 3.7498302285967493`*^9}, 
   3.749912803913763*^9, 3.75057034044425*^9, 3.7505898043367586`*^9, {
   3.75491737276879*^9, 3.7549173846779194`*^9}, {3.755239812906081*^9, 
   3.7552398320554657`*^9}, {3.767607856077035*^9, 3.767607870248171*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Eigen", " ", "Solutions", " ", "of", " ", "the", " ", "Dirac", " ", 
    "Equation"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Superscript", "[", 
     RowBox[{"\[CapitalPsi]", ",", "1"}], "]"}], ":=", 
    RowBox[{
     SubscriptBox["u", "1"], "*", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "exp"}], "]"}]}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Superscript", "[", 
     RowBox[{"\[CapitalPsi]", ",", "2"}], "]"}], ":=", 
    RowBox[{
     SubscriptBox["u", "2"], "*", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "exp"}], "]"}]}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Superscript", "[", 
     RowBox[{"\[CapitalPsi]", ",", "3"}], "]"}], ":=", 
    RowBox[{
     SubscriptBox["v", "2"], "*", 
     RowBox[{"Exp", "[", 
      RowBox[{"\[ImaginaryI]", " ", "exp"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Superscript", "[", 
     RowBox[{"\[CapitalPsi]", ",", "4"}], "]"}], ":=", 
    RowBox[{
     SubscriptBox["v", "1"], "*", 
     RowBox[{"Exp", "[", 
      RowBox[{"\[ImaginaryI]", " ", "exp"}], "]"}]}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7492126029798937`*^9, 3.7492126126091375`*^9}, {
   3.749212649344903*^9, 3.7492127281450405`*^9}, {3.749212776801013*^9, 
   3.749212780213903*^9}, {3.7492128126221895`*^9, 3.749212821592609*^9}, {
   3.749212860566321*^9, 3.7492129395505805`*^9}, {3.749293490796563*^9, 
   3.749293492117037*^9}, {3.749293533633948*^9, 3.7492935489040976`*^9}, {
   3.7492937559989414`*^9, 3.749293782824461*^9}, 3.749297404937399*^9, {
   3.7676077998354564`*^9, 3.7676078260713253`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Evaluation Chain", "Subsection",
 CellChangeTimes->{{3.7675278827105026`*^9, 3.767527888276621*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "Rationals", " ", "for", " ", "using", " ", "this", " ", "pipeline", " ", 
     "of", " ", "evaluations", "\[IndentingNewLine]", "1.", " ", "SumSplit"}],
     ",", " ", "IntegrateSplit", ",", " ", "AntiCommutatorLocal", ",", " ", 
    RowBox[{
     RowBox[{"Simplify", ":"}], "\[IndentingNewLine]", "\[Rule]", " ", 
     RowBox[{
     "resolve", " ", "summations", " ", "and", " ", "integration", " ", "to", 
      " ", "one", " ", "summation"}]}], ",", " ", 
    RowBox[{
    "sort", " ", "operators", " ", "in", " ", "operator", " ", "products", 
     "\[IndentingNewLine]", "2.", " ", "SortVariables"}], ",", " ", "SumJoin",
     ",", " ", "Dirac", ",", " ", "Simplify", ",", " ", "Dirac", ",", " ", 
    RowBox[{
     RowBox[{"SumSplit", ":"}], "\[IndentingNewLine]", "\[Rule]", " ", 
     RowBox[{
     "bring", " ", "indexed", " ", "variables", " ", "in", " ", 
      "standardized", " ", "order"}]}], ",", " ", 
    RowBox[{"replace", " ", 
     RowBox[{"m", "^", "2"}]}], ",", " ", 
    RowBox[{"simplify", "\[IndentingNewLine]", "3.", " ", "Simplify"}], ",", 
    " ", "SumJoin", ",", " ", 
    RowBox[{
     RowBox[{"Simplify", ":"}], "\[IndentingNewLine]", "\[Rule]", " ", 
     RowBox[{"final", " ", "simplification"}]}]}], "\[IndentingNewLine]", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"QAEvaluate1", "[", "ex_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"ex", "//", 
                  RowBox[{
                  "QAReplaceRepeated", "[", "\"\<SumSplit\>\"", "]"}]}], "//",
                  " ", 
                 RowBox[{
                 "QAReplaceRepeated", "[", "\"\<IntegrateSplit\>\"", "]"}]}], 
                "//", 
                RowBox[{
                "QAReplaceRepeated", "[", 
                 "\"\<AntiCommutatorLocal-Reverse-Dirac\>\"", "]"}]}], "//", 
               RowBox[{"QASimplify", "[", "]"}]}], "//", 
              RowBox[{
              "QAReplaceRepeated", "[", "\"\<SortVariables\>\"", "]"}]}], "//", 
             RowBox[{"QAReplaceRepeated", "[", "\"\<SumJoin\>\"", "]"}]}], "//", 
            RowBox[{"QAReplaceRepeated", "[", "\"\<Dirac\>\"", "]"}]}], "//", 
           RowBox[{"QASimplify", "[", "]"}]}], "//", 
          RowBox[{"QAReplaceRepeated", "[", "\"\<Dirac\>\"", "]"}]}], "//", 
         RowBox[{"QAReplaceRepeated", "[", 
          RowBox[{"{", "\"\<SumSplit\>\"", "}"}], "]"}]}], "//", 
        RowBox[{"QASimplify", "[", "]"}]}], "//", 
       RowBox[{"QAReplaceRepeated", "[", "\"\<SumJoin\>\"", "]"}]}], "//", 
      RowBox[{"QASimplify", "[", "]"}]}], "//", 
     RowBox[{"QAReplaceRepeated", "[", 
      RowBox[{"{", "\"\<SumSplit\>\"", "}"}], "]"}]}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QAEvaluate2", "[", "ex_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"ex", "//", 
                 RowBox[{
                 "QAReplaceRepeated", "[", "\"\<SumSplit\>\"", "]"}]}], "//", 
                " ", 
                RowBox[{
                "QAReplaceRepeated", "[", "\"\<IntegrateSplit\>\"", "]"}]}], "//", 
               RowBox[{
               "QAReplaceRepeated", "[", "\"\<AntiCommutatorLocal-Dirac\>\"", 
                "]"}]}], "//", 
              RowBox[{"QASimplify", "[", "]"}]}], "//", 
             RowBox[{
             "QAReplaceRepeated", "[", "\"\<SortVariables\>\"", "]"}]}], "//", 
            RowBox[{"QAReplace", "[", "\"\<SumJoin\>\"", "]"}]}], "//", 
           RowBox[{"QAReplaceRepeated", "[", "\"\<Dirac\>\"", "]"}]}], "//", 
          RowBox[{"QASimplify", "[", "]"}]}], "//", 
         RowBox[{"QAReplaceRepeated", "[", "\"\<Dirac\>\"", "]"}]}], "//", 
        RowBox[{"QAReplaceRepeated", "[", "\"\<SumSplit\>\"", "]"}]}], "//", 
       RowBox[{"QASimplify", "[", "]"}]}], "//", 
      RowBox[{"QAReplace", "[", "\"\<SumJoin\>\"", "]"}]}], "//", 
     RowBox[{"QASimplify", "[", "]"}]}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.750765586305279*^9, 3.7507655867450814`*^9}, {
   3.7507656235675983`*^9, 3.750765658007486*^9}, 3.750766049457921*^9, 
   3.7507660799742947`*^9, {3.750766111401239*^9, 3.750766144232714*^9}, 
   3.750766461699074*^9, 3.7507865801910524`*^9, 3.754635806016717*^9, 
   3.754910575153778*^9, {3.7549328781557903`*^9, 3.754932897906336*^9}, {
   3.7549329323708544`*^9, 3.75493293352573*^9}, {3.754933644790909*^9, 
   3.754933650745966*^9}, {3.7549336864015837`*^9, 3.754933688664528*^9}, {
   3.754933942708687*^9, 3.7549339671753163`*^9}, {3.7549341729020214`*^9, 
   3.7549341834378476`*^9}, 3.7549342405968847`*^9, {3.7549343729689865`*^9, 
   3.754934396557824*^9}, 3.7549364770414095`*^9, 3.754988954059105*^9, 
   3.7549903266917133`*^9, 3.7549903818281717`*^9, 3.754990868354166*^9, {
   3.7549909970138392`*^9, 3.754991013487795*^9}, {3.7549913029765563`*^9, 
   3.7549913142713313`*^9}, {3.754991770289226*^9, 3.7549917725372386`*^9}, {
   3.7549922124646254`*^9, 3.7549922170353613`*^9}, {3.75499283618839*^9, 
   3.7549928481903067`*^9}, {3.7549945951699677`*^9, 
   3.7549946149091806`*^9}, {3.754994899418578*^9, 3.7549949173536167`*^9}, 
   3.754994981100999*^9, {3.754995236979695*^9, 3.7549952534246883`*^9}, 
   3.754995801564348*^9, {3.754995976241149*^9, 3.754996015531044*^9}, 
   3.7549965362041645`*^9, {3.7549965755857506`*^9, 3.754996599818498*^9}, {
   3.7549967380486*^9, 3.7549967637238655`*^9}, 3.7549973238909535`*^9, {
   3.7550652537239523`*^9, 3.7550652551581182`*^9}, {3.755066153327221*^9, 
   3.755066153516721*^9}, {3.755066281128628*^9, 3.755066405846662*^9}, {
   3.75506646519884*^9, 3.755066466400625*^9}, {3.7550664991978903`*^9, 
   3.755066522669053*^9}, {3.755066559516488*^9, 3.755066611038599*^9}, {
   3.7550666584946203`*^9, 3.755066854958597*^9}, {3.7550669449830494`*^9, 
   3.755067014977751*^9}, {3.768969161804057*^9, 3.7689691736354055`*^9}, {
   3.771251209405113*^9, 3.7712512396386747`*^9}, {3.7949047117670293`*^9, 
   3.794904742730291*^9}, 3.7949343759573755`*^9, {3.7949774999448767`*^9, 
   3.7949775678884187`*^9}, 3.7949775989573684`*^9, {3.7949776539473963`*^9, 
   3.7949776701979494`*^9}, {3.7949777487501945`*^9, 3.794977833433613*^9}, 
   3.7949778834558935`*^9, 3.7949779205188184`*^9, {3.7951502597550917`*^9, 
   3.795150266868111*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Investigate", " ", "this", " ", "chain", " ", "as", " ", "alternative"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QAEvaluate3", "[", "ex_", "]"}], ":=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"ex", "//", 
               RowBox[{"QAReplace", "[", "\"\<SumJoin\>\"", "]"}]}], "//", 
              RowBox[{
              "QAReplace", "[", "\"\<AntiCommutatorLocal\>\"", "]"}]}], "//", 
             RowBox[{
             "QAReplaceRepeated", "[", "\"\<IntegrateSplit\>\"", "]"}]}], "//", 
            RowBox[{"QAReplaceRepeated", "[", "\"\<SumSplit\>\"", "]"}]}], "//", 
           RowBox[{
           "QAReplaceRepeated", "[", "\"\<FullDistributionLaw\>\"", "]"}]}], "//", 
          RowBox[{"QAReplace", "[", "\"\<SumJoin\>\"", "]"}]}], "//", 
         RowBox[{
         "QAReplaceRepeated", "[", "\"\<FullDistributionLaw\>\"", "]"}]}], "//", 
        RowBox[{"QASimplify", "[", "]"}]}], "//", 
       RowBox[{"QAReplace", "[", "\"\<Dirac\>\"", "]"}]}], "//", 
      RowBox[{"QASimplify", "[", "]"}]}], "//", 
     RowBox[{"QAReplace", "[", "\"\<Dirac\>\"", "]"}]}], "//", 
    RowBox[{"QASimplify", "[", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.7949246793980803`*^9, 3.794924731617491*^9}, {
   3.7949248319524946`*^9, 3.7949248385817733`*^9}, {3.7949248864617825`*^9, 
   3.7949248869734154`*^9}, {3.794924944165532*^9, 3.7949249573193693`*^9}, {
   3.7949325915917664`*^9, 3.794932598330751*^9}, 3.794977550773018*^9, 
   3.794977614190647*^9, {3.79497767112049*^9, 3.7949776736786475`*^9}, {
   3.7949779365100713`*^9, 3.7949779670095496`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Helper Relations", "Subsection",
 CellChangeTimes->{{3.7676076679122887`*^9, 3.7676076785907507`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Print", " ", "an", " ", "Assignment"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SetAttributes", "[", 
     RowBox[{"printAssignment", ",", "HoldAll"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"printAssignment", "[", "expr_", "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{
        RowBox[{"Defer", "[", "expr", "]"}], ",", "\"\< = \>\"", ",", " ", 
        "expr"}], "]"}]}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{"printDirac", "[", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"printAssignment", "[", 
           RowBox[{
            RowBox[{"Superscript", "[", 
             RowBox[{"\[Gamma]", ",", "#"}], "]"}], "//", "MatrixForm"}], 
           "]"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}]}], "]"}], ";", 
       RowBox[{"Print", "[", "]"}]}]}], "]"}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.738589483141281*^9, 3.7385895516183324`*^9}, {
   3.7385895960126524`*^9, 3.738589628847865*^9}, 3.7385898301297035`*^9, {
   3.738589914307266*^9, 3.7385899873745193`*^9}, 3.7492103676393003`*^9, {
   3.767607948442996*^9, 3.7676079606104536`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Calculate", " ", "an", " ", "Inner", " ", "Product"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"QAInner", "[", 
     RowBox[{"a_", ",", "b_", ",", "n_Integer", ",", "x_Symbol"}], "]"}], ":=", 
    RowBox[{"QAIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Hermitian", "[", "a", "]"}], ".", "b"}], ",", "V", ",", "n", 
      ",", "x"}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{"QAInner", "[", 
     RowBox[{"i_Integer", ",", "j_Integer"}], "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"QAInner", "[", 
        RowBox[{
         RowBox[{"Superscript", "[", 
          RowBox[{"\[CapitalPsi]", ",", "i"}], "]"}], ",", 
         RowBox[{"Superscript", "[", 
          RowBox[{"\[CapitalPsi]", ",", "j"}], "]"}], ",", "3", ",", "x"}], 
        "]"}], "//", 
       RowBox[{"QASimplify", "[", "]"}]}], "//", 
      RowBox[{"QAReplaceRepeated", "[", "\"\<Dirac\>\"", "]"}]}], "//", 
     RowBox[{"QASimplify", "[", "]"}]}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7492952560066566`*^9, 3.7492952669793043`*^9}, {
   3.749295303471727*^9, 3.7492954893506002`*^9}, 3.749295573752195*^9, {
   3.7492956058069625`*^9, 3.7492956191273375`*^9}, {3.749295772831094*^9, 
   3.7492957792698708`*^9}, 3.749313048081235*^9, {3.749489112214207*^9, 
   3.7494891139006605`*^9}, {3.767599830833376*^9, 3.767599852900345*^9}, {
   3.7675999300589848`*^9, 3.767599930353166*^9}, {3.767602463744462*^9, 
   3.767602466375424*^9}, 3.767602628359276*^9, {3.7676048277714167`*^9, 
   3.7676048361509924`*^9}, {3.767607972315148*^9, 3.7676079888998623`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dirac Equation QFT", "Section",
 CellChangeTimes->{{3.74972890219599*^9, 3.7497289150515842`*^9}}],

Cell[CellGroupData[{

Cell["Anti Commutation Relations", "Subsection",
 CellChangeTimes->{{3.771251292488694*^9, 3.771251301245674*^9}}],

Cell["\<\
We have no relations here coming from classical ones. We postulate anti \
commutation relations for the coefficients of the plane wave solutions.\
\>", "Text",
 CellChangeTimes->{{3.794066000303119*^9, 3.794066018904422*^9}, 
   3.7940661322445307`*^9, {3.794127858372034*^9, 3.794127927202401*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"anticommutator", "=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"\[CapitalPsi]", "\[CenterDot]", 
      RowBox[{"(", 
       RowBox[{
        OverscriptBox["\[CapitalPsi]", "_"], "/.", 
        RowBox[{"p", "\[Rule]", "p1"}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        OverscriptBox["\[CapitalPsi]", "_"], "/.", 
        RowBox[{"p", "\[Rule]", "p1"}]}], ")"}], "\[CenterDot]", 
      "\[CapitalPsi]"}]}], ")"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.794482084513627*^9, 3.794482111753818*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"anticommutator", "//", "QAEvaluate1"}], "//", "Timing"}]], "Input",
 CellChangeTimes->{{3.771251396742648*^9, 3.771251460031651*^9}, {
  3.7712515070246506`*^9, 3.771251539512683*^9}, {3.771251830368445*^9, 
  3.771251849010454*^9}, {3.771251898209445*^9, 3.7712519165284057`*^9}, {
  3.7944821058625603`*^9, 3.794482132003708*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"418.`", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.7944726297333965`*^9, 3.794545663543782*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hamiltonian", "Subsection",
 CellChangeTimes->{{3.749744483012596*^9, 3.749744486862337*^9}}],

Cell[CellGroupData[{

Cell["Explanation", "Subsubsection",
 CellChangeTimes->{{3.794051021273877*^9, 3.794051024496252*^9}}],

Cell["\<\
We express the Hamiltonian as expression in the field solutions, then \
simplify by invoking the evaluation chain.\
\>", "Text",
 CellChangeTimes->{{3.794051059416866*^9, 3.7940511552088394`*^9}}],

Cell[BoxData[{
 RowBox[{"\[GothicCapitalH]", ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "\[ImaginaryI]"}], " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       OverscriptBox["\[CapitalPsi]", "_"], "//", 
       RowBox[{"QASimplify", "[", "]"}]}], ")"}], "\[CenterDot]", 
     RowBox[{
      UnderoverscriptBox["\[Sum]", 
       RowBox[{"i", "=", "1"}], "3"], 
      RowBox[{"(", 
       RowBox[{
        TemplateBox[{"\[Gamma]","i"},
         "Superscript"], "\[CenterDot]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SubscriptBox["\[GothicCapitalD]", 
            SuperscriptBox["x", "i"]], "\[CapitalPsi]"}], "/.", 
          RowBox[{"p", "\[Rule]", "p1"}]}], ")"}]}], ")"}]}]}]}], "+", 
   RowBox[{"m", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       OverscriptBox["\[CapitalPsi]", "_"], "//", 
       RowBox[{"QASimplify", "[", "]"}]}], ")"}], "\[CenterDot]", 
     RowBox[{"(", 
      RowBox[{"\[CapitalPsi]", "/.", 
       RowBox[{"p", "\[Rule]", "p1"}]}], ")"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"H", ":=", 
  RowBox[{
   SubscriptBox["\[Integral]", "V"], 
   RowBox[{"\[GothicCapitalH]", 
    RowBox[{
     SuperscriptBox["\[DifferentialD]", "3"], "x"}]}]}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7497452226289644`*^9, 3.749745233865909*^9}, 
   3.7498146347275157`*^9, 3.7500636197454596`*^9, {3.7505702683829794`*^9, 
   3.750570277427758*^9}, {3.750589820838624*^9, 3.750589826937315*^9}, 
   3.754917302492875*^9, {3.7674318449021406`*^9, 3.7674318605991554`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"hamiltonian", "=", 
  RowBox[{
   RowBox[{"H", "//", "QAEvaluate2"}], "//", "QATiming"}]}]], "Input",
 CellChangeTimes->{
  3.7497445574993734`*^9, {3.749745704976673*^9, 3.749745709717*^9}, {
   3.749794443298417*^9, 3.7497944590173635`*^9}, {3.749794503597083*^9, 
   3.749794505116049*^9}, {3.74980285043549*^9, 3.7498028613832307`*^9}, {
   3.7498059672944207`*^9, 3.749805970627503*^9}, {3.7498075463677816`*^9, 
   3.7498075486725817`*^9}, 3.749811765546129*^9, {3.749815654543948*^9, 
   3.7498156768203564`*^9}, {3.7498164418426285`*^9, 
   3.7498164552457457`*^9}, {3.7498233134460225`*^9, 3.749823341868991*^9}, {
   3.7498240409858403`*^9, 3.7498240553354783`*^9}, 3.7498258092999043`*^9, 
   3.749829104854369*^9, {3.7499667431736345`*^9, 3.749966746262335*^9}, {
   3.750569911545774*^9, 3.75056991167343*^9}, {3.7505919339821005`*^9, 
   3.7505919343979816`*^9}, {3.7505920547612605`*^9, 3.750592061043455*^9}, 
   3.7507672905534554`*^9, {3.7549367485666475`*^9, 3.7549367487222614`*^9}, {
   3.754989368059873*^9, 3.7549893681905203`*^9}, {3.754997056284988*^9, 
   3.754997056394722*^9}, {3.7550661839205813`*^9, 3.755066184008314*^9}, {
   3.765453982469267*^9, 3.765453984199625*^9}, 3.7949290221653385`*^9, {
   3.7949327544309793`*^9, 3.7949327547441397`*^9}, {3.7949780211169043`*^9, 
   3.794978021416106*^9}, {3.795605767031438*^9, 3.7956057705710087`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"Tue 21 Apr 2020 11:00:56\"\>", ",", "77.90625`"}], "}"}], 
   ",", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     OverscriptBox["1", "^"], " ", 
     RowBox[{
      UnderscriptBox["\[Sum]", "p"], 
      SubscriptBox["p", "0"]}]}], "+", 
    RowBox[{
     UnderscriptBox["\[Sum]", "p"], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SubsuperscriptBox[
          OverscriptBox["c", "^"], 
          RowBox[{
           SubscriptBox["p", "1"], ",", 
           SubscriptBox["p", "2"], ",", 
           SubscriptBox["p", "3"]}], 
          RowBox[{"1", ",", "\[Dagger]"}]], "\[CenterDot]", 
         SubsuperscriptBox[
          OverscriptBox["c", "^"], 
          RowBox[{
           SubscriptBox["p", "1"], ",", 
           SubscriptBox["p", "2"], ",", 
           SubscriptBox["p", "3"]}], "1"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          OverscriptBox["c", "^"], 
          RowBox[{
           SubscriptBox["p", "1"], ",", 
           SubscriptBox["p", "2"], ",", 
           SubscriptBox["p", "3"]}], 
          RowBox[{"2", ",", "\[Dagger]"}]], "\[CenterDot]", 
         SubsuperscriptBox[
          OverscriptBox["c", "^"], 
          RowBox[{
           SubscriptBox["p", "1"], ",", 
           SubscriptBox["p", "2"], ",", 
           SubscriptBox["p", "3"]}], "2"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          OverscriptBox["d", "^"], 
          RowBox[{
           SubscriptBox["p", "1"], ",", 
           SubscriptBox["p", "2"], ",", 
           SubscriptBox["p", "3"]}], 
          RowBox[{"1", ",", "\[Dagger]"}]], "\[CenterDot]", 
         SubsuperscriptBox[
          OverscriptBox["d", "^"], 
          RowBox[{
           SubscriptBox["p", "1"], ",", 
           SubscriptBox["p", "2"], ",", 
           SubscriptBox["p", "3"]}], "1"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          OverscriptBox["d", "^"], 
          RowBox[{
           SubscriptBox["p", "1"], ",", 
           SubscriptBox["p", "2"], ",", 
           SubscriptBox["p", "3"]}], 
          RowBox[{"2", ",", "\[Dagger]"}]], "\[CenterDot]", 
         SubsuperscriptBox[
          OverscriptBox["d", "^"], 
          RowBox[{
           SubscriptBox["p", "1"], ",", 
           SubscriptBox["p", "2"], ",", 
           SubscriptBox["p", "3"]}], "2"]}]}], ")"}], " ", 
      SubscriptBox["p", "0"]}]}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.794934482412098*^9, 3.7949781048264847`*^9, 
  3.795150457728365*^9, 3.7956059131043*^9, 3.796448535804635*^9},
 Background->RGBColor[1, 1, 0.85]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Check Evaluation Chain", "Subsection",
 CellChangeTimes->{{3.767518722947663*^9, 3.76751873148287*^9}}],

Cell["This is no longer required.", "Text",
 CellChangeTimes->{{3.7940511757405453`*^9, 3.794051183932621*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["3-Momentum", "Subsection",
 CellChangeTimes->{{3.7479128009342823`*^9, 3.7479128058242307`*^9}}],

Cell[CellGroupData[{

Cell["Explanation", "Subsubsection",
 CellChangeTimes->{{3.794026157700893*^9, 3.7940262419038305`*^9}}],

Cell["\<\
We express the 3-momentum as expression in the field solutions, then simplify \
by invoking the evaluation chain.\
\>", "Text",
 CellChangeTimes->{{3.794051059416866*^9, 3.7940511552088394`*^9}, {
  3.79405131474679*^9, 3.794051317972168*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[GothicCapitalP]", "[", "i_", "]"}], ":=", 
  RowBox[{"\[ImaginaryI]", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      OverscriptBox["\[CapitalPsi]", "_"], "//", 
      RowBox[{"QASimplify", "[", "]"}]}], ")"}], "\[CenterDot]", 
    RowBox[{"(", 
     RowBox[{
      TemplateBox[{"\[Gamma]","0"},
       "Superscript"], "\[CenterDot]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SubscriptBox["\[GothicCapitalD]", 
          SuperscriptBox["x", "i"]], "\[CapitalPsi]"}], "/.", 
        RowBox[{"p", "\[Rule]", "p1"}]}], ")"}]}], 
     ")"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"P", "[", "i_", "]"}], ":=", 
  RowBox[{
   SubscriptBox["\[Integral]", "V"], 
   RowBox[{
    RowBox[{"\[GothicCapitalP]", "[", "i", "]"}], 
    RowBox[{
     SuperscriptBox["\[DifferentialD]", "3"], "x"}]}]}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7499878149084716`*^9, 3.749987833797942*^9}, {
   3.749987870650363*^9, 3.7499878741160903`*^9}, {3.7499879270407248`*^9, 
   3.74998793504834*^9}, {3.749988008612235*^9, 3.7499880116271873`*^9}, 
   3.7500636206829605`*^9, {3.7505765904360075`*^9, 3.7505765910443788`*^9}, {
   3.7675900321051435`*^9, 3.7675900454763784`*^9}, {3.795607991941223*^9, 
   3.7956080375253706`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"momentum", "=", 
  RowBox[{
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"P", "[", "#", "]"}], "//", "QAEvaluate2"}], ")"}], "&"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "]"}], "//", 
   "QATiming"}]}]], "Input",
 CellChangeTimes->{{3.750590380960963*^9, 3.7505903820400724`*^9}, {
   3.75059288269359*^9, 3.7505928854442616`*^9}, 3.75076730113316*^9, {
   3.7549329685155497`*^9, 3.7549329686222315`*^9}, {3.7549896590213103`*^9, 
   3.754989659230744*^9}, {3.7549904026943073`*^9, 3.754990402867857*^9}, {
   3.7550662042351923`*^9, 3.7550662043199883`*^9}, {3.765454727341099*^9, 
   3.7654547283334365`*^9}, {3.7688249708831015`*^9, 3.768824970955907*^9}, {
   3.768834707665857*^9, 3.7688347077785873`*^9}, {3.7949781489954147`*^9, 
   3.7949781493075795`*^9}, {3.7956079677468987`*^9, 
   3.7956079736680727`*^9}, {3.795608054456112*^9, 3.795608061704735*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"Sat 11 Apr 2020 17:34:27\"\>", ",", "61.59375`"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      UnderscriptBox["\[Sum]", "p"], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox["c", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], 
           RowBox[{"1", ",", "\[Dagger]"}]], "\[CenterDot]", 
          SubsuperscriptBox[
           OverscriptBox["c", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], "1"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox["c", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], 
           RowBox[{"2", ",", "\[Dagger]"}]], "\[CenterDot]", 
          SubsuperscriptBox[
           OverscriptBox["c", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], "2"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox["d", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], 
           RowBox[{"1", ",", "\[Dagger]"}]], "\[CenterDot]", 
          SubsuperscriptBox[
           OverscriptBox["d", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], "1"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox["d", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], 
           RowBox[{"2", ",", "\[Dagger]"}]], "\[CenterDot]", 
          SubsuperscriptBox[
           OverscriptBox["d", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], "2"]}]}], ")"}], " ", 
       SubscriptBox["p", "1"]}]}], ",", 
     RowBox[{
      UnderscriptBox["\[Sum]", "p"], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox["c", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], 
           RowBox[{"1", ",", "\[Dagger]"}]], "\[CenterDot]", 
          SubsuperscriptBox[
           OverscriptBox["c", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], "1"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox["c", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], 
           RowBox[{"2", ",", "\[Dagger]"}]], "\[CenterDot]", 
          SubsuperscriptBox[
           OverscriptBox["c", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], "2"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox["d", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], 
           RowBox[{"1", ",", "\[Dagger]"}]], "\[CenterDot]", 
          SubsuperscriptBox[
           OverscriptBox["d", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], "1"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox["d", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], 
           RowBox[{"2", ",", "\[Dagger]"}]], "\[CenterDot]", 
          SubsuperscriptBox[
           OverscriptBox["d", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], "2"]}]}], ")"}], " ", 
       SubscriptBox["p", "2"]}]}], ",", 
     RowBox[{
      UnderscriptBox["\[Sum]", "p"], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox["c", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], 
           RowBox[{"1", ",", "\[Dagger]"}]], "\[CenterDot]", 
          SubsuperscriptBox[
           OverscriptBox["c", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], "1"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox["c", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], 
           RowBox[{"2", ",", "\[Dagger]"}]], "\[CenterDot]", 
          SubsuperscriptBox[
           OverscriptBox["c", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], "2"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox["d", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], 
           RowBox[{"1", ",", "\[Dagger]"}]], "\[CenterDot]", 
          SubsuperscriptBox[
           OverscriptBox["d", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], "1"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox["d", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], 
           RowBox[{"2", ",", "\[Dagger]"}]], "\[CenterDot]", 
          SubsuperscriptBox[
           OverscriptBox["d", "^"], 
           RowBox[{
            SubscriptBox["p", "1"], ",", 
            SubscriptBox["p", "2"], ",", 
            SubscriptBox["p", "3"]}], "2"]}]}], ")"}], " ", 
       SubscriptBox["p", "3"]}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmVkYGDQAuKUJjfOzg+vHUUqXuas+Pja8ckFaev1QFr6x+ZNIPpY
Wb/NBiBd7/fBFUR7nDFKA9E/OopLQHTLda8GEG2x/pU766fXjrkGhuLLgbRN
6hu+7z9fO97JLs4G0UXT8jV/Aunr4r4cwr9eO7pXuguB6EvLNpWB6CmHv04X
A9Jatb6KFkD64zd3Rk6+N47TXnx6GQqkVyyf1Sct9MZRnvftPBB9evL0expA
msd2cVKWyBvH8I1LVMqAtLng1IkgegUzyxwQraCsFFMNpP8oR6jVAOl9z1ul
9gLppPPOH78A6SecqXITRd84Op169miyyxtHkQUbVDYBaYVLs5/2ur5xXMa3
RJDT7Y3j/O0ulc5AOmqzz9YIIK3b3HprDZDmqswx7XF/4/ghV9MTRAMAmeus
Ng==
  "],
 Background->RGBColor[1, 1, 0.85]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["4 - Current and Continuity Equation", "Subsection",
 CellChangeTimes->{{3.7487030627653775`*^9, 3.7487030806694827`*^9}}],

Cell[CellGroupData[{

Cell["Explanation", "Subsubsection",
 CellChangeTimes->{{3.794026157700893*^9, 3.7940262419038305`*^9}}],

Cell["\<\
We express the 4-current as expression in the field solutions, then simplify \
the charge by invoking the evaluation chain.\
\>", "Text",
 CellChangeTimes->{{3.794051059416866*^9, 3.7940511552088394`*^9}, {
  3.794051334283561*^9, 3.79405135198281*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[GothicCapitalJ]", "[", "i_", "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     OverscriptBox["\[CapitalPsi]", "_"], "//", 
     RowBox[{"QASimplify", "[", "]"}]}], ")"}], "\[CenterDot]", 
   RowBox[{"(", 
    RowBox[{
     TemplateBox[{"\[Gamma]","i"},
      "Superscript"], "\[CenterDot]", 
     RowBox[{"(", 
      RowBox[{"\[CapitalPsi]", "/.", 
       RowBox[{"p", "\[Rule]", "p1"}]}], ")"}]}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"J", "[", "i_", "]"}], ":=", 
  RowBox[{
   SubscriptBox["\[Integral]", "V"], 
   RowBox[{
    RowBox[{"\[GothicCapitalJ]", "[", "i", "]"}], 
    RowBox[{
     SuperscriptBox["\[DifferentialD]", "3"], "x"}]}]}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7499231497045107`*^9, 3.7499231686041083`*^9}, {
   3.749923227093647*^9, 3.749923287142085*^9}, 3.7499235910502615`*^9, {
   3.7499239796710796`*^9, 3.749924007282258*^9}, {3.7505917026856284`*^9, 
   3.750591703038683*^9}, {3.795608163063788*^9, 3.79560820537568*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"charge", "=", 
  RowBox[{
   RowBox[{"QAEvaluate2", "[", 
    RowBox[{"J", "[", "0", "]"}], "]"}], "//", "QATiming"}]}]], "Input",
 CellChangeTimes->{{3.749923473995243*^9, 3.7499234750045147`*^9}, 
   3.7499667527430058`*^9, {3.750591422695462*^9, 3.7505914231123753`*^9}, {
   3.7505927058515773`*^9, 3.7505927084297*^9}, 3.7507673246043825`*^9, {
   3.7549330094370165`*^9, 3.7549330096205254`*^9}, {3.7549898551027317`*^9, 
   3.754989855254306*^9}, {3.7549908073054953`*^9, 3.754990807489003*^9}, {
   3.755066215465141*^9, 3.7550662155678625`*^9}, {3.765454892106325*^9, 
   3.7654548946674724`*^9}, {3.7688248020008974`*^9, 
   3.7688248020996284`*^9}, {3.76883320872785*^9, 3.7688332088545384`*^9}, {
   3.794978237614547*^9, 3.794978237857905*^9}, {3.79560821600427*^9, 
   3.7956082483318844`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"Sat 11 Apr 2020 17:37:31\"\>", ",", "12.734375`"}], "}"}], 
   ",", 
   RowBox[{
    RowBox[{"2", " ", 
     OverscriptBox["1", "^"], " ", 
     RowBox[{
      UnderscriptBox["\[Sum]", "p"], "1"}]}], "+", 
    RowBox[{
     UnderscriptBox["\[Sum]", "p"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubsuperscriptBox[
         OverscriptBox["c", "^"], 
         RowBox[{
          SubscriptBox["p", "1"], ",", 
          SubscriptBox["p", "2"], ",", 
          SubscriptBox["p", "3"]}], 
         RowBox[{"1", ",", "\[Dagger]"}]], "\[CenterDot]", 
        SubsuperscriptBox[
         OverscriptBox["c", "^"], 
         RowBox[{
          SubscriptBox["p", "1"], ",", 
          SubscriptBox["p", "2"], ",", 
          SubscriptBox["p", "3"]}], "1"]}], "+", 
       RowBox[{
        SubsuperscriptBox[
         OverscriptBox["c", "^"], 
         RowBox[{
          SubscriptBox["p", "1"], ",", 
          SubscriptBox["p", "2"], ",", 
          SubscriptBox["p", "3"]}], 
         RowBox[{"2", ",", "\[Dagger]"}]], "\[CenterDot]", 
        SubsuperscriptBox[
         OverscriptBox["c", "^"], 
         RowBox[{
          SubscriptBox["p", "1"], ",", 
          SubscriptBox["p", "2"], ",", 
          SubscriptBox["p", "3"]}], "2"]}], "-", 
       RowBox[{
        SubsuperscriptBox[
         OverscriptBox["d", "^"], 
         RowBox[{
          SubscriptBox["p", "1"], ",", 
          SubscriptBox["p", "2"], ",", 
          SubscriptBox["p", "3"]}], 
         RowBox[{"1", ",", "\[Dagger]"}]], "\[CenterDot]", 
        SubsuperscriptBox[
         OverscriptBox["d", "^"], 
         RowBox[{
          SubscriptBox["p", "1"], ",", 
          SubscriptBox["p", "2"], ",", 
          SubscriptBox["p", "3"]}], "1"]}], "-", 
       RowBox[{
        SubsuperscriptBox[
         OverscriptBox["d", "^"], 
         RowBox[{
          SubscriptBox["p", "1"], ",", 
          SubscriptBox["p", "2"], ",", 
          SubscriptBox["p", "3"]}], 
         RowBox[{"2", ",", "\[Dagger]"}]], "\[CenterDot]", 
        SubsuperscriptBox[
         OverscriptBox["d", "^"], 
         RowBox[{
          SubscriptBox["p", "1"], ",", 
          SubscriptBox["p", "2"], ",", 
          SubscriptBox["p", "3"]}], "2"]}]}], ")"}]}]}]}], "}"}]], "Output",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmVkYGCwA+INzP9DMz+8dhRYxVkEovkVEpaC6IS2Ay11QNosULNy
/cfXjpd9sqeB6KbzvxeAaMffr+U2AOkdH/0DWD+9duQpK7nOB6SLqoqfLQPS
rEW/zb//fO3odK2nD0Tf0royC0R77e/aCaKLGdY/BtEH/Iv+gej/J5llfgDp
mbq3xX4C6Xs3eZWEf712fOsjqA6iq3XFJ4DoOV/CZoPoBcICy0H0lZssu0D0
mo/yT0F0yNMYdxEgfUejNQhET8p9OQ9EhyzkahQF0r9iy1eB6C3b354C0Tlz
TvOLAelV33s0QXSVn789iHaryy4D0X0pza0geoPZXk0LIP3t1D1uTr43jnVe
R3+GAukMrfdLpYXeOKa1SFzSANLp7k/Ts0TeOC7Y76NRBqTzvgWagOjfkp9r
QPQfjh9NIJovMnJWFZBuc/HyqQbSPvaLxGuAdEtkkOpeIF1W3vD9C5AOcd+t
PlH0jWPJTp1Xk13eOD53vue8CUjn/An9mej6xtGiz+h1L5COdigU43R74xjz
JLrZGUj/+mewNwJIyxzouLcGSIcv8I/scX/jCACVzAiB
  "],
 Background->RGBColor[1, 1, 0.85]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Resume Dirac Equation", "Subsection",
 CellChangeTimes->{{3.767590428661327*^9, 3.7675904355568914`*^9}}],

Cell[CellGroupData[{

Cell["Results analogous to Klein-Gordon-Equation", "Item",
 CellChangeTimes->{{3.7675904499733205`*^9, 3.767590459351215*^9}}],

Cell["Hamilton operator contains negative vacuum energy", "Item",
 CellChangeTimes->{{3.7675904504220953`*^9, 3.7675904696327357`*^9}}],

Cell["\<\
Number instead of operator? Reason perhaps matrix multiplication\
\>", "Item",
 CellChangeTimes->{{3.7675904508210287`*^9, 3.767590450822057*^9}, {
  3.767590488543165*^9, 3.7675904936624775`*^9}}],

Cell["\<\
Charge contains \[OpenCurlyDoubleQuote]vacuum share\[CloseCurlyDoubleQuote], \
allowed for validity of divergence equation\
\>", "Item",
 CellChangeTimes->{{3.7675904511681004`*^9, 3.7675904511690965`*^9}, 
   3.7675905104086895`*^9}],

Cell["\<\
3 - Momentum contains numbers, but these result in Null for Momentum Sum \
(Simplification as for Klein - Gordon - Equation)\
\>", "Item",
 CellChangeTimes->{{3.767590451525172*^9, 3.767590451525172*^9}, 
   3.7675905741810966`*^9}],

Cell["long calculation -> optimize!", "Item",
 CellChangeTimes->{3.7675905846630907`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Output of the Dirac Matrices", "Section"]], "Section",
 CellChangeTimes->{{3.7385875454052057`*^9, 3.7385875535095377`*^9}, {
  3.7492118590498886`*^9, 3.7492118674743557`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"printDirac", "[", "]"}]], "Input",
 CellChangeTimes->{{3.7385902891923685`*^9, 3.7385902932136393`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TemplateBox[{"\[Gamma]","0"},
     "Superscript"],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0"},
       {"0", "1", "0", "0"},
       {"0", "0", 
        RowBox[{"-", "1"}], "0"},
       {"0", "0", "0", 
        RowBox[{"-", "1"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm[
   Defer[
    MatrixForm[
     Superscript[QuantumAlgebra`Constants`\[Gamma], 0]]], " = ", 
   MatrixForm[{{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, -1, 0}, {0, 0, 0, -1}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.73859029467072*^9, 3.7385903225242453`*^9}, 
   3.7492103747103586`*^9, 3.7654546259632854`*^9, 3.7674993316140594`*^9, 
   3.7676068812202797`*^9, 3.794117236203756*^9, 3.7956057256240935`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TemplateBox[{"\[Gamma]","1"},
     "Superscript"],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0", "0", "1"},
       {"0", "0", "1", "0"},
       {"0", 
        RowBox[{"-", "1"}], "0", "0"},
       {
        RowBox[{"-", "1"}], "0", "0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm[
   Defer[
    MatrixForm[
     Superscript[QuantumAlgebra`Constants`\[Gamma], 1]]], " = ", 
   MatrixForm[{{0, 0, 0, 1}, {0, 0, 1, 0}, {0, -1, 0, 0}, {-1, 0, 0, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.73859029467072*^9, 3.7385903225242453`*^9}, 
   3.7492103747103586`*^9, 3.7654546259632854`*^9, 3.7674993316140594`*^9, 
   3.7676068812202797`*^9, 3.794117236203756*^9, 3.79560572562908*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TemplateBox[{"\[Gamma]","2"},
     "Superscript"],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0", "0", 
        RowBox[{"-", "\[ImaginaryI]"}]},
       {"0", "0", "\[ImaginaryI]", "0"},
       {"0", "\[ImaginaryI]", "0", "0"},
       {
        RowBox[{"-", "\[ImaginaryI]"}], "0", "0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm[
   Defer[
    MatrixForm[
     Superscript[QuantumAlgebra`Constants`\[Gamma], 2]]], " = ", 
   MatrixForm[{{0, 0, 0, 
      Complex[0, -1]}, {0, 0, 
      Complex[0, 1], 0}, {0, 
      Complex[0, 1], 0, 0}, {
      Complex[0, -1], 0, 0, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.73859029467072*^9, 3.7385903225242453`*^9}, 
   3.7492103747103586`*^9, 3.7654546259632854`*^9, 3.7674993316140594`*^9, 
   3.7676068812202797`*^9, 3.794117236203756*^9, 3.795605725635064*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    TemplateBox[{"\[Gamma]","3"},
     "Superscript"],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], "\[InvisibleSpace]", "\<\" = \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0", "1", "0"},
       {"0", "0", "0", 
        RowBox[{"-", "1"}]},
       {
        RowBox[{"-", "1"}], "0", "0", "0"},
       {"0", "1", "0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm[
   Defer[
    MatrixForm[
     Superscript[QuantumAlgebra`Constants`\[Gamma], 3]]], " = ", 
   MatrixForm[{{0, 0, 1, 0}, {0, 0, 0, -1}, {-1, 0, 0, 0}, {0, 1, 0, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.73859029467072*^9, 3.7385903225242453`*^9}, 
   3.7492103747103586`*^9, 3.7654546259632854`*^9, 3.7674993316140594`*^9, 
   3.7676068812202797`*^9, 3.794117236203756*^9, 3.7956057256410475`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.73859029467072*^9, 3.7385903225242453`*^9}, 
   3.7492103747103586`*^9, 3.7654546259632854`*^9, 3.7674993316140594`*^9, 
   3.7676068812202797`*^9, 3.794117236203756*^9, 3.79560572564404*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Eigen Solutions for the Dirac Equation (RQM)", "Section",
 CellChangeTimes->{{3.7385922862863665`*^9, 3.7385923025957212`*^9}, {
  3.7492110167712216`*^9, 3.7492110375945177`*^9}, {3.7492124524016953`*^9, 
  3.749212455272046*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Conjugate", "[", 
     RowBox[{
      SubscriptBox["\[GothicU]", "1"], "/.", 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["p", "i_"], ":>", 
        RowBox[{
         RowBox[{"-", 
          SubscriptBox["p", "i"]}], "/;", 
         RowBox[{"1", "\[LessEqual]", "i", "\[LessEqual]", "3"}]}]}], ")"}]}],
      "]"}], ".", 
    SubscriptBox["\[GothicV]", "1"]}], ")"}], "//", 
  RowBox[{"QASimplify", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.749224236933815*^9, 3.749224279670498*^9}, {
   3.749224362514331*^9, 3.749224371307809*^9}, {3.749225006858358*^9, 
   3.749225086088415*^9}, {3.7492251204534874`*^9, 3.749225168041192*^9}, {
   3.7675908775597615`*^9, 3.7675909257475*^9}, 3.7675910372472887`*^9, {
   3.7675995921002398`*^9, 3.767599679217279*^9}, {3.767601847913294*^9, 
   3.767601858746289*^9}, {3.7676019031248093`*^9, 3.7676019084046707`*^9}, {
   3.767601950455221*^9, 3.7676019751531982`*^9}, {3.7676020053494368`*^9, 
   3.7676020115109577`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.7492251217639804`*^9, 3.7492251694613886`*^9}, {
   3.7675909153466663`*^9, 3.7675909272913723`*^9}, 3.767591039552122*^9, {
   3.7675996568450766`*^9, 3.767599681722584*^9}, 3.7676018633869047`*^9, 
   3.76760191092595*^9, {3.7676019560552235`*^9, 3.7676019763818913`*^9}, 
   3.7676020125860605`*^9, 3.7688170376009727`*^9, 3.794117241734969*^9, 
   3.7941189332849083`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"QAInner", "[", 
       RowBox[{"i", ",", "j"}], "]"}], "//", 
      RowBox[{"QAReplaceRepeated", "[", "\"\<DiracEquation\>\"", "]"}]}], "//", 
     RowBox[{"QASimplify", "[", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "4"}], "}"}]}], "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.7492972002727733`*^9, 3.7492972429351315`*^9}, {
  3.7941183912292347`*^9, 3.794118397593184*^9}, {3.7941184321617804`*^9, 
  3.7941184550256615`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       RowBox[{"V", " ", 
        OverscriptBox["1", "^"], " ", 
        SubscriptBox["p", "0"]}], "m"], "0", "0", "0"},
     {"0", 
      FractionBox[
       RowBox[{"V", " ", 
        OverscriptBox["1", "^"], " ", 
        SubscriptBox["p", "0"]}], "m"], "0", "0"},
     {"0", "0", 
      FractionBox[
       RowBox[{"V", " ", 
        OverscriptBox["1", "^"], " ", 
        SubscriptBox["p", "0"]}], "m"], "0"},
     {"0", "0", "0", 
      FractionBox[
       RowBox[{"V", " ", 
        OverscriptBox["1", "^"], " ", 
        SubscriptBox["p", "0"]}], "m"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.7492972748936415`*^9, 3.749297448488897*^9, 
  3.749300692630598*^9, 3.7493007980093856`*^9, 3.7494890346117563`*^9, 
  3.749489146910355*^9, 3.767599809043643*^9, 3.7675998425958776`*^9, 
  3.767599907095388*^9, 3.767599978764686*^9, 3.767602528275896*^9, 
  3.7676029025529165`*^9, 3.7676048859777*^9, 3.7676066059136105`*^9, 
  3.767606958801813*^9, 3.767607460420234*^9, 3.7688170893514557`*^9, 
  3.794117374347475*^9, 3.794118516195155*^9, 3.7941189158754473`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dirac Equation", "Section",
 CellChangeTimes->{{3.749375194527919*^9, 3.7493751986009874`*^9}}],

Cell[CellGroupData[{

Cell["The Dirac Equation as an Operator", "Subsection",
 CellChangeTimes->{{3.7688171937227073`*^9, 3.768817210324294*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "Definition", " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{"DiracOperator", "[", "]"}], ":=", 
   RowBox[{
    RowBox[{"\[ImaginaryI]", " ", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Superscript", "[", 
          RowBox[{"\[Gamma]", ",", "i"}], "]"}], "\[CircleDot]", 
         RowBox[{"QAD", "[", 
          SuperscriptBox["x", "i"], "]"}]}], ")"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "3"}], "}"}]}], "]"}]}], "-", 
    RowBox[{"m", " ", 
     RowBox[{"IdentityMatrix", "[", "4", "]"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.7688174851669865`*^9, 3.7688175044135227`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Matrix", " ", "Form"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DiracOperator", "[", "]"}], "//", "MatrixForm"}]}]], "Input",
 CellChangeTimes->{{3.749379407655079*^9, 3.749379410749793*^9}, {
  3.768817509658491*^9, 3.7688175192239027`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "m"}], "+", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"1", "\[CircleDot]", 
         RowBox[{"QAD", "[", 
          SuperscriptBox["x", "0"], "]"}]}]}]}], "0", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"1", "\[CircleDot]", 
        RowBox[{"QAD", "[", 
         SuperscriptBox["x", "3"], "]"}]}]}], 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "\[ImaginaryI]"}], ")"}], "\[CircleDot]", 
          RowBox[{"QAD", "[", 
           SuperscriptBox["x", "2"], "]"}]}], "+", 
         RowBox[{"1", "\[CircleDot]", 
          RowBox[{"QAD", "[", 
           SuperscriptBox["x", "1"], "]"}]}]}], ")"}]}]},
     {"0", 
      RowBox[{
       RowBox[{"-", "m"}], "+", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"1", "\[CircleDot]", 
         RowBox[{"QAD", "[", 
          SuperscriptBox["x", "0"], "]"}]}]}]}], 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[ImaginaryI]", "\[CircleDot]", 
          RowBox[{"QAD", "[", 
           SuperscriptBox["x", "2"], "]"}]}], "+", 
         RowBox[{"1", "\[CircleDot]", 
          RowBox[{"QAD", "[", 
           SuperscriptBox["x", "1"], "]"}]}]}], ")"}]}], 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "\[CircleDot]", 
        RowBox[{"QAD", "[", 
         SuperscriptBox["x", "3"], "]"}]}]}]},
     {
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "\[CircleDot]", 
        RowBox[{"QAD", "[", 
         SuperscriptBox["x", "3"], "]"}]}]}], 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "\[CircleDot]", 
          RowBox[{"QAD", "[", 
           SuperscriptBox["x", "1"], "]"}]}], "+", 
         RowBox[{"\[ImaginaryI]", "\[CircleDot]", 
          RowBox[{"QAD", "[", 
           SuperscriptBox["x", "2"], "]"}]}]}], ")"}]}], 
      RowBox[{
       RowBox[{"-", "m"}], "+", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}], "\[CircleDot]", 
         RowBox[{"QAD", "[", 
          SuperscriptBox["x", "0"], "]"}]}]}]}], "0"},
     {
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "\[CircleDot]", 
          RowBox[{"QAD", "[", 
           SuperscriptBox["x", "1"], "]"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "\[ImaginaryI]"}], ")"}], "\[CircleDot]", 
          RowBox[{"QAD", "[", 
           SuperscriptBox["x", "2"], "]"}]}]}], ")"}]}], 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"1", "\[CircleDot]", 
        RowBox[{"QAD", "[", 
         SuperscriptBox["x", "3"], "]"}]}]}], "0", 
      RowBox[{
       RowBox[{"-", "m"}], "+", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}], "\[CircleDot]", 
         RowBox[{"QAD", "[", 
          SuperscriptBox["x", "0"], "]"}]}]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.7493794117770348`*^9, 3.749380023871893*^9, 
  3.749488855752564*^9, 3.749488931168824*^9, 3.768816868964091*^9, 
  3.768817435776284*^9, 3.7941177600723743`*^9, 3.7941189676320972`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Application", " ", "of", " ", "the", " ", "Operator", " ", "on", " ", 
    "Eigen", " ", "Solution"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"DiracOperator", "[", "]"}], "\[CircleTimes]", 
      TemplateBox[{"\[CapitalPsi]","2"},
       "Superscript"]}], "//", 
     RowBox[{"QASimplify", "[", "]"}]}], "//", 
    RowBox[{"QAReplaceRepeated", "[", "\"\<DiracEquation\>\"", "]"}]}], "//", 
   RowBox[{"QASimplify", "[", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.74937543665425*^9, 3.7493754747682557`*^9}, 
   3.7493772861164455`*^9, {3.7493773538452997`*^9, 3.749377356451297*^9}, {
   3.7493778572994018`*^9, 3.7493778773607073`*^9}, {3.7493779728203793`*^9, 
   3.7493779776115522`*^9}, {3.7493786062263536`*^9, 
   3.7493786111921005`*^9}, {3.7493874371252766`*^9, 3.7493874398440046`*^9}, 
   3.7493875464534535`*^9, 3.7494886020332985`*^9, {3.749488975430425*^9, 
   3.74948897766049*^9}, {3.768816926983887*^9, 3.768816940772957*^9}, {
   3.768817254175022*^9, 3.7688172558694506`*^9}, {3.768817451985792*^9, 
   3.768817452833525*^9}, {3.7688175309156227`*^9, 3.7688175603797984`*^9}, {
   3.7941182185827093`*^9, 3.7941182205155797`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.749375485907457*^9, 3.7493755621144004`*^9, 3.749377185556444*^9, 
   3.749377287712203*^9, 3.749377357406741*^9, 3.749377784311613*^9, 
   3.7493778789743867`*^9, 3.7493779872936583`*^9, 3.7493784969846044`*^9, 
   3.7493786142887836`*^9, 3.749379267060605*^9, 3.7493873932236753`*^9, 
   3.7493874444536343`*^9, 3.749387563080003*^9, 3.7494885929077206`*^9, 
   3.749488850020897*^9, {3.74948896331583*^9, 3.7494889929560375`*^9}, 
   3.7688169512858315`*^9, 3.768817262803898*^9, 3.768817460236679*^9, 
   3.794117826542689*^9, 3.79411824567031*^9, 3.794118984876996*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell["Analysis of Evaluation", "Section",
 CellChangeTimes->{{3.7944820450259*^9, 3.79448205253885*^9}}],

Cell["Tests", "Section",
 CellChangeTimes->{{3.79447705739859*^9, 3.794477058216441*^9}}]
}, Open  ]]
},
WindowSize->{889, 882},
WindowMargins->{{375, Automatic}, {86, Automatic}},
InputAliases->{"com" -> SubscriptBox[
    RowBox[{"[", "\[SelectionPlaceholder]", "]"}], "-"], "op" -> 
  OverscriptBox["\[SelectionPlaceholder]", "^"], "opd" -> SubscriptBox[
    OverscriptBox["\[SelectionPlaceholder]", "^"], "\[SelectionPlaceholder]"],
   "opu" -> SuperscriptBox[
    OverscriptBox["\[SelectionPlaceholder]", "^"], "\[SelectionPlaceholder]"],
   "opdu" -> SubsuperscriptBox[
    OverscriptBox["\[SelectionPlaceholder]", "^"], "\[SelectionPlaceholder]", 
    "\[SelectionPlaceholder]"], "hop" -> SuperscriptBox[
    OverscriptBox["\[SelectionPlaceholder]", "^"], "\[Dagger]"], "hopd" -> 
  SubsuperscriptBox[
    OverscriptBox["\[SelectionPlaceholder]", "^"], "\[SelectionPlaceholder]", 
    "\[Dagger]"], "hopu" -> SuperscriptBox[
    OverscriptBox["\[SelectionPlaceholder]", "^"], 
    RowBox[{"\[SelectionPlaceholder]", ",", "\[Dagger]"}]], "hopdu" -> 
  SubsuperscriptBox[
    OverscriptBox["\[SelectionPlaceholder]", "^"], "\[SelectionPlaceholder]", 
    RowBox[{"\[SelectionPlaceholder]", ",", "\[Dagger]"}]], "ket" -> TagBox[
    RowBox[{
      AdjustmentBox[
      "\[VerticalSeparator]", BoxMargins -> {{-0.4, 0.}, {0, 0}}], 
      AdjustmentBox[
       TagBox[
       "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
        BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
      "\[RightAngleBracket]"}], QuantumAlgebra`Ket, BaseStyle -> 
    "KetWrapper"], "ketd" -> TagBox[
    SubscriptBox[
     RowBox[{
       AdjustmentBox[
       "\[VerticalSeparator]", BoxMargins -> {{-0.4, 0.}, {0, 0}}], 
       AdjustmentBox[
        TagBox[
        "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
         BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
       "\[RightAngleBracket]"}], 
     TagBox[
      AdjustmentBox[
       TagBox[
       "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
        BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
      QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]], 
    QuantumAlgebra`Ket, BaseStyle -> "KetWrapper"], "ketu" -> TagBox[
    SuperscriptBox[
     RowBox[{
       AdjustmentBox[
       "\[VerticalSeparator]", BoxMargins -> {{-0.4, 0.}, {0, 0}}], 
       AdjustmentBox[
        TagBox[
        "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
         BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
       "\[RightAngleBracket]"}], 
     TagBox[
      AdjustmentBox[
       TagBox[
       "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
        BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
      QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]], 
    QuantumAlgebra`Ket, BaseStyle -> "KetWrapper"], "ketdu" -> TagBox[
    SubsuperscriptBox[
     RowBox[{
       AdjustmentBox[
       "\[VerticalSeparator]", BoxMargins -> {{-0.4, 0.}, {0, 0}}], 
       AdjustmentBox[
        TagBox[
        "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
         BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
       "\[RightAngleBracket]"}], 
     TagBox[
      AdjustmentBox[
       TagBox[
       "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
        BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
      QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"], 
     TagBox[
      AdjustmentBox[
       TagBox[
       "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
        BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
      QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]], 
    QuantumAlgebra`Ket, BaseStyle -> "KetWrapper"], "bra" -> TagBox[
    RowBox[{"\[LeftAngleBracket]", 
      AdjustmentBox[
       TagBox[
       "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
        BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
      AdjustmentBox[
      "\[VerticalSeparator]", BoxMargins -> {{0., -0.2}, {0, 0}}]}], 
    QuantumAlgebra`Bra, BaseStyle -> "BraWrapper"], "dbra" -> TagBox[
    RowBox[{
      SubscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      RowBox[{"\[LeftAngleBracket]", 
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        AdjustmentBox[
        "\[VerticalSeparator]", BoxMargins -> {{0., -0.2}, {0, 0}}]}]}], 
    QuantumAlgebra`Bra, BaseStyle -> "BraWrapper"], "ubra" -> TagBox[
    RowBox[{
      SuperscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      RowBox[{"\[LeftAngleBracket]", 
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        AdjustmentBox[
        "\[VerticalSeparator]", BoxMargins -> {{0., -0.2}, {0, 0}}]}]}], 
    QuantumAlgebra`Bra, BaseStyle -> "BraWrapper"], "dubra" -> TagBox[
    RowBox[{
      SubsuperscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      RowBox[{"\[LeftAngleBracket]", 
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        AdjustmentBox[
        "\[VerticalSeparator]", BoxMargins -> {{0., -0.2}, {0, 0}}]}]}], 
    QuantumAlgebra`Bra, BaseStyle -> "BraWrapper"], "braket" -> TagBox[
    RowBox[{"\[LeftAngleBracket]", 
      AdjustmentBox[
       RowBox[{
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraKetArgs,
           BaseStyle -> "BraKetArg"], "\[VerticalSeparator]", 
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraKetArgs,
           BaseStyle -> "BraKetArg"]}], BoxBaselineShift -> 0], 
      "\[RightAngleBracket]"}], QuantumAlgebra`BraKet, BaseStyle -> 
    "BraKetWrapper"], "braketd" -> TagBox[
    SubscriptBox[
     RowBox[{"\[LeftAngleBracket]", 
       AdjustmentBox[
        RowBox[{
          TagBox[
          "\[SelectionPlaceholder]", 
           QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
           "BraKetArg"], "\[VerticalSeparator]", 
          TagBox[
          "\[SelectionPlaceholder]", 
           QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
           "BraKetArg"]}], BoxBaselineShift -> 0], "\[RightAngleBracket]"}], 
     TagBox[
      AdjustmentBox[
       TagBox[
       "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
        BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
      QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]], 
    QuantumAlgebra`BraKet, BaseStyle -> "BraKetWrapper"], "braketu" -> TagBox[
    SuperscriptBox[
     RowBox[{"\[LeftAngleBracket]", 
       AdjustmentBox[
        RowBox[{
          TagBox[
          "\[SelectionPlaceholder]", 
           QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
           "BraKetArg"], "\[VerticalSeparator]", 
          TagBox[
          "\[SelectionPlaceholder]", 
           QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
           "BraKetArg"]}], BoxBaselineShift -> 0], "\[RightAngleBracket]"}], 
     TagBox[
      AdjustmentBox[
       TagBox[
       "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
        BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
      QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]], 
    QuantumAlgebra`BraKet, BaseStyle -> "BraKetWrapper"], "braketdu" -> TagBox[
    SubsuperscriptBox[
     RowBox[{"\[LeftAngleBracket]", 
       AdjustmentBox[
        RowBox[{
          TagBox[
          "\[SelectionPlaceholder]", 
           QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
           "BraKetArg"], "\[VerticalSeparator]", 
          TagBox[
          "\[SelectionPlaceholder]", 
           QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
           "BraKetArg"]}], BoxBaselineShift -> 0], "\[RightAngleBracket]"}], 
     TagBox[
      AdjustmentBox[
       TagBox[
       "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
        BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
      QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"], 
     TagBox[
      AdjustmentBox[
       TagBox[
       "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
        BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
      QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]], 
    QuantumAlgebra`BraKet, BaseStyle -> "BraKetWrapper"], "dbraket" -> TagBox[
    RowBox[{
      SubscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      RowBox[{"\[LeftAngleBracket]", 
        AdjustmentBox[
         RowBox[{
           TagBox[
           "\[SelectionPlaceholder]", 
            QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
            "BraKetArg"], "\[VerticalSeparator]", 
           TagBox[
           "\[SelectionPlaceholder]", 
            QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
            "BraKetArg"]}], BoxBaselineShift -> 0], 
        "\[RightAngleBracket]"}]}], QuantumAlgebra`BraKet, BaseStyle -> 
    "BraKetWrapper"], "ubraket" -> TagBox[
    RowBox[{
      SuperscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      RowBox[{"\[LeftAngleBracket]", 
        AdjustmentBox[
         RowBox[{
           TagBox[
           "\[SelectionPlaceholder]", 
            QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
            "BraKetArg"], "\[VerticalSeparator]", 
           TagBox[
           "\[SelectionPlaceholder]", 
            QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
            "BraKetArg"]}], BoxBaselineShift -> 0], 
        "\[RightAngleBracket]"}]}], QuantumAlgebra`BraKet, BaseStyle -> 
    "BraKetWrapper"], "dubraket" -> TagBox[
    RowBox[{
      SubsuperscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      RowBox[{"\[LeftAngleBracket]", 
        AdjustmentBox[
         RowBox[{
           TagBox[
           "\[SelectionPlaceholder]", 
            QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
            "BraKetArg"], "\[VerticalSeparator]", 
           TagBox[
           "\[SelectionPlaceholder]", 
            QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
            "BraKetArg"]}], BoxBaselineShift -> 0], 
        "\[RightAngleBracket]"}]}], QuantumAlgebra`BraKet, BaseStyle -> 
    "BraKetWrapper"], "dbraketd" -> TagBox[
    RowBox[{
      SubscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      SubscriptBox[
       RowBox[{"\[LeftAngleBracket]", 
         AdjustmentBox[
          RowBox[{
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"], "\[VerticalSeparator]", 
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"]}], BoxBaselineShift -> 0], "\[RightAngleBracket]"}], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]]}], 
    QuantumAlgebra`BraKet, BaseStyle -> "BraKetWrapper"], "dbraketu" -> TagBox[
    RowBox[{
      SubscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      SuperscriptBox[
       RowBox[{"\[LeftAngleBracket]", 
         AdjustmentBox[
          RowBox[{
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"], "\[VerticalSeparator]", 
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"]}], BoxBaselineShift -> 0], "\[RightAngleBracket]"}], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]]}], 
    QuantumAlgebra`BraKet, BaseStyle -> "BraKetWrapper"], "dbraketdu" -> 
  TagBox[
    RowBox[{
      SubscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      SubsuperscriptBox[
       RowBox[{"\[LeftAngleBracket]", 
         AdjustmentBox[
          RowBox[{
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"], "\[VerticalSeparator]", 
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"]}], BoxBaselineShift -> 0], "\[RightAngleBracket]"}], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]]}], 
    QuantumAlgebra`BraKet, BaseStyle -> "BraKetWrapper"], "ubraketd" -> TagBox[
    RowBox[{
      SuperscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      SubscriptBox[
       RowBox[{"\[LeftAngleBracket]", 
         AdjustmentBox[
          RowBox[{
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"], "\[VerticalSeparator]", 
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"]}], BoxBaselineShift -> 0], "\[RightAngleBracket]"}], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]]}], 
    QuantumAlgebra`BraKet, BaseStyle -> "BraKetWrapper"], "ubraketu" -> TagBox[
    RowBox[{
      SuperscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      SuperscriptBox[
       RowBox[{"\[LeftAngleBracket]", 
         AdjustmentBox[
          RowBox[{
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"], "\[VerticalSeparator]", 
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"]}], BoxBaselineShift -> 0], "\[RightAngleBracket]"}], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]]}], 
    QuantumAlgebra`BraKet, BaseStyle -> "BraKetWrapper"], "ubraketdu" -> 
  TagBox[
    RowBox[{
      SuperscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      SubsuperscriptBox[
       RowBox[{"\[LeftAngleBracket]", 
         AdjustmentBox[
          RowBox[{
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"], "\[VerticalSeparator]", 
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"]}], BoxBaselineShift -> 0], "\[RightAngleBracket]"}], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]]}], 
    QuantumAlgebra`BraKet, BaseStyle -> "BraKetWrapper"], "dubraketd" -> 
  TagBox[
    RowBox[{
      SubsuperscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      SubscriptBox[
       RowBox[{"\[LeftAngleBracket]", 
         AdjustmentBox[
          RowBox[{
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"], "\[VerticalSeparator]", 
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"]}], BoxBaselineShift -> 0], "\[RightAngleBracket]"}], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]]}], 
    QuantumAlgebra`BraKet, BaseStyle -> "BraKetWrapper"], "dubraketu" -> 
  TagBox[
    RowBox[{
      SubsuperscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      SuperscriptBox[
       RowBox[{"\[LeftAngleBracket]", 
         AdjustmentBox[
          RowBox[{
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"], "\[VerticalSeparator]", 
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"]}], BoxBaselineShift -> 0], "\[RightAngleBracket]"}], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]]}], 
    QuantumAlgebra`BraKet, BaseStyle -> "BraKetWrapper"], "dubraketdu" -> 
  TagBox[
    RowBox[{
      SubsuperscriptBox["\[InvisiblePrefixScriptBase]", 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`BraArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "LIndex"]], 
      SubsuperscriptBox[
       RowBox[{"\[LeftAngleBracket]", 
         AdjustmentBox[
          RowBox[{
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"], "\[VerticalSeparator]", 
            TagBox[
            "\[SelectionPlaceholder]", 
             QuantumAlgebra`QuantumNotation`BraKetArgs, BaseStyle -> 
             "BraKetArg"]}], BoxBaselineShift -> 0], "\[RightAngleBracket]"}], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"], 
       TagBox[
        AdjustmentBox[
         TagBox[
         "\[SelectionPlaceholder]", QuantumAlgebra`QuantumNotation`KetArgs, 
          BaseStyle -> "BraKetArg"], BoxBaselineShift -> 0], 
        QuantumAlgebra`QuantumNotation`UDScript, BaseStyle -> "RIndex"]]}], 
    QuantumAlgebra`BraKet, BaseStyle -> "BraKetWrapper"], "sd" -> 
  SubscriptBox["\[Placeholder]", "\[Placeholder]"], "su" -> 
  SuperscriptBox["\[Placeholder]", "\[Placeholder]"], "sdu" -> 
  SubsuperscriptBox[
   "\[SelectionPlaceholder]", "\[SelectionPlaceholder]", 
    "\[SelectionPlaceholder]"]},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}]}, Visible -> False, FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> 
  FrontEnd`FileName[{$RootDirectory, "C:", "Program Files", "Work", 
     "Wolfram Research", "Mathematica", "11.0", "SystemFiles", "FrontEnd", 
     "StyleSheets"}, "PrivateStylesheetFormatting.nb", CharacterEncoding -> 
    "UTF-8"]]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 101, 1, 101, "Title"],
Cell[CellGroupData[{
Cell[706, 27, 150, 2, 70, "Section"],
Cell[CellGroupData[{
Cell[881, 33, 256, 5, 46, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1162, 42, 1639, 27, 22, "Print"],
Cell[2804, 71, 1653, 28, 22, "Print"],
Cell[4460, 101, 1658, 28, 22, "Print"],
Cell[6121, 131, 1660, 28, 22, "Print"],
Cell[7784, 161, 2079, 33, 149, "Print"]
}, Open  ]]
}, Open  ]],
Cell[9890, 198, 266, 5, 30, "Input"],
Cell[CellGroupData[{
Cell[10181, 207, 95, 1, 49, "Subsection"],
Cell[10279, 210, 10235, 233, 730, "Input",
 InitializationCell->True],
Cell[20517, 445, 847, 24, 70, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[21401, 474, 94, 1, 49, "Subsection"],
Cell[21498, 477, 913, 23, 71, "Input",
 InitializationCell->True],
Cell[22414, 502, 4038, 108, 275, "Input",
 InitializationCell->True],
Cell[26455, 612, 3181, 80, 180, "Input",
 InitializationCell->True],
Cell[29639, 694, 1785, 46, 123, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[31461, 745, 106, 1, 49, "Subsection"],
Cell[31570, 748, 6784, 137, 465, "Input",
 InitializationCell->True],
Cell[38357, 887, 1813, 41, 126, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40207, 933, 108, 1, 49, "Subsection"],
Cell[40318, 936, 1528, 41, 161, "Input",
 InitializationCell->True],
Cell[41849, 979, 1690, 38, 123, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[43588, 1023, 104, 1, 70, "Section"],
Cell[CellGroupData[{
Cell[43717, 1028, 114, 1, 49, "Subsection"],
Cell[43834, 1031, 309, 5, 49, "Text"],
Cell[44146, 1038, 566, 16, 34, "Input"],
Cell[CellGroupData[{
Cell[44737, 1058, 367, 6, 30, "Input"],
Cell[45107, 1066, 143, 3, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[45299, 1075, 99, 1, 49, "Subsection"],
Cell[CellGroupData[{
Cell[45423, 1080, 102, 1, 39, "Subsubsection"],
Cell[45528, 1083, 206, 4, 30, "Text"],
Cell[45737, 1089, 1559, 42, 117, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[47321, 1135, 1405, 21, 30, "Input"],
Cell[48729, 1158, 2646, 77, 99, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[51436, 1242, 109, 1, 49, "Subsection"],
Cell[51548, 1245, 111, 1, 30, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51696, 1251, 102, 1, 49, "Subsection"],
Cell[CellGroupData[{
Cell[51823, 1256, 104, 1, 39, "Subsubsection"],
Cell[51930, 1259, 253, 5, 30, "Text"],
Cell[52186, 1266, 1310, 34, 89, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[53521, 1304, 991, 21, 30, "Input"],
Cell[54515, 1327, 7301, 204, 187, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[61877, 1538, 127, 1, 49, "Subsection"],
Cell[CellGroupData[{
Cell[62029, 1543, 104, 1, 39, "Subsubsection"],
Cell[62136, 1546, 263, 5, 30, "Text"],
Cell[62402, 1553, 1051, 28, 90, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[63478, 1585, 832, 14, 30, "Input"],
Cell[64313, 1601, 2994, 83, 99, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[67368, 1691, 111, 1, 49, "Subsection"],
Cell[CellGroupData[{
Cell[67504, 1696, 126, 1, 29, "Item"],
Cell[67633, 1699, 135, 1, 29, "Item"],
Cell[67771, 1702, 207, 4, 29, "Item"],
Cell[67981, 1708, 244, 5, 29, "Item"],
Cell[68228, 1715, 242, 5, 45, "Item"],
Cell[68473, 1722, 89, 1, 29, "Item"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[68623, 1730, 201, 2, 70, "Section"],
Cell[CellGroupData[{
Cell[68849, 1736, 128, 2, 30, "Input"],
Cell[CellGroupData[{
Cell[69002, 1742, 1383, 38, 65, "Print"],
Cell[70388, 1782, 1380, 38, 65, "Print"],
Cell[71771, 1822, 1505, 42, 69, "Print"],
Cell[73279, 1866, 1383, 38, 65, "Print"],
Cell[74665, 1906, 248, 3, 22, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[74974, 1916, 237, 3, 70, "Section"],
Cell[CellGroupData[{
Cell[75236, 1923, 1046, 24, 33, "Input"],
Cell[76285, 1949, 427, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76749, 1960, 623, 16, 50, "Input"],
Cell[77375, 1978, 1631, 42, 140, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[79055, 2026, 101, 1, 70, "Section"],
Cell[CellGroupData[{
Cell[79181, 2031, 123, 1, 49, "Subsection"],
Cell[79307, 2034, 701, 19, 55, "Input"],
Cell[CellGroupData[{
Cell[80033, 2057, 320, 7, 50, "Input"],
Cell[80356, 2066, 4023, 114, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[84416, 2185, 1272, 25, 50, "Input"],
Cell[85691, 2212, 692, 11, 30, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[86422, 2228, 104, 1, 70, "Section"],
Cell[86529, 2231, 89, 1, 56, "Section"]
}, Open  ]]
}
]
*)

