(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     11136,        297]
NotebookOptionsPosition[      6868,        196]
NotebookOutlinePosition[     10689,        281]
CellTagsIndexPosition[     10646,        278]
WindowTitle->Input Aliases
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA GUIDE", "PacletNameCell"], Cell[TextData[Cell[
    BoxData[
     ActionMenuBox[
      FrameBox[
       InterpretationBox[Cell[TextData[{
         "URL",
         StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
          StripOnInput->False]
        }]],
        TextCell[
         Row[{"URL", 
           Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
       StripOnInput->False], {"\<\"QuantumAlgebra/guide/InputAliases\"\>":>
      None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["QuantumAlgebra/guide/InputAliases"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/language/QuantumAlgebra/guide/\
InputAliases.html"], StandardForm]], "Input", TextClipboardType -> 
             "PlainText"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
            If[
             TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$5552], 
             "http://reference.wolfram.com/system-modeler/", 
             "http://reference.wolfram.com/language/"], 
            "QuantumAlgebra/guide/InputAliases", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic,
      MenuStyle->"URLMenu"]],
     LineSpacing->{1.4, 0}]], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Input Aliases", "GuideTitle",
 CellID->942062912],

Cell["\<\
The purpose of this page is to provide an overview about the input aliases \
which can be used in Quantum Algebra notebooks.
The aliases are given in a table with columns for Alias, Prefix, Postfix, \
Meaning. This is because most aliases can be combined with Prefix(es) and \
Postfix(es).\
\>", "GuideAbstract",
 CellID->2001916300]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Reference"
}], "GuideReferenceSection",
 WholeCellGroupOpener->True],

Cell["", "SectionHeaderSpacer"],

Cell[CellGroupData[{

Cell["Input Aliases Table", "GuideFunctionsSubsection",
 CellID->78434960],

Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["Alias", "GuideText"], 
     StyleBox["Prefix", "GuideText"], 
     StyleBox["Postfix", "GuideText"], "Meaning"},
    {"com", "-", "-", 
     StyleBox[
      RowBox[{"For", " ", "commutator", " ", "notation"}],
      FontWeight->"Plain"]},
    {"op", "h", "du", 
     StyleBox[
      RowBox[{
       RowBox[{"For", " ", "Operator", " ", "notation"}], ",", " ", 
       RowBox[{
       "h", " ", "signifies", " ", "a", " ", "Hermitian", " ", "operator"}], 
       ",", " ", 
       RowBox[{
       "d", " ", "a", " ", "lower", " ", "index", " ", "and", " ", "u", " ", 
        "an", " ", "upper", " ", "index", " ", "on", " ", "the", " ", "right",
         " ", "side"}]}],
      FontWeight->"Plain"]},
    {"ket", "-", "du", 
     StyleBox[
      RowBox[{
       RowBox[{"For", " ", "Ket", " ", "symbol", " ", "notation"}], ",", " ", 
       
       RowBox[{
       "d", " ", "signifies", " ", "a", " ", "lower", " ", "index", " ", 
        "and", " ", "u", " ", "an", " ", "upper", " ", "index", " ", "at", 
        " ", "the", " ", "right", " ", "side"}]}],
      FontWeight->"Plain"]},
    {"bra", "du", "-", 
     StyleBox[
      RowBox[{
       RowBox[{"For", " ", "Bra", " ", "symbol", " ", "notation"}], ",", " ", 
       
       RowBox[{
       "d", " ", "signifies", " ", "a", " ", "lower", " ", "index", " ", 
        "and", " ", "u", " ", "an", " ", "upper", " ", "index", " ", "at", 
        " ", "the", " ", "left", " ", "side"}]}],
      FontWeight->"Plain"]},
    {"braket", "du", "du", 
     StyleBox[
      RowBox[{
       RowBox[{"For", " ", "BraKet", " ", "symbol", " ", "notation"}], ",", 
       " ", 
       RowBox[{
       "d", " ", "signifies", " ", "a", " ", "lower", " ", "index", " ", 
        "and", " ", "u", " ", "an", " ", "upper", " ", "index", " ", "at", 
        " ", "the", " ", "respective", " ", "sides"}]}],
      FontWeight->"Plain"]},
    {"s", "-", "du", 
     StyleBox[
      RowBox[{
       RowBox[{"For", " ", "Scripted", " ", "symbol", " ", "notation"}], ",", 
       " ", 
       RowBox[{"d", " ", "signifies", " ", "lower", " ", 
        RowBox[{"index", "/", "indices"}], " ", "and", " ", "u", " ", "upper",
         " ", 
        RowBox[{"index", "/", 
         RowBox[{"indices", ".", " ", "This"}]}], " ", "is", " ", "resolved", 
        " ", "to", " ", "QASimplescript", " ", "or", " ", "QASubsuperscript", 
        " ", "depending", " ", "on", " ", "the", " ", "concrete", " ", 
        RowBox[{"shape", "."}]}]}],
      FontWeight->"Plain"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxBackground->{"Columns" -> {None, None}, "Rows" -> {
       GrayLevel[0.85], None}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "InlineGuideFunctionListing",
 CellID->73004191]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Input Aliases",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "GuideColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "ExampleCounter" -> 1, "NeedPlatMsgIn" -> None, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 3, 26.1730827}", 
    "history" -> {"2.1", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Guide", "language" -> "en", "paclet" -> "QuantumAlgebra",
     "status" -> "None", "summary" -> 
    "The purpose of this page is to provide an overview about the input \
aliases which can be used in Quantum Algebra notebooks. The aliases are given \
in a table with columns for Alias, Prefix, Postfix, Meaning. This is because \
most aliases can be combined with Prefix(es) and Postfix(es).", 
    "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$5484, "title" -> 
    "Input Aliases", "titlemodifier" -> "", "windowtitle" -> "Input Aliases", 
    "type" -> "Guide", "uri" -> "QuantumAlgebra/guide/InputAliases"}, 
  "SearchTextTranslated" -> ""},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"Wolfram"}, "Reference.nb", CharacterEncoding -> 
       "UTF-8"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}]}, Visible -> False, FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[585, 21, 2330, 54, 50, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[2940, 79, 55, 1, 47, "GuideTitle",
 CellID->942062912],
Cell[2998, 82, 343, 7, 120, "GuideAbstract",
 CellID->2001916300]
}, Open  ]],
Cell[CellGroupData[{
Cell[3378, 94, 257, 11, 30, "GuideReferenceSection"],
Cell[3638, 107, 31, 0, 14, "SectionHeaderSpacer"],
Cell[CellGroupData[{
Cell[3694, 111, 74, 1, 30, "GuideFunctionsSubsection",
 CellID->78434960],
Cell[3771, 114, 3043, 76, 300, "InlineGuideFunctionListing",
 CellID->73004191]
}, Open  ]]
}, Open  ]],
Cell[6841, 194, 23, 0, 41, "FooterCell"]
}
]
*)

