(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10096,        283]
NotebookOptionsPosition[      5954,        185]
NotebookOutlinePosition[      9605,        267]
CellTagsIndexPosition[      9562,        264]
WindowTitle->Palette Input
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA GUIDE", "PacletNameCell"], Cell[TextData[Cell[
    BoxData[
     ActionMenuBox[
      FrameBox[
       InterpretationBox[Cell[TextData[{
         "URL",
         StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
          StripOnInput->False]
        }]],
        TextCell[
         Row[{"URL", 
           Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
       StripOnInput->False], {"\<\"QuantumAlgebra/guide/PaletteInput\"\>":>
      None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["QuantumAlgebra/guide/PaletteInput"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/language/QuantumAlgebra/guide/\
PaletteInput.html"], StandardForm]], "Input", TextClipboardType -> 
             "PlainText"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
            If[
             TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$6972], 
             "http://reference.wolfram.com/system-modeler/", 
             "http://reference.wolfram.com/language/"], 
            "QuantumAlgebra/guide/PaletteInput", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic,
      MenuStyle->"URLMenu"]],
     LineSpacing->{1.4, 0}]], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Palette Input", "GuideTitle",
 CellID->942062912],

Cell["\<\
This page provides a table about frequently used palette entries, symbols and \
templates, to be used for Quantum Algebra.\
\>", "GuideAbstract",
 CellID->2001916300],

Cell["\<\
Remark: The input aliases and notations of Quantum Algebra are not mentioned \
here.\
\>", "GuideAbstract",
 CellID->59600294]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Reference"
}], "GuideReferenceSection",
 WholeCellGroupOpener->True],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["Entry",
      FontWeight->"Bold"], 
     StyleBox["Alias",
      FontWeight->"Bold"], 
     StyleBox[
      RowBox[{"Used", " ", "By"}],
      FontWeight->"Bold"]},
    {"Subscript", 
     RowBox[{"CTRL", " ", "-"}], 
     RowBox[{
      RowBox[{
      "QAIntegrate", " ", "with", " ", "range", " ", "and", " ", "integral"}],
       ",", " ", 
      RowBox[{"QAD", " ", "with", " ", "GothicCapitelD"}]}]},
    {"Superscript", 
     RowBox[{"CTRL", " ", "6"}], 
     RowBox[{"DifferentialD", " ", "with", " ", "dimension"}]},
    {"Underscript", 
     RowBox[{"CTRL", " ", "4"}], 
     RowBox[{"QASum", " ", "with", " ", "variable"}]},
    {"DifferentialD", 
     RowBox[{"ESC", " ", "dd", " ", "ESC"}], 
     RowBox[{"For", " ", "integration", " ", "variable"}]},
    {"Integral", 
     RowBox[{"ESC", " ", "int", " ", "ESC"}], 
     RowBox[{"QAIntegrate", " ", "-", " ", 
      RowBox[{"the", " ", "integration", " ", "symbol"}]}]},
    {"Sum", 
     RowBox[{"ESC", " ", "sum", " ", "ESC"}], 
     RowBox[{"QASum", " ", "-", " ", 
      RowBox[{"the", " ", "summation", " ", "symbol"}]}]},
    {"Product", 
     RowBox[{"ESC", " ", "prod", " ", "ESC"}], 
     RowBox[{"The", " ", "product", " ", "symbol"}]},
    {"GothicCapitelD", 
     RowBox[{"ESC", " ", "goD", " ", "ESC"}], 
     RowBox[{"QAD", " ", "-", " ", 
      RowBox[{"partial", " ", "derivative", " ", 
       RowBox[{"(", 
        RowBox[{"with", " ", "Subscript"}], ")"}]}]}]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxBackground->{"Columns" -> {None, None}, "Rows" -> {
       GrayLevel[0.85], None}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "GuideText",
 CellID->63493547],

Cell["", "SectionHeaderSpacer"]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Reference"
}], "GuideReferenceSection",
 WholeCellGroupOpener->True],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Palette Input",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "GuideColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "ExampleCounter" -> 1, "NeedPlatMsgIn" -> None, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 3, 30.0347588}", 
    "history" -> {"2.1", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Guide", "language" -> "en", "paclet" -> "QuantumAlgebra",
     "status" -> "None", "summary" -> 
    "This page provides a table about frequently used palette entries, \
symbols and templates, to be used for Quantum Algebra.", "synonyms" -> {}, 
    "tabletags" -> DocumentationBuild`Make`Private`tabletaggingrules$6896, 
    "title" -> "Palette Input", "titlemodifier" -> "", "windowtitle" -> 
    "Palette Input", "type" -> "Guide", "uri" -> 
    "QuantumAlgebra/guide/PaletteInput"}, "SearchTextTranslated" -> ""},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"Wolfram"}, "Reference.nb", CharacterEncoding -> 
       "UTF-8"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}]}, Visible -> False, FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[585, 21, 2330, 54, 50, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[2940, 79, 55, 1, 47, "GuideTitle",
 CellID->942062912],
Cell[2998, 82, 176, 4, 68, "GuideAbstract",
 CellID->2001916300],
Cell[3177, 88, 136, 4, 48, "GuideAbstract",
 CellID->59600294]
}, Open  ]],
Cell[CellGroupData[{
Cell[3350, 97, 257, 11, 30, "GuideReferenceSection"],
Cell[3610, 110, 31, 0, 14, "SectionHeaderSpacer"],
Cell[3644, 112, 1974, 53, 220, "GuideText",
 CellID->63493547],
Cell[5621, 167, 31, 0, 14, "SectionHeaderSpacer"]
}, Open  ]],
Cell[5667, 170, 257, 11, 30, "GuideReferenceSection"],
Cell[5927, 183, 23, 0, 25, "FooterCell"]
}
]
*)

