(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     17689,        559]
NotebookOptionsPosition[     12160,        406]
NotebookOutlinePosition[     16120,        501]
CellTagsIndexPosition[     16035,        496]
WindowTitle->Analyze
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"BraExpressionQ\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/BraExpressionQ"], "\<\"KetExpressionQ\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/KetExpressionQ"], \
"\<\"OperatorExpressionQ\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/OperatorExpressionQ"], \
"\<\"QuantumConstantExpressionQ\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QuantumConstantExpressionQ"], \
"\<\"QuantumFreeQ\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QuantumFreeQ"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/Analyze\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/Analyze"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
Analyze.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$7418], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/Analyze", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["Analyze", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Analyze", "[", 
       StyleBox["ex", "TI"], "]"}]], "InlineFormula"],
     " \n\tPrints out some diagnostic messages about Analyze result."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->328742974],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
Analyze checks the expression ex for validity as Quantum Algebra object. It \
may be a Bra, Ket, Operator, Quantum Constant or no Quantum object at all. \
Each of the object types may be a simple or a composed object.\
\>", "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->24449128],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->398513559],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->158584138],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[10]:=",
 CellID->133251379],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[10]:=",
 CellID->26906773],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[10]:=",
 CellID->330827307],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[10]:=",
 CellID->386352416]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetNotebookStyles", "[", "]"}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->28647855],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Define", " ", "a", " ", "Bra", " ", "object"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"bra", "=", 
   RowBox[{
    RowBox[{
     TagBox[
      RowBox[{"\[LeftAngleBracket]", 
       AdjustmentBox[
        TagBox["A",
         QuantumAlgebra`QuantumNotation`BraArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0], 
       AdjustmentBox["\[VerticalSeparator]",
        BoxMargins->{{0., -0.2}, {0, 0}}]}],
      QuantumAlgebra`Bra,
      BaseStyle->"BraWrapper"], "Pi", " ", "I"}], "+", 
    RowBox[{
     TagBox[
      RowBox[{"\[LeftAngleBracket]", 
       AdjustmentBox[
        TagBox["B",
         QuantumAlgebra`QuantumNotation`BraArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0], 
       AdjustmentBox["\[VerticalSeparator]",
        BoxMargins->{{0., -0.2}, {0, 0}}]}],
      QuantumAlgebra`Bra,
      BaseStyle->"BraWrapper"], "\[CenterDot]", 
     OverscriptBox["Q", "^"]}]}]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->805038975],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
   TagBox[
    RowBox[{"\[LeftAngleBracket]", 
     AdjustmentBox[
      TagBox["A",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], 
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{0., -0.2}, {0, 0}}]}],
    QuantumAlgebra`Bra,
    BaseStyle->"BraWrapper"]}], "+", 
  RowBox[{
   TagBox[
    RowBox[{"\[LeftAngleBracket]", 
     AdjustmentBox[
      TagBox["B",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], 
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{0., -0.2}, {0, 0}}]}],
    QuantumAlgebra`Bra,
    BaseStyle->"BraWrapper"], "\[CenterDot]", 
   OverscriptBox["Q", "^"]}]}]], "Output",
 ImageSize->{100, 20},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->647900261]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Analyzes", " ", "the", " ", "object"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Analyze", "[", "bra", "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->217552095],

Cell[BoxData["\<\"Detected a valid Bra.\"\>"], "Print",
 CellLabel->"During evaluation of In[12]:=",
 CellID->11057655],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->743841812]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["BraExpressionQ"]],"paclet:QuantumAlgebra/ref/BraExpressionQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["KetExpressionQ"]],"paclet:QuantumAlgebra/ref/KetExpressionQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OperatorExpressionQ"]],
    "paclet:QuantumAlgebra/ref/OperatorExpressionQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QuantumConstantExpressionQ"]],
    "paclet:QuantumAlgebra/ref/QuantumConstantExpressionQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QuantumFreeQ"]],"paclet:QuantumAlgebra/ref/QuantumFreeQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Analyze",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 3, 31.7511699}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> 
    "QuantumAlgebra`Analyze`", 
    "keywords" -> {
     "Analyze BraExpressionQ KetExpressionQ OperatorExpressionQ \
QuantumConstantExpressionQ QuantumFreeQ"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "Analyze[ex] Prints out some diagnostic messages about Analyze result.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "Analyze", 
    "titlemodifier" -> "", "windowtitle" -> "Analyze", "type" -> "Symbol", 
    "uri" -> "QuantumAlgebra/ref/Analyze"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5905, 175, 386, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->24449128]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15893, 489}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[579, 21, 3519, 83, 50, "AnchorBarGrid",
 CellID->1],
Cell[4101, 106, 284, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4410, 121, 383, 11, 89, "Usage"],
Cell[CellGroupData[{
Cell[4818, 136, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->328742974],
Cell[5559, 162, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5593, 164, 263, 5, 70, "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5905, 175, 386, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->24449128],
Cell[CellGroupData[{
Cell[6316, 194, 195, 6, 25, "ExampleSection",
 CellID->398513559],
Cell[CellGroupData[{
Cell[6536, 204, 239, 7, 43, "Input",
 CellID->158584138],
Cell[CellGroupData[{
Cell[6800, 215, 144, 2, 22, "Print",
 CellID->133251379],
Cell[6947, 219, 153, 3, 22, "Print",
 CellID->26906773],
Cell[7103, 224, 159, 3, 22, "Print",
 CellID->330827307],
Cell[7265, 229, 161, 3, 22, "Print",
 CellID->386352416]
}, Open  ]]
}, Open  ]],
Cell[7453, 236, 125, 4, 26, "Input",
 CellID->28647855],
Cell[CellGroupData[{
Cell[7603, 244, 1048, 33, 47, "Input",
 CellID->805038975],
Cell[8654, 279, 946, 31, 41, "Output",
 CellID->647900261]
}, Open  ]],
Cell[CellGroupData[{
Cell[9637, 315, 232, 7, 43, "Input",
 CellID->217552095],
Cell[9872, 324, 119, 2, 22, "Print",
 CellID->11057655],
Cell[9994, 328, 161, 5, 35, "Output",
 CellID->743841812]
}, Open  ]]
}, Open  ]],
Cell[10182, 337, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10250, 342, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[10523, 356, 1595, 45, 74, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[12133, 404, 23, 0, 70, "FooterCell"]
}
]
*)

