(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     17668,        556]
NotebookOptionsPosition[     12090,        406]
NotebookOutlinePosition[     16214,        502]
CellTagsIndexPosition[     16129,        497]
WindowTitle->Bra
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Ket\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Ket"], "\<\"BraKet\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/BraKet"], "\<\"Operator\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/ref/Operator"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/Bra\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/Bra"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/Bra.\
html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$9597], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/Bra", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["Bra", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Bra", "[", "A__", "]"}]], "InlineFormula"],
     "\[LineSeparator]is the simple form of a Bra object where the sequence A \
labels the Bra. Additional forms allow the usage of indices. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Bra", "[", 
       RowBox[{"A__", ",", 
        RowBox[{"{", 
         StyleBox["x__", "TI"], "}"}], ",", 
        RowBox[{"{", "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]enables the use of a sequence of subscript indices (x). "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Bra", "[", 
       RowBox[{"A__", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         StyleBox["y__", "TI"], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]provides a sequence of superscripts (y). "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Bra", "[", 
       RowBox[{"A__", ",", 
        RowBox[{"{", 
         StyleBox["x__", "TI"], "}"}], ",", 
        RowBox[{"{", 
         StyleBox["y__", "TI"], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]provides subscripts as well as superscripts. \
\[LineSeparator]"
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, {None}}, "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->104778666],

Cell["", "SectionHeaderSpacer"],

Cell[TextData[{
 Cell[BoxData["ALIASES"], "InlineFormula"],
 ": \[LineSeparator][ESC] bra [ESC]   : bra \[LineSeparator][ESC] dbra [ESC]  \
: bra with subscript \[LineSeparator][ESC] ubra [ESC]  : bra with superscript \
\[LineSeparator][ESC] dubra [ESC] : bra with both scripts. \[LineSeparator]\
\[LineSeparator]Bra is also used as a tag for TagBoxes that guide the \
interpretation of the internal structure of bra notation."
}], "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->204371471],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->66959367],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "Application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Needs", "[", "\"\<QuantumAlgebra`\>\"", "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->572725899],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->154128299],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->7037705],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->397605441],

Cell[BoxData["\<\"For proper styling You should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->311584966]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Input", " ", "in", " ", "FullForm"}], ",", " ", 
    RowBox[{"Output", " ", "as", " ", "Bra", " ", "Symbol"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Bra", "[", "m", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->100786896],

Cell[BoxData[
 TagBox[
  RowBox[{"\[LeftAngleBracket]", 
   AdjustmentBox[
    TagBox["m",
     QuantumAlgebra`QuantumNotation`BraArgs,
     BaseStyle->"BraKetArg"],
    BoxBaselineShift->0], 
   AdjustmentBox["\[VerticalSeparator]",
    BoxMargins->{{0, -0.2}, {0, 0}}]}],
  Bra,
  BaseStyle->"BraWrapper"]], "Output",
 ImageSize->{26, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->104728556]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Input", " ", "with", " ", "Input", " ", 
    RowBox[{"Alias", ":", " ", 
     RowBox[{"ESC", " ", "dbra", " ", "ESC"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  TagBox[
   RowBox[{
    SubscriptBox["\[InvisiblePrefixScriptBase]", 
     TagBox[
      AdjustmentBox[
       TagBox["1",
        QuantumAlgebra`QuantumNotation`BraArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0],
      QuantumAlgebra`QuantumNotation`UDScript,
      BaseStyle->"LIndex"]], 
    RowBox[{"\[LeftAngleBracket]", 
     AdjustmentBox[
      TagBox["n",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], 
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{0, -0.2}, {0, 0}}]}]}],
   Bra,
   BaseStyle->"BraWrapper"]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->6591982],

Cell[BoxData[
 TagBox[
  RowBox[{
   SubscriptBox["\[InvisiblePrefixScriptBase]", 
    TagBox[
     AdjustmentBox[
      TagBox["1",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"LIndex"]], 
   RowBox[{"\[LeftAngleBracket]", 
    AdjustmentBox[
     TagBox["n",
      QuantumAlgebra`QuantumNotation`BraArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], 
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{0, -0.2}, {0, 0}}]}]}],
  Bra,
  BaseStyle->"BraWrapper"]], "Output",
 ImageSize->{32, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->353611923]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Ket"]],"paclet:QuantumAlgebra/ref/Ket"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["BraKet"]],"paclet:QuantumAlgebra/ref/BraKet"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Operator"]],"paclet:QuantumAlgebra/ref/Operator"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Bra",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 3, 40.1945965}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {"Bra Ket BraKet Operator Dirac"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "Bra[A__] is the simple form of a Bra object where the sequence A labels \
the Bra. Additional forms allow the usage of indices. Bra[A__, {x__}, {}] \
enables the use of a sequence of subscript indices (x). Bra[A__, {}, {y__}] \
provides a sequence of superscripts (y). Bra[A__, {x__}, {y__}] provides \
subscripts as well as superscripts. ", "synonyms" -> {}, "tabletags" -> {}, 
    "title" -> "Bra", "titlemodifier" -> "", "windowtitle" -> "Bra", "type" -> 
    "Symbol", "uri" -> "QuantumAlgebra/ref/Bra"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6800, 201, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->204371471]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15986, 490}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[575, 21, 3202, 77, 50, "AnchorBarGrid",
 CellID->1],
Cell[3780, 100, 280, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4085, 115, 1405, 40, 270, "Usage"],
Cell[CellGroupData[{
Cell[5515, 159, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->104778666],
Cell[6256, 185, 31, 0, 70, "SectionHeaderSpacer"],
Cell[6290, 187, 461, 8, 70, "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6800, 201, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->204371471],
Cell[CellGroupData[{
Cell[7212, 220, 194, 6, 25, "ExampleSection",
 CellID->66959367],
Cell[CellGroupData[{
Cell[7431, 230, 252, 7, 43, "Input",
 CellID->572725899],
Cell[CellGroupData[{
Cell[7708, 241, 143, 2, 22, "Print",
 CellID->154128299],
Cell[7854, 245, 151, 3, 22, "Print",
 CellID->7037705],
Cell[8008, 250, 158, 3, 22, "Print",
 CellID->397605441],
Cell[8169, 255, 160, 3, 22, "Print",
 CellID->311584966]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8378, 264, 312, 9, 43, "Input",
 CellID->100786896],
Cell[8693, 275, 449, 16, 37, "Output",
 CellID->104728556]
}, Open  ]],
Cell[CellGroupData[{
Cell[9179, 296, 892, 29, 44, "Input",
 CellID->6591982],
Cell[10074, 327, 751, 26, 46, "Output",
 CellID->353611923]
}, Open  ]]
}, Open  ]],
Cell[10852, 357, 31, 0, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10920, 362, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[11193, 376, 855, 25, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[12063, 404, 23, 0, 70, "FooterCell"]
}
]
*)

