(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     19406,        605]
NotebookOptionsPosition[     13629,        446]
NotebookOutlinePosition[     17723,        543]
CellTagsIndexPosition[     17638,        538]
WindowTitle->DefineNameOrderingRule
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DefineCommutatorRule\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/DefineCommutatorRule"], "\<\"QAReplace\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAReplace"], "\<\"QAReplaceRepeated\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAReplaceRepeated"], "\<\"QASelectDefault\"\
\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QASelectDefault"], \
"\<\"QAAddReplacementRules\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAAddReplacementRules"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"QuantumAlgebra/ref/DefineNameOrderingRule\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/DefineNameOrderingRule"]}, Visible -> 
            False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
DefineNameOrderingRule.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$13767], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/DefineNameOrderingRule", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["DefineNameOrderingRule", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DefineNameOrderingRule", "[", 
       RowBox[{
        StyleBox["anti", "TI"], ",", " ", 
        StyleBox["dim", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]uses a Commutator / Anti-Commutator to sort operators \
according to name order."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->30726514],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
If both operators of a multiplied pair are either Hermitian or Non-Hermitian, \
they can be brought in a defined order by using their name. Otherwise the \
application could not sufficiently simplify expressions with such pairs.\
\>", "Notes",
 CellID->1067943069],

Cell["The meaning of the parameters is as follows:", "Notes",
 CellID->21145800],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"anti\"\>", "Notes"], 
     StyleBox["\<\"Whether to use a anti-commutator/commutator\"\>", "Notes"]},
    {
     StyleBox["\<\"dim\"\>", "Notes"], 
     StyleBox["\<\"The dimension, defaults to 3\"\>", "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False]], "Notes",
 CellID->47800268]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->209782704],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->425262876],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->91566771],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[19]:=",
 CellID->366103575],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[19]:=",
 CellID->319958138],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[19]:=",
 CellID->41719178],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[19]:=",
 CellID->38947677]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Selects", " ", "the", " ", "default", " ", "set"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"QASelectDefault", "[", "\"\<KleinGordon\>\"", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->25991509],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Adds", " ", "2", " ", "replacement", " ", "rules", " ", "under", " ", 
    "the", " ", "name", " ", "\"\<commutator\>\""}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QAAddReplacementRules", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"DefineCommutatorRule", "[", 
        RowBox[{"False", ",", "True", ",", "True"}], "]"}], ",", 
       RowBox[{"DefineNameOrderingRule", "[", "False", "]"}]}], "}"}], ",", 
     "\"\<commutator\>\""}], "]"}], ";"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->104380238],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Defines", " ", "a", " ", "pair", " ", "of", " ", "multiplied", " ", 
    "operators"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"pair", "=", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["a", "^"], 
     RowBox[{
      SubscriptBox["k", "1"], ",", 
      SubscriptBox["k", "2"], ",", 
      SubscriptBox["k", "3"]}]], "\[CenterDot]", 
    SubscriptBox[
     OverscriptBox["a", "^"], 
     RowBox[{
      SubscriptBox["i", "1"], ",", 
      SubscriptBox["i", "2"], ",", 
      SubscriptBox["i", "3"]}]]}]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->412025834],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   OverscriptBox["a", "^"], 
   RowBox[{
    SubscriptBox["k", "1"], ",", 
    SubscriptBox["k", "2"], ",", 
    SubscriptBox["k", "3"]}]], "\[CenterDot]", 
  SubscriptBox[
   OverscriptBox["a", "^"], 
   RowBox[{
    SubscriptBox["i", "1"], ",", 
    SubscriptBox["i", "2"], ",", 
    SubscriptBox["i", "3"]}]]}]], "Output",
 ImageSize->{117, 20},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1991137]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Applies", " ", "the", " ", "rules", " ", "defined", " ", "before", " ", 
    "\[IndentingNewLine]", "We", " ", "can", " ", "see", " ", "the", " ", 
    "reversed", " ", "operators", " ", "as", " ", "their", " ", "indexes", 
    " ", "are", " ", "now", " ", "alphabetically", " ", "ordered"}], 
   "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"pair", "//", 
   RowBox[{"QAReplace", "[", "\"\<commutator\>\"", "]"}]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->92929731],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   OverscriptBox["a", "^"], 
   RowBox[{
    SubscriptBox["i", "1"], ",", 
    SubscriptBox["i", "2"], ",", 
    SubscriptBox["i", "3"]}]], "\[CenterDot]", 
  SubscriptBox[
   OverscriptBox["a", "^"], 
   RowBox[{
    SubscriptBox["k", "1"], ",", 
    SubscriptBox["k", "2"], ",", 
    SubscriptBox["k", "3"]}]]}]], "Output",
 ImageSize->{117, 20},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1540602]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DefineCommutatorRule"]],
    "paclet:QuantumAlgebra/ref/DefineCommutatorRule"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAReplace"]],"paclet:QuantumAlgebra/ref/QAReplace"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAReplaceRepeated"]],
    "paclet:QuantumAlgebra/ref/QAReplaceRepeated"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QASelectDefault"]],"paclet:QuantumAlgebra/ref/QASelectDefault"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAAddReplacementRules"]],
    "paclet:QuantumAlgebra/ref/QAAddReplacementRules"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DefineNameOrderingRule",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 3, 54.6409829}", 
    "history" -> {"2.0.1", "2.1.1", "", ""}, "context" -> 
    "QuantumAlgebra`RulesSupplement`", 
    "keywords" -> {
     "DefineCommutatorRule DefineNameOrderingRule QAReplace QAReplaceRepeated \
QASelectDefault QAAddReplacementRules"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "DefineNameOrderingRule[anti, dim] uses a Commutator / Anti-Commutator to \
sort operators according to name order.", "synonyms" -> {}, "tabletags" -> {},
     "title" -> "DefineNameOrderingRule", "titlemodifier" -> "", 
    "windowtitle" -> "DefineNameOrderingRule", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/DefineNameOrderingRule"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6954, 203, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->209782704]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 17495, 531}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 3605, 85, 50, "AnchorBarGrid",
 CellID->1],
Cell[4202, 108, 299, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4526, 123, 495, 14, 80, "Usage"],
Cell[CellGroupData[{
Cell[5046, 141, 737, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->30726514],
Cell[5786, 167, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5820, 169, 274, 5, 70, "Notes",
 CellID->1067943069],
Cell[6097, 176, 80, 1, 70, "Notes",
 CellID->21145800],
Cell[6180, 179, 725, 18, 70, "Notes",
 CellID->47800268]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6954, 203, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->209782704],
Cell[CellGroupData[{
Cell[7366, 222, 195, 6, 25, "ExampleSection",
 CellID->425262876],
Cell[CellGroupData[{
Cell[7586, 232, 238, 7, 43, "Input",
 CellID->91566771],
Cell[CellGroupData[{
Cell[7849, 243, 144, 2, 22, "Print",
 CellID->366103575],
Cell[7996, 247, 154, 3, 22, "Print",
 CellID->319958138],
Cell[8153, 252, 158, 3, 22, "Print",
 CellID->41719178],
Cell[8314, 257, 160, 3, 22, "Print",
 CellID->38947677]
}, Open  ]]
}, Open  ]],
Cell[8501, 264, 267, 7, 43, "Input",
 CellID->25991509],
Cell[8771, 273, 611, 17, 59, "Input",
 CellID->104380238],
Cell[CellGroupData[{
Cell[9407, 294, 634, 21, 47, "Input",
 CellID->412025834],
Cell[10044, 317, 494, 18, 41, "Output",
 CellID->1991137]
}, Open  ]],
Cell[CellGroupData[{
Cell[10575, 340, 552, 12, 75, "Input",
 CellID->92929731],
Cell[11130, 354, 494, 18, 41, "Output",
 CellID->1540602]
}, Open  ]]
}, Open  ]],
Cell[11651, 376, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11719, 381, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[11992, 395, 1595, 46, 70, "SeeAlso",
 CellID->1038487239]
}, Open  ]],
Cell[13602, 444, 23, 0, 70, "FooterCell"]
}
]
*)

