(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     20368,        657]
NotebookOptionsPosition[     13867,        483]
NotebookOutlinePosition[     18342,        583]
CellTagsIndexPosition[     18257,        578]
WindowTitle->Operator
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Bra\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Bra"], "\<\"Ket\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Ket"], "\<\"BraKet\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/ref/BraKet"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra Guide\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/guide/Guide"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/Operator\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/Operator"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
Operator.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$20052], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/Operator", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["Operator", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Operator", "[", 
       TemplateBox[{Cell[
          TextData["A"]],"paclet:ref/A"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "]"}]], "InlineFormula"],
     "\[LineSeparator]defines an operator object, where A is the label of the \
operator. Some other forms are defined as follows. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Operator", "[", 
       RowBox[{
        TemplateBox[{Cell[
           TextData["A"]],"paclet:ref/A"},
         "RefLink",
         BaseStyle->{"InlineFormula"}], ",", 
        StyleBox["x", "TI"], ",", 
        RowBox[{"{", "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]defines an operator where ",
     Cell[BoxData[
      StyleBox["x", "TI"]], "InlineFormula"],
     " is a list of subscript indices. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Operator", "[", 
       RowBox[{
        TemplateBox[{Cell[
           TextData["A"]],"paclet:ref/A"},
         "RefLink",
         BaseStyle->{"InlineFormula"}], ",", 
        RowBox[{"{", "}"}], ",", 
        StyleBox["y", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]defines an operator where ",
     Cell[BoxData[
      StyleBox["y", "TI"]], "InlineFormula"],
     " is a list of superscript indices. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Operator", "[", 
       RowBox[{
        TemplateBox[{Cell[
           TextData["A"]],"paclet:ref/A"},
         "RefLink",
         BaseStyle->{"InlineFormula"}], ",", 
        StyleBox["x", "TI"], ",", 
        StyleBox["y", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]defines an operator where both subscripts and \
superscripts are given. If y is an integer this is interpreted as Power. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Operator", "[", "__", "]"}]], "InlineFormula"],
     Cell[BoxData[
      RowBox[{"[", 
       StyleBox["t__", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]contains additional variables. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Operator", "[", 
       RowBox[{
        TemplateBox[{Cell[
           TextData["A"]],"paclet:ref/A"},
         "RefLink",
         BaseStyle->{"InlineFormula"}], ",", "\"\<H\>\"", ",", "__"}], "]"}]],
       "InlineFormula"],
     "\[LineSeparator]contains a label ",
     Cell[BoxData["\"\<H\>\""], "InlineFormula"],
     " signifying a hermitian operator for ",
     Cell[BoxData[
      RowBox[{"Operator", "[", 
       TemplateBox[{Cell[
          TextData["A"]],"paclet:ref/A"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "]"}]], "InlineFormula"],
     ". "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Operator", "[", "1", "]"}]], "InlineFormula"],
     "\[LineSeparator]and ",
     Cell[BoxData[
      RowBox[{"Operator", "[", "0", "]"}]], "InlineFormula"],
     " are interpreted as the identity and zero operators respectively."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, None, None, None, {None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->766756235],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
ALIASES: \[LineSeparator][ESC] op [ESC]  : operator. \[LineSeparator][ESC] \
hop [ESC] : hermitian operator.\
\>", "Notes",
 CellID->1067943069],

Cell["", "SectionFooterSpacer"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->449371995],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->19530369],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Needs", "[", "\"\<QuantumAlgebra`\>\"", "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->316429542],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellID->283865661],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellID->351484068],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellID->104985719],

Cell[BoxData["\<\"For proper styling You should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellID->408387651]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Input", " ", "in", " ", "FullForm"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Operator", "[", "H", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->17305950],

Cell[BoxData[
 OverscriptBox["H", "^"]], "Output",
 ImageSize->{11, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->651415889]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Operator", "[", 
  RowBox[{"H", ",", "\"\<H\>\""}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->99130355],

Cell[BoxData[
 SuperscriptBox[
  OverscriptBox["H", "^"], "\[Dagger]"]], "Output",
 ImageSize->{17, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->106182075]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Operator", "[", 
  RowBox[{"A", ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "j"}], "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->181268179],

Cell[BoxData[
 SubscriptBox[
  OverscriptBox["A", "^"], 
  RowBox[{"i", ",", "j"}]]], "Output",
 ImageSize->{27, 21},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->18255877]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Input", " ", "with", " ", "input", " ", "alias", " ", "ESC", " ", "op", 
    " ", "ESC"}], " ", "*)"}], "\[IndentingNewLine]", 
  OverscriptBox["V", "^"]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->37004807],

Cell[BoxData[
 OverscriptBox["V", "^"]], "Output",
 ImageSize->{11, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->654612170]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Bra"]],"paclet:QuantumAlgebra/ref/Bra"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Ket"]],"paclet:QuantumAlgebra/ref/Ket"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["BraKet"]],"paclet:QuantumAlgebra/ref/BraKet"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->9321290]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["QuantumAlgebra Guide"]],"paclet:QuantumAlgebra/guide/Guide"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->238383610]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Operator",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 4, 16.3609054}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {"Operator Bra Ket BraKet Dirac"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "Operator[A] defines an operator object, where A is the label of the \
operator. Some other forms are defined as follows. Operator[A, x, {}] defines \
an operator where x is a list of subscript indices. Operator[A, {}, y] \
defines an operator where y is a list of superscript indices. Operator[A, x, \
y] defines an operator where both subscripts and superscripts are given. If y \
is an integer this is interpreted as Power. Operator[__][t__] contains \
additional variables. Operator[A, \"H\", __] contains a label \"H\" \
signifying a hermitian operator for Operator[A]. Operator[1] and Operator[0] \
are interpreted as the identity and zero operators respectively.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "Operator", 
    "titlemodifier" -> "", "windowtitle" -> "Operator", "type" -> "Symbol", 
    "uri" -> "QuantumAlgebra/ref/Operator"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8921, 269, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->449371995]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 18114, 571}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[580, 21, 3751, 92, 50, "AnchorBarGrid",
 CellID->1],
Cell[4334, 115, 285, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4644, 130, 3240, 95, 460, "Usage"],
Cell[CellGroupData[{
Cell[7909, 229, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->766756235],
Cell[8650, 255, 31, 0, 70, "SectionHeaderSpacer"],
Cell[8684, 257, 154, 4, 70, "Notes",
 CellID->1067943069],
Cell[8841, 263, 31, 0, 70, "SectionFooterSpacer"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8921, 269, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->449371995],
Cell[CellGroupData[{
Cell[9333, 288, 194, 6, 25, "ExampleSection",
 CellID->19530369],
Cell[CellGroupData[{
Cell[9552, 298, 252, 7, 43, "Input",
 CellID->316429542],
Cell[CellGroupData[{
Cell[9829, 309, 99, 1, 22, "Print",
 CellID->283865661],
Cell[9931, 312, 109, 2, 22, "Print",
 CellID->351484068],
Cell[10043, 316, 114, 2, 70, "Print",
 CellID->104985719],
Cell[10160, 320, 116, 2, 70, "Print",
 CellID->408387651]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10325, 328, 228, 7, 70, "Input",
 CellID->17305950],
Cell[10556, 337, 180, 6, 39, "Output",
 CellID->651415889]
}, Open  ]],
Cell[CellGroupData[{
Cell[10773, 348, 134, 4, 70, "Input",
 CellID->99130355],
Cell[10910, 354, 212, 7, 39, "Output",
 CellID->106182075]
}, Open  ]],
Cell[CellGroupData[{
Cell[11159, 366, 205, 7, 70, "Input",
 CellID->181268179],
Cell[11367, 375, 224, 8, 42, "Output",
 CellID->18255877]
}, Open  ]],
Cell[CellGroupData[{
Cell[11628, 388, 270, 8, 70, "Input",
 CellID->37004807],
Cell[11901, 398, 180, 6, 39, "Output",
 CellID->654612170]
}, Open  ]]
}, Open  ]],
Cell[12108, 408, 31, 0, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12176, 413, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[12449, 427, 843, 25, 70, "SeeAlso",
 CellID->9321290]
}, Open  ]],
Cell[CellGroupData[{
Cell[13329, 457, 276, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[13608, 471, 31, 0, 70, "SectionHeaderSpacer"],
Cell[13642, 473, 183, 5, 70, "MoreAbout",
 CellID->238383610]
}, Open  ]],
Cell[13840, 481, 23, 0, 70, "FooterCell"]
}
]
*)

