(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18350,        562]
NotebookOptionsPosition[     12543,        403]
NotebookOutlinePosition[     16664,        500]
CellTagsIndexPosition[     16579,        495]
WindowTitle->QAAddExplicitIntegrationVariables
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QAResetExplicitIntegrationVariables\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAResetExplicitIntegrationVariables"], \
"\<\"QAGetExplicitIntegrationVariables\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAGetExplicitIntegrationVariables"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"QuantumAlgebra/ref/QAAddExplicitIntegrationVariables\"\
\>":>None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAAddExplicitIntegrationVariables"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAAddExplicitIntegrationVariables.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$22158], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAAddExplicitIntegrationVariables", 
             ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAAddExplicitIntegrationVariables", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       RowBox[{"QAAddExplicitIntegrationVariables", "[", 
        RowBox[{
         StyleBox["vars", "TI"], ",", " ", 
         StyleBox["set", "TI"]}], "]"}], " "}]], "InlineFormula"],
     "\[LineSeparator]adds vars to the given set of Explicit Integration \
Variables."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->369959925],

Cell["", "SectionHeaderSpacer"],

Cell["The meaning of the parameters is as follows:", "Notes",
 CellID->1067943069],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"vars\"\>", "Notes"], 
     StyleBox[
      RowBox[{
      "The", " ", "vars", " ", "parameter", " ", "must", " ", "be", " ", "a", 
       " ", "list", " ", "of", " ", "scripted", " ", "symbols"}], "Notes"]},
    {
     StyleBox["\<\"set\"\>", "Notes"], 
     StyleBox[
      RowBox[{
      "The", " ", "set", " ", "name", " ", "or", " ", "Null", " ", "or", " ", 
       "left", " ", "empty", " ", "for", " ", "the", " ", "default", " ", 
       "set"}], "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False]], "Notes",
 CellID->649193982],

Cell["\<\
This set of functions is normally used as follows: In Integrals we have \
implicit integration variables. These are for instance the spatial \
coordinates with indices 1, 2, 3. The time in such integrals can be treated \
as integration constant and the integral can be appropriately simplified. But \
if we integrate over a wave number space (3 dimensional), the fourth \
variable, the wave frequency is dependent on the wave numbers and cannot be \
treated as constant. We can explicitly define such variables as variables \
regarding integration. Otherwise the simplification would fail.\
\>", "Notes",
 CellID->14480980]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->591971836],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->159231294],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "QuantumAlgebra`"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->50840935],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[41]:=",
 CellID->4864816],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[41]:=",
 CellID->252600442],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[41]:=",
 CellID->96614404],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[41]:=",
 CellID->207013298]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Declare", " ", "a", " ", "name", " ", "for", " ", "a", " ", "set", " ", 
    "of", " ", "assumptions"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QASelectDefault", "[", "\"\<KleinGordon\>\"", "]"}], 
   ";"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->141102975],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Adds", " ", "to", " ", "Explicit", " ", "Integration", " ", 
    RowBox[{"Variables", ".", " ", "This"}], " ", "is", " ", "required", " ", 
    "to", " ", "perform", " ", "adequate", " ", 
    RowBox[{"simplifications", ".", " ", "Without"}], " ", "giving", " ", 
    "it", " ", "a", " ", "name", " ", "the", " ", "default", " ", "name", 
    " ", "\"\<KleinGordon\>\"", " ", "is", " ", 
    RowBox[{"used", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QAAddExplicitIntegrationVariables", "[", 
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["k", "0"], ",", " ", 
      SubscriptBox["k1", "0"]}], "}"}], "]"}], ";"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->55424084],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"After", " ", "adding", " ", "it"}], ",", " ", 
    RowBox[{"the", " ", "list", " ", "can", " ", "be", " ", "queried"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QAGetExplicitIntegrationVariables", "[", "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->46286282],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   SubscriptBox["k", "0"], ",", 
   SubscriptBox["k1", "0"]}], "}"}]], "Output",
 ImageSize->{62, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->692707570]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "As", " ", "we", " ", "can", " ", "see", " ", "the", " ", "variable", " ", 
    "is", " ", "not", " ", "treated", " ", "as", " ", "constant"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   SubscriptBox["\[Integral]", "V"], 
   RowBox[{
    SubscriptBox["k", "0"], 
    RowBox[{
     SuperscriptBox["\[DifferentialD]", "3"], "k"}]}]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->31356969],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Integral]", "V"], 
  RowBox[{
   SubscriptBox["k", "0"], 
   RowBox[{
    SuperscriptBox["\[DifferentialD]", "3"], "k"}]}]}]], "Output",
 ImageSize->{54, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->10340563]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAResetExplicitIntegrationVariables"]],
    "paclet:QuantumAlgebra/ref/QAResetExplicitIntegrationVariables"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAGetExplicitIntegrationVariables"]],
    "paclet:QuantumAlgebra/ref/QAGetExplicitIntegrationVariables"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAAddExplicitIntegrationVariables",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 4, 23.8119851}", 
    "history" -> {"2.0.1", "2.1.2", "", ""}, "context" -> 
    "QuantumAlgebra`Agreements`", 
    "keywords" -> {
     "QAResetExplicitIntegrationVariables QAAddExplicitIntegrationVariables \
QAGetExplicitIntegrationVariables"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAAddExplicitIntegrationVariables[vars, set] adds vars to the given set \
of Explicit Integration Variables.", "synonyms" -> {}, "tabletags" -> {}, 
    "title" -> "QAAddExplicitIntegrationVariables", "titlemodifier" -> "", 
    "windowtitle" -> "QAAddExplicitIntegrationVariables", "type" -> "Symbol", 
    "uri" -> "QuantumAlgebra/ref/QAAddExplicitIntegrationVariables"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7389, 211, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->591971836]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 16436, 488}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[605, 21, 3383, 80, 50, "AnchorBarGrid",
 CellID->1],
Cell[3991, 103, 310, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4326, 118, 515, 15, 80, "Usage"],
Cell[CellGroupData[{
Cell[4866, 137, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->369959925],
Cell[5607, 163, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5641, 165, 82, 1, 70, "Notes",
 CellID->1067943069],
Cell[5726, 168, 978, 25, 70, "Notes",
 CellID->649193982],
Cell[6707, 195, 633, 10, 70, "Notes",
 CellID->14480980]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7389, 211, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->591971836],
Cell[CellGroupData[{
Cell[7801, 230, 195, 6, 25, "ExampleSection",
 CellID->159231294],
Cell[CellGroupData[{
Cell[8021, 240, 230, 7, 43, "Input",
 CellID->50840935],
Cell[CellGroupData[{
Cell[8276, 251, 142, 2, 22, "Print",
 CellID->4864816],
Cell[8421, 255, 154, 3, 22, "Print",
 CellID->252600442],
Cell[8578, 260, 158, 3, 22, "Print",
 CellID->96614404],
Cell[8739, 265, 161, 3, 22, "Print",
 CellID->207013298]
}, Open  ]]
}, Open  ]],
Cell[8927, 272, 345, 10, 43, "Input",
 CellID->141102975],
Cell[9275, 284, 757, 17, 75, "Input",
 CellID->55424084],
Cell[CellGroupData[{
Cell[10057, 305, 346, 9, 43, "Input",
 CellID->46286282],
Cell[10406, 316, 250, 9, 35, "Output",
 CellID->692707570]
}, Open  ]],
Cell[CellGroupData[{
Cell[10693, 330, 459, 14, 60, "Input",
 CellID->31356969],
Cell[11155, 346, 307, 11, 54, "Output",
 CellID->10340563]
}, Open  ]]
}, Open  ]],
Cell[11489, 361, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11557, 366, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[11830, 380, 671, 18, 70, "SeeAlso",
 CellID->1038487239]
}, Open  ]],
Cell[12516, 401, 23, 0, 70, "FooterCell"]
}
]
*)

