(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     17208,        550]
NotebookOptionsPosition[     11378,        387]
NotebookOutlinePosition[     15434,        484]
CellTagsIndexPosition[     15349,        479]
WindowTitle->QAAddNotScriptedSymbols
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QAResetNotScriptedSymbols\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAResetNotScriptedSymbols"], \
"\<\"QAGetNotScriptedSymbols\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAGetNotScriptedSymbols"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"QuantumAlgebra/ref/QAAddNotScriptedSymbols\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAAddNotScriptedSymbols"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAAddNotScriptedSymbols.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$22678], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAAddNotScriptedSymbols", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAAddNotScriptedSymbols", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QAAddNotScriptedSymbols", "[", 
       RowBox[{
        StyleBox["sym", "TI"], ",", " ", 
        StyleBox["set", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]adds the symbol list sym to the set of Symbols not to \
be used as scripted symbols."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->465832193],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
This set of functions is used to solve a Notation problem. Without using \
them, Mathematica could confuse the use of simple super-scripted symbols with \
the use of Power, especially for integer indices.\
\>", "Notes",
 CellID->1067943069],

Cell["The meaning of the parameters is as follows:", "Notes",
 CellID->5778612],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"sym\"\>", "Notes"], 
     StyleBox[
      RowBox[{
      "The", " ", "sym", " ", "parameter", " ", "must", " ", "be", " ", "a", 
       " ", "list", " ", "of", " ", "symbols"}], "Notes"]},
    {
     StyleBox["\<\"set\"\>", "Notes"], 
     StyleBox[
      RowBox[{"The", " ", "set", " ", "name", " ", "or", " ", 
       RowBox[{"(", 
        RowBox[{
        "Null", " ", "or", " ", "left", " ", "empty", " ", "for", " ", "the", 
         " ", "default", " ", "set"}], ")"}]}], "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False]], "Notes",
 CellID->649193982]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->235674887],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->120905803],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->91566771],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[45]:=",
 CellID->268907597],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[45]:=",
 CellID->44448898],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[45]:=",
 CellID->556606101],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[45]:=",
 CellID->326102286]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Selects", " ", "the", " ", "default", " ", "set"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"QASelectDefault", "[", "\"\<Dirac\>\"", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->25991509],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Define", " ", "Not", " ", "Scripted", " ", "Symbols"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QAAddNotScriptedSymbols", "[", 
    RowBox[{"{", "\[Mu]", "}"}], "]"}], "\[IndentingNewLine]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->478593141],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{"\<\"Dirac\"\>", "\[Rule]", 
   RowBox[{"{", "\[Mu]", "}"}]}], "\[RightAssociation]"}]], "Output",
 ImageSize->{101, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->97938433]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Power", " ", "remains", " ", "Power"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"power", "=", 
   RowBox[{"Power", "[", 
    RowBox[{"\[Mu]", ",", "3"}], "]"}]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->194838828],

Cell[BoxData[
 SuperscriptBox["\[Mu]", "3"]], "Output",
 ImageSize->{17, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->183888600]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"power", "//", "FullForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->126094264],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"Power", "[", 
    RowBox[{"\[Mu]", ",", "3"}], "]"}],
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 ImageSize->{78, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//FullForm=",
 CellID->130678532]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAResetNotScriptedSymbols"]],
    "paclet:QuantumAlgebra/ref/QAResetNotScriptedSymbols"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAGetNotScriptedSymbols"]],
    "paclet:QuantumAlgebra/ref/QAGetNotScriptedSymbols"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->217293345]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAAddNotScriptedSymbols",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 4, 25.6929568}", 
    "history" -> {"2.1.1", "", "", ""}, "context" -> 
    "QuantumAlgebra`Agreements`", 
    "keywords" -> {
     "QAResetNotScriptedSymbols QAAddNotScriptedSymbols \
QAGetNotScriptedSymbols"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAAddNotScriptedSymbols[sym, set] adds the symbol list sym to the set of \
Symbols not to be used as scripted symbols.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "QAAddNotScriptedSymbols", "titlemodifier" -> 
    "", "windowtitle" -> "QAAddNotScriptedSymbols", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QAAddNotScriptedSymbols"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6916, 206, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->235674887]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15206, 472}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[595, 21, 3308, 80, 50, "AnchorBarGrid",
 CellID->1],
Cell[3906, 103, 300, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4231, 118, 499, 14, 80, "Usage"],
Cell[CellGroupData[{
Cell[4755, 136, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->465832193],
Cell[5496, 162, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5530, 164, 250, 5, 70, "Notes",
 CellID->1067943069],
Cell[5783, 171, 79, 1, 70, "Notes",
 CellID->5778612],
Cell[5865, 174, 1002, 26, 70, "Notes",
 CellID->649193982]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6916, 206, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->235674887],
Cell[CellGroupData[{
Cell[7328, 225, 195, 6, 25, "ExampleSection",
 CellID->120905803],
Cell[CellGroupData[{
Cell[7548, 235, 238, 7, 43, "Input",
 CellID->91566771],
Cell[CellGroupData[{
Cell[7811, 246, 144, 2, 22, "Print",
 CellID->268907597],
Cell[7958, 250, 153, 3, 22, "Print",
 CellID->44448898],
Cell[8114, 255, 159, 3, 22, "Print",
 CellID->556606101],
Cell[8276, 260, 161, 3, 22, "Print",
 CellID->326102286]
}, Open  ]]
}, Open  ]],
Cell[8464, 267, 261, 7, 43, "Input",
 CellID->25991509],
Cell[CellGroupData[{
Cell[8750, 278, 329, 9, 59, "Input",
 CellID->478593141],
Cell[9082, 289, 284, 8, 35, "Output",
 CellID->97938433]
}, Open  ]],
Cell[CellGroupData[{
Cell[9403, 302, 285, 9, 43, "Input",
 CellID->194838828],
Cell[9691, 313, 185, 6, 37, "Output",
 CellID->183888600]
}, Open  ]],
Cell[CellGroupData[{
Cell[9913, 324, 104, 3, 26, "Input",
 CellID->126094264],
Cell[10020, 329, 318, 12, 49, "Output",
 CellID->130678532]
}, Open  ]]
}, Open  ]],
Cell[10365, 345, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10433, 350, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[10706, 364, 630, 18, 70, "SeeAlso",
 CellID->217293345]
}, Open  ]],
Cell[11351, 385, 23, 0, 70, "FooterCell"]
}
]
*)

