(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     17075,        534]
NotebookOptionsPosition[     11441,        379]
NotebookOutlinePosition[     15450,        474]
CellTagsIndexPosition[     15365,        469]
WindowTitle->QAAddReplacementRules
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QAResetReplacementRules\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAResetReplacementRules"], \
"\<\"QAGetReplacementRules\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAGetReplacementRules"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"QuantumAlgebra/ref/QAAddReplacementRules\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAAddReplacementRules"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAAddReplacementRules.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$23197], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAAddReplacementRules", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAAddReplacementRules", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       RowBox[{"QAAddReplacementRules", "[", 
        RowBox[{
         StyleBox["rules", "TI"], ",", " ", 
         StyleBox["set", "TI"]}], "]"}], " "}]], "InlineFormula"],
     "\[LineSeparator]adds rules to the given set of Replacement Rules."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->229544387],

Cell["", "SectionHeaderSpacer"],

Cell["The meaning of the parameters is as follows:", "Notes",
 CellID->419725181],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"rules\"\>", "Notes"], 
     StyleBox[
      RowBox[{
      "The", " ", "rules", " ", "parameter", " ", "must", " ", "be", " ", "a",
        " ", "list", " ", "of", " ", "DelayedRule", " ", "rules"}], "Notes"]},
    {
     StyleBox["\<\"set\"\>", "Notes"], 
     StyleBox[
      RowBox[{
      "The", " ", "set", " ", "name", " ", "or", " ", "Null", " ", "or", " ", 
       "left", " ", "empty", " ", "for", " ", "the", " ", "default", " ", 
       "set"}], "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False]], "Notes",
 CellID->12012038]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->336113076],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->150915859],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "QuantumAlgebra`"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->50840935],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[21]:=",
 CellID->40720005],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[21]:=",
 CellID->88308564],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[21]:=",
 CellID->171243403],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[21]:=",
 CellID->134363886]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Declare", " ", "a", " ", "name", " ", "for", " ", "a", " ", "set", " ", 
    "of", " ", "assumptions"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QASelectDefault", "[", "\"\<KleinGordon\>\"", "]"}], 
   ";"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->141102975],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Define", " ", "a", " ", "replacement", " ", "rule", " ", "for", " ", 
    "the", " ", "mass", " ", 
    RowBox[{"invariant", ".", " ", "This"}], " ", "is", " ", "required", " ", 
    "to", " ", "perform", " ", "adequate", " ", 
    RowBox[{"simplifications", ".", " ", "Without"}], " ", "giving", " ", 
    "it", " ", "a", " ", "name", " ", "the", " ", "default", " ", "name", 
    " ", "\"\<KleinGordon\>\"", " ", "is", " ", 
    RowBox[{"used", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QAAddReplacementRules", "[", 
    RowBox[{"{", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Mu]", "^", "2"}], " ", 
       RowBox[{"QASum", "[", 
        RowBox[{"exp_", ",", "k_"}], "]"}]}], "\[RuleDelayed]", 
      RowBox[{"QASum", "[", 
       RowBox[{
        RowBox[{"exp", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            SubscriptBox["k", "0"], "2"], "-", 
           SuperscriptBox[
            SubscriptBox["k", "1"], "2"], "-", 
           SuperscriptBox[
            SubscriptBox["k", "2"], "2"], "-", 
           SuperscriptBox[
            SubscriptBox["k", "3"], "2"]}], ")"}]}], ",", "k"}], "]"}]}], 
     "}"}], "]"}], ";"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->55424084],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QAGetDefault", "[", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->746810559],

Cell[BoxData["\<\"KleinGordon\"\>"], "Output",
 ImageSize->{81, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->74394573]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["$Context"], "Input",
 CellLabel->"In[5]:=",
 CellID->384225886],

Cell[BoxData["\<\"KleinGordon`\"\>"], "Output",
 ImageSize->{88, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->149711990]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAResetReplacementRules"]],
    "paclet:QuantumAlgebra/ref/QAResetReplacementRules"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAGetReplacementRules"]],
    "paclet:QuantumAlgebra/ref/QAGetReplacementRules"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAAddReplacementRules",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 4, 27.5649523}", 
    "history" -> {"2.0.1", "2.1.2", "", ""}, "context" -> 
    "QuantumAlgebra`Agreements`", 
    "keywords" -> {
     "QAResetReplacementRules QAAddReplacementRules QAGetReplacementRules"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAAddReplacementRules[rules, set] adds rules to the given set of \
Replacement Rules.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "QAAddReplacementRules", "titlemodifier" -> "", "windowtitle" -> 
    "QAAddReplacementRules", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QAAddReplacementRules"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6602, 197, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->336113076]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15222, 462}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[593, 21, 3280, 79, 50, "AnchorBarGrid",
 CellID->1],
Cell[3876, 102, 298, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4199, 117, 490, 14, 80, "Usage"],
Cell[CellGroupData[{
Cell[4714, 135, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->229544387],
Cell[5455, 161, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5489, 163, 81, 1, 70, "Notes",
 CellID->419725181],
Cell[5573, 166, 980, 25, 70, "Notes",
 CellID->12012038]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6602, 197, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->336113076],
Cell[CellGroupData[{
Cell[7014, 216, 195, 6, 25, "ExampleSection",
 CellID->150915859],
Cell[CellGroupData[{
Cell[7234, 226, 230, 7, 43, "Input",
 CellID->50840935],
Cell[CellGroupData[{
Cell[7489, 237, 143, 2, 22, "Print",
 CellID->40720005],
Cell[7635, 241, 153, 3, 22, "Print",
 CellID->88308564],
Cell[7791, 246, 159, 3, 22, "Print",
 CellID->171243403],
Cell[7953, 251, 161, 3, 22, "Print",
 CellID->134363886]
}, Open  ]]
}, Open  ]],
Cell[8141, 258, 345, 10, 43, "Input",
 CellID->141102975],
Cell[8489, 270, 1319, 35, 79, "Input",
 CellID->55424084],
Cell[CellGroupData[{
Cell[9833, 309, 103, 3, 26, "Input",
 CellID->746810559],
Cell[9939, 314, 175, 5, 35, "Output",
 CellID->74394573]
}, Open  ]],
Cell[CellGroupData[{
Cell[10151, 324, 77, 2, 26, "Input",
 CellID->384225886],
Cell[10231, 328, 177, 5, 35, "Output",
 CellID->149711990]
}, Open  ]]
}, Open  ]],
Cell[10435, 337, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10503, 342, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[10776, 356, 623, 18, 58, "SeeAlso",
 CellID->1038487239]
}, Open  ]],
Cell[11414, 377, 23, 0, 70, "FooterCell"]
}
]
*)

