(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     17574,        559]
NotebookOptionsPosition[     11980,        408]
NotebookOutlinePosition[     16106,        503]
CellTagsIndexPosition[     16021,        498]
WindowTitle->QACommutatorContract
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Commutator\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Commutator"], "\<\"QACommutatorExpand\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QACommutatorExpand"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"QuantumAlgebra/ref/QACommutatorContract\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QACommutatorContract"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QACommutatorContract.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$24266], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QACommutatorContract", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QACommutatorContract", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QACommutatorContract", "[", 
       StyleBox["expr", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]contracts all expanded commutators in expr. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QACommutatorContract", "[", 
       RowBox[{
        StyleBox["expr", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          TemplateBox[{Cell[
             TextData["A"]],"paclet:ref/A"},
           "RefLink",
           BaseStyle->{"InlineFormula"}], ",", 
          TemplateBox[{Cell[
             TextData["B"]],"paclet:ref/B"},
           "RefLink",
           BaseStyle->{"InlineFormula"}]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]contracts all expanded forms of ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["Commutator"]],"paclet:QuantumAlgebra/ref/Commutator"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", 
       RowBox[{
        TemplateBox[{Cell[
           TextData["A"]],"paclet:ref/A"},
         "RefLink",
         BaseStyle->{"InlineFormula"}], ",", 
        TemplateBox[{Cell[
           TextData["B"]],"paclet:ref/B"},
         "RefLink",
         BaseStyle->{"InlineFormula"}]}], "]"}]], "InlineFormula"],
     " in expr. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QACommutatorContract", "[", 
       RowBox[{
        StyleBox["expr", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            TemplateBox[{Cell[
               TextData["A"]],"paclet:ref/A"},
             "RefLink",
             BaseStyle->{"InlineFormula"}], ",", 
            TemplateBox[{Cell[
               TextData["B"]],"paclet:ref/B"},
             "RefLink",
             BaseStyle->{"InlineFormula"}]}], "}"}], ",", " ", 
          StyleBox["\[Ellipsis]", "TR"]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]performs several commutators' contracts."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->3985134],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->379765790],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Needs", "[", "\"\<QuantumAlgebra`\>\"", "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->150930009],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->251828605],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->32775722],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->299394627],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->751957789]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Enter", " ", "a", " ", "commutator"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"commutator", "=", 
   SubscriptBox[
    RowBox[{"[", 
     RowBox[{
      OverscriptBox["A", "^"], ",", 
      SuperscriptBox[
       OverscriptBox["A", "^"], "\[Dagger]"]}], "]"}], "-"]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->152788841],

Cell[BoxData[
 SubscriptBox[
  RowBox[{"[", 
   RowBox[{
    OverscriptBox["A", "^"], ",", 
    SuperscriptBox[
     OverscriptBox["A", "^"], "\[Dagger]"]}], "]"}], "-"]], "Output",
 ImageSize->{55, 21},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->524247337]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Express", " ", "it", " ", "as", " ", "Full", " ", "Form"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"commutator", "//", "FullForm"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->326583462],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"Commutator", "[", 
    RowBox[{
     RowBox[{"Operator", "[", "A", "]"}], ",", 
     RowBox[{"Operator", "[", 
      RowBox[{"A", ",", "\"\<H\>\""}], "]"}]}], "]"}],
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 ImageSize->{285, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//FullForm=",
 CellID->8096084]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Expand", " ", "the", " ", "commutator"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"expanded", "=", 
   RowBox[{"QACommutatorExpand", "[", "commutator", "]"}]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->321097205],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["A", "^"], "\[CenterDot]", 
   SuperscriptBox[
    OverscriptBox["A", "^"], "\[Dagger]"]}], "-", 
  RowBox[{
   SuperscriptBox[
    OverscriptBox["A", "^"], "\[Dagger]"], "\[CenterDot]", 
   OverscriptBox["A", "^"]}]}]], "Output",
 ImageSize->{79, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->249194425]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Subsequently", " ", "contract", " ", "it", " ", "with", " ", "opposite", 
    " ", "order"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"contracted", "=", 
   RowBox[{"QACommutatorContract", "[", 
    RowBox[{"expanded", ",", 
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox[
        OverscriptBox["A", "^"], "\[Dagger]"], ",", 
       OverscriptBox["A", "^"]}], "}"}]}], "]"}]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->77304245],

Cell[BoxData[
 RowBox[{"-", 
  SubscriptBox[
   RowBox[{"[", 
    RowBox[{
     SuperscriptBox[
      OverscriptBox["A", "^"], "\[Dagger]"], ",", 
     OverscriptBox["A", "^"]}], "]"}], "-"]}]], "Output",
 ImageSize->{63, 21},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->8508742]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Commutator"]],"paclet:QuantumAlgebra/ref/Commutator"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QACommutatorExpand"]],
    "paclet:QuantumAlgebra/ref/QACommutatorExpand"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QACommutatorContract",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 4, 32.0709055}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {"Commutator QACommutatorExpand QACommutatorContract"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QACommutatorContract[expr] contracts all expanded commutators in expr. \
QACommutatorContract[expr, {A, B}] contracts all expanded forms of \
Commutator[A, B] in expr. QACommutatorContract[expr, {{A, B}, ...}] performs \
several commutators' contracts.", "synonyms" -> {}, "tabletags" -> {}, 
    "title" -> "QACommutatorContract", "titlemodifier" -> "", "windowtitle" -> 
    "QACommutatorContract", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QACommutatorContract"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6359, 182, 385, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->3985134]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15880, 491}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 3242, 78, 50, "AnchorBarGrid",
 CellID->1],
Cell[3837, 101, 297, 11, 44, "ObjectNameGrid"],
Cell[4137, 114, 2197, 64, 203, "Usage"],
Cell[CellGroupData[{
Cell[6359, 182, 385, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->3985134],
Cell[CellGroupData[{
Cell[6769, 201, 195, 6, 25, "ExampleSection",
 CellID->379765790],
Cell[CellGroupData[{
Cell[6989, 211, 252, 7, 43, "Input",
 CellID->150930009],
Cell[CellGroupData[{
Cell[7266, 222, 143, 2, 22, "Print",
 CellID->251828605],
Cell[7412, 226, 152, 3, 22, "Print",
 CellID->32775722],
Cell[7567, 231, 158, 3, 22, "Print",
 CellID->299394627],
Cell[7728, 236, 160, 3, 22, "Print",
 CellID->751957789]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7937, 245, 392, 13, 49, "Input",
 CellID->152788841],
Cell[8332, 260, 311, 11, 42, "Output",
 CellID->524247337]
}, Open  ]],
Cell[CellGroupData[{
Cell[8680, 276, 257, 7, 43, "Input",
 CellID->326583462],
Cell[8940, 285, 429, 15, 49, "Output",
 CellID->8096084]
}, Open  ]],
Cell[CellGroupData[{
Cell[9406, 305, 283, 8, 43, "Input",
 CellID->321097205],
Cell[9692, 315, 412, 14, 39, "Output",
 CellID->249194425]
}, Open  ]],
Cell[CellGroupData[{
Cell[10141, 334, 509, 15, 70, "Input",
 CellID->77304245],
Cell[10653, 351, 332, 12, 42, "Output",
 CellID->8508742]
}, Open  ]]
}, Open  ]],
Cell[11012, 367, 31, 0, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11080, 372, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[11353, 386, 585, 17, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[11953, 406, 23, 0, 70, "FooterCell"]
}
]
*)

