(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18910,        626]
NotebookOptionsPosition[     12926,        455]
NotebookOutlinePosition[     16827,        548]
CellTagsIndexPosition[     16742,        543]
WindowTitle->QAD
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QAIntegrate\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAIntegrate"], "\<\"QASum\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/ref/QASum"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/QAD\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAD"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/QAD.\
html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$25314], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAD", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAD", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QAD", "[", 
       RowBox[{
        StyleBox["ex", "TI"], ",", " ", 
        StyleBox["var", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]performs derivation in the context of Quantum Algebra."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1159608],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
QAD is the Quantum Algebra substitute of D, the derivation function of \
Mathematica. It has extra rules for QAIntegrate, QASum, Plus ( + ), Times ( * \
) and NonCommutativeMultiply ( ** ) and also is Listable, meaning it is \
applied to all components of Lists.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
If none of the above rules can be applied, it falls back to the usual D \
function.\
\>", "Notes",
 CellID->231561927],

Cell["\<\
As an example QAD applied to an integral results in application to the \
integrand.\
\>", "Notes",
 CellID->633849418],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"\\!\\(\\*\\nStyleBox[\\\"ex\\\", \\\"TI\\\"]\\)\"\>", 
      "Notes"], 
     StyleBox[
      RowBox[{
      "The", " ", "expression", " ", "which", " ", "to", " ", "derive"}], 
      "Notes"]},
    {
     StyleBox["\<\"\\!\\(\\*\\nStyleBox[\\\"var\\\", \\\"TI\\\"]\\)\"\>", 
      "Notes"], 
     StyleBox[
      RowBox[{"\<\"The variable\"\>", " ", "with", " ", "respect", " ", "to", 
       " ", "which", " ", "ex", " ", "will", " ", "be", " ", "derived"}], 
      "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False]], "Notes",
 CellID->222135989]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->285901898],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->6080023],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->647522450],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[38]:=",
 CellID->108675056],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[38]:=",
 CellID->216176944],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[38]:=",
 CellID->407880695],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[38]:=",
 CellID->63044174]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Define", " ", "an", " ", "integrand"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"integrand", "=", 
   RowBox[{
    SubscriptBox["x", "1"], "*", 
    RowBox[{"Exp", "[", 
     RowBox[{"\[ImaginaryI]", " ", 
      SubscriptBox["x", "2"]}], "]"}]}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->140706306],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{"\[ImaginaryI]", " ", 
    SubscriptBox["x", "2"]}]], " ", 
  SubscriptBox["x", "1"]}]], "Output",
 ImageSize->{46, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->795817900]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Use", " ", "this", " ", "integrand", " ", "to", " ", "define", " ", "an", 
    " ", "integral"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"integral", "=", 
   RowBox[{"QAIntegrate", "[", 
    RowBox[{"integrand", ",", "Infinity", ",", "3", ",", "x"}], 
    "]"}]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->686021315],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Integral]", "\[Infinity]"], 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", 
       SubscriptBox["x", "2"]}]], " ", 
     SubscriptBox["x", "1"]}], ")"}], 
   RowBox[{
    SuperscriptBox["\[DifferentialD]", "3"], "x"}]}]}]], "Output",
 ImageSize->{98, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->278042743]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Subsequently", " ", "derive", " ", "this", " ", "integral", " ", "after", 
    " ", 
    SubscriptBox["x", "2"], " ", "or", " ", 
    SubscriptBox["x", "1"], " ", "or", " ", 
    SubscriptBox["x", "3"]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QAD", "[", 
   RowBox[{"integral", ",", 
    SubscriptBox["x", "2"]}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->383043248],

Cell[BoxData[
 RowBox[{"\[ImaginaryI]", " ", 
  RowBox[{
   SubscriptBox["\[Integral]", "\[Infinity]"], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"\[ImaginaryI]", " ", 
        SubscriptBox["x", "2"]}]], " ", 
      SubscriptBox["x", "1"]}], ")"}], 
    RowBox[{
     SuperscriptBox["\[DifferentialD]", "3"], "x"}]}]}]}]], "Output",
 ImageSize->{108, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->82993956]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QAD", "[", 
  RowBox[{"integral", ",", 
   SubscriptBox["x", "1"]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->571997896],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Integral]", "\[Infinity]"], 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"\[ImaginaryI]", " ", 
     SubscriptBox["x", "2"]}]], 
   RowBox[{
    SuperscriptBox["\[DifferentialD]", "3"], "x"}]}]}]], "Output",
 ImageSize->{68, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->350145415]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QAD", "[", 
  RowBox[{"integral", ",", 
   SubscriptBox["x", "3"]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->73259717],

Cell[BoxData["0"], "Output",
 ImageSize->{11, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->90970614]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAIntegrate"]],"paclet:QuantumAlgebra/ref/QAIntegrate"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QASum"]],"paclet:QuantumAlgebra/ref/QASum"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAD",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 4, 36.2297863}", 
    "history" -> {"2.0.1", "", "", ""}, "context" -> 
    "QuantumAlgebra`RulesSupplement`", 
    "keywords" -> {"QAD QAIntegrate QASum Plus Times NonCommutativeMultiply"},
     "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> 
    True, "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAD[ex, var] performs derivation in the context of Quantum Algebra.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "QAD", "titlemodifier" -> 
    "", "windowtitle" -> "QAD", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QAD"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6867, 211, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->285901898]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 16599, 536}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[575, 21, 3125, 76, 50, "AnchorBarGrid",
 CellID->1],
Cell[3703, 99, 280, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4008, 114, 448, 13, 80, "Usage"],
Cell[CellGroupData[{
Cell[4481, 131, 736, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1159608],
Cell[5220, 157, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5254, 159, 308, 6, 70, "Notes",
 CellID->1067943069],
Cell[5565, 167, 128, 4, 70, "Notes",
 CellID->231561927],
Cell[5696, 173, 128, 4, 70, "Notes",
 CellID->633849418],
Cell[5827, 179, 991, 26, 70, "Notes",
 CellID->222135989]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6867, 211, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->285901898],
Cell[CellGroupData[{
Cell[7279, 230, 193, 6, 25, "ExampleSection",
 CellID->6080023],
Cell[CellGroupData[{
Cell[7497, 240, 239, 7, 43, "Input",
 CellID->647522450],
Cell[CellGroupData[{
Cell[7761, 251, 144, 2, 22, "Print",
 CellID->108675056],
Cell[7908, 255, 154, 3, 22, "Print",
 CellID->216176944],
Cell[8065, 260, 159, 3, 22, "Print",
 CellID->407880695],
Cell[8227, 265, 160, 3, 22, "Print",
 CellID->63044174]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8436, 274, 371, 12, 43, "Input",
 CellID->140706306],
Cell[8810, 288, 300, 10, 37, "Output",
 CellID->795817900]
}, Open  ]],
Cell[CellGroupData[{
Cell[9147, 303, 389, 11, 43, "Input",
 CellID->686021315],
Cell[9539, 316, 476, 16, 54, "Output",
 CellID->278042743]
}, Open  ]],
Cell[CellGroupData[{
Cell[10052, 337, 447, 13, 43, "Input",
 CellID->383043248],
Cell[10502, 352, 521, 17, 54, "Output",
 CellID->82993956]
}, Open  ]],
Cell[CellGroupData[{
Cell[11060, 374, 152, 5, 26, "Input",
 CellID->571997896],
Cell[11215, 381, 396, 13, 54, "Output",
 CellID->350145415]
}, Open  ]],
Cell[CellGroupData[{
Cell[11648, 399, 151, 5, 70, "Input",
 CellID->73259717],
Cell[11802, 406, 157, 5, 35, "Output",
 CellID->90970614]
}, Open  ]]
}, Open  ]],
Cell[11986, 415, 31, 0, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12054, 420, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[12327, 434, 557, 16, 70, "SeeAlso",
 CellID->1038487239]
}, Open  ]],
Cell[12899, 453, 23, 0, 70, "FooterCell"]
}
]
*)

