(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     19875,        629]
NotebookOptionsPosition[     14020,        466]
NotebookOutlinePosition[     18090,        563]
CellTagsIndexPosition[     18005,        558]
WindowTitle->QAInitializeReplacementRules
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QAReplace\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAReplace"], "\<\"QAReplaceRepeated\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAReplaceRepeated"], "\<\"QASelectDefault\"\
\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QASelectDefault"], \
"\<\"QAAddReplacementRules\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAAddReplacementRules"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"QuantumAlgebra/ref/QAInitializeReplacementRules\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAInitializeReplacementRules"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAInitializeReplacementRules.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$30506], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAInitializeReplacementRules", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAInitializeReplacementRules", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QAInitializeReplacementRules", "[", "]"}]], "InlineFormula"],
     "\[LineSeparator]initializes a built-in set of Replacement Rules."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->215288146],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
The added replacement rules are global, e.g. can be used in each Quantum \
Algebra Notebook.\
\>", "Notes",
 CellID->1067943069],

Cell["The following rules will be defined:", "Notes",
 CellID->214383149],

Cell[BoxData[GridBox[{
   {
    StyleBox["\"\<IntegrateSplit\>\"", "Notes"], 
    StyleBox[
     RowBox[{"Splits", " ", "an", " ", "integral", " ", "in", " ", "parts"}], 
     "Notes"]},
   {
    StyleBox["\"\<IntegrateJoin\>\"", "Notes"], 
    StyleBox[
     RowBox[{"Joins", " ", "a", " ", "sum", " ", "of", " ", "integrals"}], 
     "Notes"]},
   {
    StyleBox["\"\<SumSplit\>\"", "Notes"], 
    StyleBox[
     RowBox[{"Splits", " ", "a", " ", "sum", " ", "in", " ", "parts"}], 
     "Notes"]},
   {
    StyleBox["\"\<SumJoin\>\"", "Notes"], 
    StyleBox[
     RowBox[{"Joins", " ", "a", " ", "sum", " ", "of", " ", "sums"}], "Notes"]},
   {
    StyleBox["\"\<DistributionLaw\>\"", "Notes"], 
    StyleBox[
     RowBox[{"Applies", " ", "the", " ", "distribution", " ", "law"}], 
     "Notes"]},
   {
    StyleBox["\"\<FullDistributionLaw\>\"", "Notes"], 
    StyleBox[
     RowBox[{"Applies", " ", "the", " ", "distribution", " ", "law"}], 
     "Notes"]},
   {
    StyleBox["\"\<ReverseDistributionLaw\>\"", "Notes"], 
    StyleBox[
     RowBox[{
     "Applies", " ", "the", " ", "distribution", " ", "law", " ", "in", " ", 
      "reverse", " ", "order"}], "Notes"]},
   {
    StyleBox["\"\<SortVariables\>\"", "Notes"], 
    StyleBox[
     RowBox[{
     "Sorts", " ", "variables", " ", "in", " ", "multiple", " ", "integrals", 
      " ", "and", " ", "other", " ", "expressions"}], "Notes"]}
  },
  AutoDelete->False,
  GridBoxAlignment->{"Columns" -> {{Left}}},
  GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
  GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
  GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
  GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}]], "Notes",
 CellID->629222969]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->269132339],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->688443727],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->91566771],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[30]:=",
 CellID->505799947],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[30]:=",
 CellID->320057310],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[30]:=",
 CellID->86119387],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[30]:=",
 CellID->254133113]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Selects", " ", "the", " ", "default", " ", "set"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"QASelectDefault", "[", "\"\<KleinGordon\>\"", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->25991509],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Defines", " ", "an", " ", "integral", " ", "with", " ", "a", " ", "sum", 
    " ", "of", " ", "3", " ", "sub", " ", "expressions", " ", "as", " ", 
    "integrand"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"integral", "=", 
   RowBox[{"QAIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox["x", "1"], "^", "2"}], "+", 
      RowBox[{
       SubscriptBox["x", "2"], "^", "2"}], "+", 
      RowBox[{
       SubscriptBox["x", "3"], "^", "3"}]}], ",", "Infinity", ",", "3", ",", 
     "x"}], "]"}]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->197329048],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Integral]", "\[Infinity]"], 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SubsuperscriptBox["x", "1", "2"], "+", 
     SubsuperscriptBox["x", "2", "2"], "+", 
     SubsuperscriptBox["x", "3", "3"]}], ")"}], 
   RowBox[{
    SuperscriptBox["\[DifferentialD]", "3"], "x"}]}]}]], "Output",
 ImageSize->{121, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->173626866]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Splits", " ", "the", " ", "integral"}], ",", " ", 
    RowBox[{
    "the", " ", "skew", " ", "symmetric", " ", "part", " ", "disappears"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"sum", "=", 
   RowBox[{"integral", "//", 
    RowBox[{"QAReplace", "[", "\"\<IntegrateSplit\>\"", "]"}]}]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->96494847],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["\[Integral]", "\[Infinity]"], 
   RowBox[{
    SubsuperscriptBox["x", "1", "2"], 
    RowBox[{
     SuperscriptBox["\[DifferentialD]", "3"], "x"}]}]}], "+", 
  RowBox[{
   SubscriptBox["\[Integral]", "\[Infinity]"], 
   RowBox[{
    SubsuperscriptBox["x", "2", "2"], 
    RowBox[{
     SuperscriptBox["\[DifferentialD]", "3"], "x"}]}]}]}]], "Output",
 ImageSize->{119, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->80447198]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Re", "-", 
    RowBox[{"joins", " ", "the", " ", "integrals"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"sum", "//", 
   RowBox[{"QAReplace", "[", "\"\<IntegrateJoin\>\"", "]"}]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->532866949],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Integral]", "\[Infinity]"], 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SubsuperscriptBox["x", "1", "2"], "+", 
     SubsuperscriptBox["x", "2", "2"]}], ")"}], 
   RowBox[{
    SuperscriptBox["\[DifferentialD]", "3"], "x"}]}]}]], "Output",
 ImageSize->{95, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->387572061]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAReplace"]],"paclet:QuantumAlgebra/ref/QAReplace"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAReplaceRepeated"]],
    "paclet:QuantumAlgebra/ref/QAReplaceRepeated"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QASelectDefault"]],"paclet:QuantumAlgebra/ref/QASelectDefault"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAAddReplacementRules"]],
    "paclet:QuantumAlgebra/ref/QAAddReplacementRules"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAInitializeReplacementRules",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 4, 52.9032112}", 
    "history" -> {"2.0.1", "2.1.1", "", ""}, "context" -> 
    "QuantumAlgebra`RulesSupplement`", 
    "keywords" -> {
     "QAInitializeReplacementRules QAReplace QAReplaceRepeated \
QASelectDefault QAAddReplacementRules"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAInitializeReplacementRules[] initializes a built-in set of Replacement \
Rules.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "QAInitializeReplacementRules", "titlemodifier" -> "", "windowtitle" -> 
    "QAInitializeReplacementRules", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QAInitializeReplacementRules"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7647, 227, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->269132339]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 17862, 551}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 3509, 83, 50, "AnchorBarGrid",
 CellID->1],
Cell[4112, 106, 305, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4442, 121, 376, 10, 80, "Usage"],
Cell[CellGroupData[{
Cell[4843, 135, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->215288146],
Cell[5584, 161, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5618, 163, 138, 4, 70, "Notes",
 CellID->1067943069],
Cell[5759, 169, 73, 1, 70, "Notes",
 CellID->214383149],
Cell[5835, 172, 1763, 49, 70, "Notes",
 CellID->629222969]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7647, 227, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->269132339],
Cell[CellGroupData[{
Cell[8059, 246, 195, 6, 25, "ExampleSection",
 CellID->688443727],
Cell[CellGroupData[{
Cell[8279, 256, 238, 7, 43, "Input",
 CellID->91566771],
Cell[CellGroupData[{
Cell[8542, 267, 144, 2, 22, "Print",
 CellID->505799947],
Cell[8689, 271, 154, 3, 22, "Print",
 CellID->320057310],
Cell[8846, 276, 158, 3, 22, "Print",
 CellID->86119387],
Cell[9007, 281, 161, 3, 22, "Print",
 CellID->254133113]
}, Open  ]]
}, Open  ]],
Cell[9195, 288, 267, 7, 43, "Input",
 CellID->25991509],
Cell[CellGroupData[{
Cell[9487, 299, 649, 19, 43, "Input",
 CellID->197329048],
Cell[10139, 320, 460, 15, 54, "Output",
 CellID->173626866]
}, Open  ]],
Cell[CellGroupData[{
Cell[10636, 340, 427, 12, 43, "Input",
 CellID->96494847],
Cell[11066, 354, 532, 18, 54, "Output",
 CellID->80447198]
}, Open  ]],
Cell[CellGroupData[{
Cell[11635, 377, 305, 9, 43, "Input",
 CellID->532866949],
Cell[11943, 388, 414, 14, 54, "Output",
 CellID->387572061]
}, Open  ]]
}, Open  ]],
Cell[12384, 406, 31, 0, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12452, 411, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[12725, 425, 1253, 36, 70, "SeeAlso",
 CellID->1038487239]
}, Open  ]],
Cell[13993, 464, 23, 0, 70, "FooterCell"]
}
]
*)

