(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15199,        482]
NotebookOptionsPosition[      9752,        332]
NotebookOutlinePosition[     13691,        425]
CellTagsIndexPosition[     13606,        420]
WindowTitle->QAIntegrate
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[
    Cell[BoxData[
     ActionMenuBox[
      FrameBox[
       InterpretationBox[Cell[TextData[{
         "URL",
         StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
          StripOnInput->False]
        }]],
        TextCell[
         Row[{"URL", 
           Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
       StripOnInput->False], {"\<\"QuantumAlgebra/ref/QAIntegrate\"\>":>
      None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["QuantumAlgebra/ref/QAIntegrate"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAIntegrate.html"], StandardForm]], "Input", TextClipboardType -> 
             "PlainText"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
            If[
             TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$31037], 
             "http://reference.wolfram.com/system-modeler/", 
             "http://reference.wolfram.com/language/"], 
            "QuantumAlgebra/ref/QAIntegrate", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic,
      MenuStyle->"URLMenu"]],
     LineSpacing->{1.4, 0}]], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAIntegrate", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QAIntegrate", "[", 
       RowBox[{
        StyleBox["ex", "TI"], ",", " ", 
        StyleBox["range", "TI"], ",", " ", 
        StyleBox["dim", "TI"], ",", " ", 
        StyleBox["var", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]defines and eventually simplifies an Integration in the \
context of Quantum Algebra"
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->636744420],

Cell["", "SectionHeaderSpacer"],

Cell["The meaning of the parameters is as follows:", "Notes",
 CellID->1067943069],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"ex\"\>", "Notes"], 
     StyleBox["\<\"The integrand expression\"\>", "Notes"]},
    {
     StyleBox["\<\"range\"\>", "Notes"], 
     StyleBox["\<\"The integration range, may be a range Symbol or Infinity\"\
\>", "Notes"]},
    {
     StyleBox["\<\"dim\"\>", "Notes"], 
     StyleBox["\<\"The dimension of the integration range\"\>", "Notes"]},
    {
     StyleBox["\<\"var\"\>", "Notes"], 
     StyleBox["\<\"The integration variable\"\>", "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output"]], "Notes",
 CellID->56782517]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->356954379],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->175781443],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->647522450],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[21]:=",
 CellID->229054006],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[21]:=",
 CellID->528333757],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[21]:=",
 CellID->117037181],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[21]:=",
 CellID->617775295]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Define", " ", "an", " ", "integral", " ", "in", " ", "full", " ", 
    "form"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"ex", "=", 
   RowBox[{"QAIntegrate", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "^", "2"}], ",", "Infinity", ",", "3", ",", 
     "x"}], "]"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->121809105],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Integral]", "\[Infinity]"], 
  RowBox[{
   SubsuperscriptBox["x", "1", "2"], 
   RowBox[{
    SuperscriptBox["\[DifferentialD]", "3"], "x"}]}]}]], "Output",
 ImageSize->{55, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->31229207]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Display", " ", "the", " ", "FullForm", " ", "where", " ", "you", " ", 
    "can", " ", "see", " ", "the", " ", 
    RowBox[{"script", "'"}], "s", " ", "internal", " ", "format"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"ex", "//", "FullForm"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->224643332],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"QAIntegrate", "[", 
    RowBox[{
     RowBox[{"Power", "[", 
      RowBox[{
       RowBox[{"QASimplescript", "[", 
        RowBox[{"x", ",", "1", ",", "False"}], "]"}], ",", "2"}], "]"}], ",", 
     RowBox[{"DirectedInfinity", "[", "1", "]"}], ",", "3", ",", "x"}], "]"}],
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 ImageSize->{525, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//FullForm=",
 CellID->373232326]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Define", " ", "an", " ", "integral", " ", "with", " ", "skew", " ", 
    "symmetric", " ", "integrand"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QAIntegrate", "[", 
   RowBox[{
    RowBox[{
     SubscriptBox["x", "1"], "^", "3"}], ",", "Infinity", ",", "3", ",", 
    "x"}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->496706337],

Cell[BoxData["0"], "Output",
 ImageSize->{11, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->922889899]
}, Open  ]],

Cell["\<\
The second integral evaluates to 0, because the integrand is skew symmetric \
and the integration range is Infinity.\
\>", "ExampleText",
 CellID->168276617]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAIntegrate",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 4, 54.7413165}", 
    "history" -> {"2.0.1", "2.1.1", "", ""}, "context" -> 
    "QuantumAlgebra`RulesSupplement`", "keywords" -> {"QAIntegrate"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAIntegrate[ex, range, dim, var] defines and eventually simplifies an \
Integration in the context of Quantum Algebra", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "QAIntegrate", "titlemodifier" -> "", 
    "windowtitle" -> "QAIntegrate", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QAIntegrate"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5647, 172, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->356954379]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13463, 413}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[583, 21, 2328, 54, 50, "AnchorBarGrid",
 CellID->1],
Cell[2914, 77, 288, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[3227, 92, 572, 16, 80, "Usage"],
Cell[CellGroupData[{
Cell[3824, 112, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->636744420],
Cell[4565, 138, 31, 0, 70, "SectionHeaderSpacer"],
Cell[4599, 140, 82, 1, 70, "Notes",
 CellID->1067943069],
Cell[4684, 143, 914, 23, 70, "Notes",
 CellID->56782517]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5647, 172, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->356954379],
Cell[CellGroupData[{
Cell[6059, 191, 195, 6, 25, "ExampleSection",
 CellID->175781443],
Cell[CellGroupData[{
Cell[6279, 201, 239, 7, 43, "Input",
 CellID->647522450],
Cell[CellGroupData[{
Cell[6543, 212, 144, 2, 22, "Print",
 CellID->229054006],
Cell[6690, 216, 154, 3, 22, "Print",
 CellID->528333757],
Cell[6847, 221, 159, 3, 22, "Print",
 CellID->117037181],
Cell[7009, 226, 161, 3, 22, "Print",
 CellID->617775295]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7219, 235, 411, 13, 43, "Input",
 CellID->121809105],
Cell[7633, 250, 327, 11, 54, "Output",
 CellID->31229207]
}, Open  ]],
Cell[CellGroupData[{
Cell[7997, 266, 373, 10, 43, "Input",
 CellID->224643332],
Cell[8373, 278, 538, 17, 49, "Output",
 CellID->373232326]
}, Open  ]],
Cell[CellGroupData[{
Cell[8948, 300, 407, 12, 43, "Input",
 CellID->496706337],
Cell[9358, 314, 158, 5, 35, "Output",
 CellID->922889899]
}, Open  ]],
Cell[9531, 322, 167, 4, 47, "ExampleText",
 CellID->168276617]
}, Open  ]]
}, Open  ]],
Cell[9725, 330, 23, 0, 41, "FooterCell"]
}
]
*)

