(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18962,        572]
NotebookOptionsPosition[     13462,        424]
NotebookOutlinePosition[     17557,        521]
CellTagsIndexPosition[     17472,        516]
WindowTitle->QAOptions
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Verbosity\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Verbosity"], "\<\"MaxLines\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/MaxLines"], "\<\"PrintStack\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/PrintStack"], "\<\"StackPattern\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/StackPattern"], "\<\"DefinitionLevel\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/ref/DefinitionLevel"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/QAOptions\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAOptions"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAOptions.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]},
             Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$31558], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAOptions", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAOptions", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QAOptions", "[", 
       StyleBox["options", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]Invoke this to setup options for the application \
different from the default options. 5 Options are defined: the 4 print \
options ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["Verbosity"]],"paclet:QuantumAlgebra/ref/Verbosity"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     ", ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["MaxLines"]],"paclet:QuantumAlgebra/ref/MaxLines"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     ", ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["PrintStack"]],"paclet:QuantumAlgebra/ref/PrintStack"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     ", ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["StackPattern"]],"paclet:QuantumAlgebra/ref/StackPattern"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     " and the ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DefinitionLevel"]],
        "paclet:QuantumAlgebra/ref/DefinitionLevel"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->23759462],

Cell["", "SectionHeaderSpacer"],

Cell["The following options can be given: ", "Notes"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["Verbosity", "Notes"], 
     StyleBox["0", "Notes"], 
     StyleBox[
      RowBox[{"The", " ", "Verbosity", " ", 
       RowBox[{"option", ":", " ", 
        RowBox[{"0", " ", "by", " ", 
         RowBox[{"default", ".", " ", "Defines"}], " ", "the", " ", "Print", 
         " ", "Levels", " ", "to", " ", "print", " ", 
         RowBox[{"out", "."}]}]}]}], "Notes"]},
    {
     StyleBox["MaxLines", "Notes"], 
     StyleBox["Infinity", "Notes"], 
     StyleBox[
      RowBox[{"MaxLines", " ", "->", " ", 
       RowBox[{
        RowBox[{"max", ".", " ", "The"}], " ", "MaxLines", " ", 
        RowBox[{"option", ".", " ", "Infinity"}], "  ", "by", " ", 
        RowBox[{"default", ".", " ", "Restricts"}], " ", "the", " ", "number",
         " ", "of", " ", "printed", " ", "diagnostic", " ", 
        RowBox[{"lines", "."}]}]}], "Notes"]},
    {
     StyleBox["PrintStack", "Notes"], 
     StyleBox["None", "Notes"], 
     StyleBox[
      RowBox[{
       RowBox[{"The", " ", "PrintStack", " ", 
        RowBox[{"option", ":", " ", "None"}]}], ",", " ", "Full", ",", " ", 
       RowBox[{"Recursive", "."}]}], "Notes"]},
    {
     StyleBox["StackPattern", "Notes"], 
     StyleBox["None", "Notes"], 
     StyleBox[
      RowBox[{"The", " ", "StackPattern", " ", 
       RowBox[{"option", ":", " ", 
        RowBox[{"None", " ", "by", " ", 
         RowBox[{"default", "."}]}]}]}], "Notes"]},
    {
     StyleBox["DefinitionLevel", "Notes"], 
     StyleBox["3", "Notes"], 
     StyleBox[
      RowBox[{"DefinitionLevel", " ", "->", " ", 
       RowBox[{
        RowBox[{"lvl", ".", " ", "The"}], " ", "DefinitionLevel", " ", 
        RowBox[{"option", ":", " ", 
         RowBox[{"3", " ", "by", " ", 
          RowBox[{"default", "."}]}]}]}]}], "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Notes",
 CellID->63238343],

Cell["\<\
 This function also resets the number of lines already printed to 0.\
\>", "Notes",
 CellID->58985674]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->450495239],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->510413937],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Needs", "[", "\"\<QuantumAlgebra`\>\"", "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->573325621],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->178716224],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->501957510],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->71329222],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->469564233]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Modifify", " ", "options"}], " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"we", "'"}], "ll", " ", "get", " ", "diagnostics", " ", 
     "printed", " ", "out"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QAOptions", "[", 
   RowBox[{"Verbosity", "\[Rule]", "1"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->302173870],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Verbosity", "\[Rule]", "1"}], ",", 
   RowBox[{"MaxLines", "\[Rule]", "\[Infinity]"}], ",", 
   RowBox[{"PrintStack", "\[Rule]", "None"}], ",", 
   RowBox[{"StackPattern", "\[Rule]", "None"}], ",", 
   RowBox[{"DefinitionLevel", "\[Rule]", "3"}]}], "}"}]], "Output",
 ImageSize->{323, 31},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->381652959]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Verbosity"]],"paclet:QuantumAlgebra/ref/Verbosity"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MaxLines"]],"paclet:QuantumAlgebra/ref/MaxLines"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PrintStack"]],"paclet:QuantumAlgebra/ref/PrintStack"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["StackPattern"]],"paclet:QuantumAlgebra/ref/StackPattern"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DefinitionLevel"]],"paclet:QuantumAlgebra/ref/DefinitionLevel"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAOptions",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 4, 56.5235309}", 
    "history" -> {"2.0.1", "2.1.1", "", ""}, "context" -> 
    "QuantumAlgebra`Options`", 
    "keywords" -> {
     "QAOptions Verbosity MaxLines PrintStack StackPattern DefinitionLevel"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAOptions[options] Invoke this to setup options for the application \
different from the default options. 5 Options are defined: the 4 print \
options Verbosity, MaxLines, PrintStack, StackPattern and the \
DefinitionLevel.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "QAOptions", "titlemodifier" -> "", "windowtitle" -> "QAOptions", "type" -> 
    "Symbol", "uri" -> "QuantumAlgebra/ref/QAOptions"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9091, 265, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->450495239]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 17329, 509}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[581, 21, 3468, 81, 50, "AnchorBarGrid",
 CellID->1],
Cell[4052, 104, 286, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4363, 119, 1519, 44, 97, "Usage"],
Cell[CellGroupData[{
Cell[5907, 167, 737, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->23759462],
Cell[6647, 193, 31, 0, 70, "SectionHeaderSpacer"],
Cell[6681, 195, 53, 0, 70, "Notes"],
Cell[6737, 197, 2190, 57, 70, "Notes",
 CellID->63238343],
Cell[8930, 256, 112, 3, 70, "Notes",
 CellID->58985674]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9091, 265, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->450495239],
Cell[CellGroupData[{
Cell[9503, 284, 195, 6, 25, "ExampleSection",
 CellID->510413937],
Cell[CellGroupData[{
Cell[9723, 294, 252, 7, 43, "Input",
 CellID->573325621],
Cell[CellGroupData[{
Cell[10000, 305, 143, 2, 22, "Print",
 CellID->178716224],
Cell[10146, 309, 153, 3, 22, "Print",
 CellID->501957510],
Cell[10302, 314, 157, 3, 22, "Print",
 CellID->71329222],
Cell[10462, 319, 160, 3, 22, "Print",
 CellID->469564233]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10671, 328, 406, 11, 43, "Input",
 CellID->302173870],
Cell[11080, 341, 449, 12, 52, "Output",
 CellID->381652959]
}, Open  ]]
}, Open  ]],
Cell[11556, 357, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11624, 362, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[11897, 376, 1523, 43, 58, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[13435, 422, 23, 0, 41, "FooterCell"]
}
]
*)

