(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15088,        477]
NotebookOptionsPosition[      9767,        333]
NotebookOutlinePosition[     13779,        427]
CellTagsIndexPosition[     13694,        422]
WindowTitle->QAProductExpand
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QACommutatorExpand\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QACommutatorExpand"], \
"\<\"QAPowerExpand\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAPowerExpand"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/QAProductExpand\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAProductExpand"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAProductExpand.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$34135], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAProductExpand", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAProductExpand", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QAProductExpand", "[", 
       StyleBox["expr", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]expands all non-commutative products of constant terms \
and quantum objects in expr as simple products of constant terms and non \
commutative-products of quantum objects."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->6207591],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->32423637],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Needs", "[", "\"\<QuantumAlgebra`\>\"", "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->349518462],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->146417449],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->49529261],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->120245544],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->91399717]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Distribution", " ", "law", " ", "needs", " ", "no", " ", "extra", " ", 
    "expand", " ", "rule"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"ex1", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      OverscriptBox["A", "^"], "+", 
      OverscriptBox["B", "^"]}], ")"}], "\[CenterDot]", 
    RowBox[{"(", 
     RowBox[{
      OverscriptBox["P", "^"], "+", 
      OverscriptBox["Q", "^"]}], ")"}]}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->313733645],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["A", "^"], "\[CenterDot]", 
   OverscriptBox["P", "^"]}], "+", 
  RowBox[{
   OverscriptBox["A", "^"], "\[CenterDot]", 
   OverscriptBox["Q", "^"]}], "+", 
  RowBox[{
   OverscriptBox["B", "^"], "\[CenterDot]", 
   OverscriptBox["P", "^"]}], "+", 
  RowBox[{
   OverscriptBox["B", "^"], "\[CenterDot]", 
   OverscriptBox["Q", "^"]}]}]], "Output",
 ImageSize->{143, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->23325278]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Perhaps", " ", "QAProductExpand", " ", "is", " ", "obsolete", " ", "as", 
    " ", "this", " ", "sample", " ", "shows"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"ex2", "=", 
   RowBox[{"Pi", "\[CenterDot]", 
    RowBox[{"(", 
     RowBox[{"I", "\[CenterDot]", 
      OverscriptBox["R", "^"]}], ")"}], "\[CenterDot]", 
    OverscriptBox["S", "^"]}]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->158942447],

Cell[BoxData[
 RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
  RowBox[{
   OverscriptBox["R", "^"], "\[CenterDot]", 
   OverscriptBox["S", "^"]}]}]], "Output",
 ImageSize->{50, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->73744121]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ex2", "//", "FullForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->785607203],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"Times", "[", 
    RowBox[{
     RowBox[{"Complex", "[", 
      RowBox[{"0", ",", "1"}], "]"}], ",", "Pi", ",", 
     RowBox[{"NonCommutativeMultiply", "[", 
      RowBox[{
       RowBox[{"Operator", "[", "R", "]"}], ",", 
       RowBox[{"Operator", "[", "S", "]"}]}], "]"}]}], "]"}],
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 ImageSize->{510, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//FullForm=",
 CellID->489630688]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QACommutatorExpand"]],
    "paclet:QuantumAlgebra/ref/QACommutatorExpand"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAPowerExpand"]],"paclet:QuantumAlgebra/ref/QAPowerExpand"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAProductExpand",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 5.4476727}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {"QAProductExpand"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAProductExpand[expr] expands all non-commutative products of constant \
terms and quantum objects in expr as simple products of constant terms and \
non commutative-products of quantum objects.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "QAProductExpand", "titlemodifier" -> "", 
    "windowtitle" -> "QAProductExpand", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QAProductExpand"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4635, 130, 385, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->6207591]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13553, 415}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[587, 21, 3206, 77, 50, "AnchorBarGrid",
 CellID->1],
Cell[3796, 100, 292, 11, 44, "ObjectNameGrid"],
Cell[4091, 113, 519, 13, 94, "Usage"],
Cell[CellGroupData[{
Cell[4635, 130, 385, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->6207591],
Cell[CellGroupData[{
Cell[5045, 149, 194, 6, 25, "ExampleSection",
 CellID->32423637],
Cell[CellGroupData[{
Cell[5264, 159, 252, 7, 43, "Input",
 CellID->349518462],
Cell[CellGroupData[{
Cell[5541, 170, 143, 2, 22, "Print",
 CellID->146417449],
Cell[5687, 174, 152, 3, 22, "Print",
 CellID->49529261],
Cell[5842, 179, 158, 3, 22, "Print",
 CellID->120245544],
Cell[6003, 184, 159, 3, 22, "Print",
 CellID->91399717]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6211, 193, 528, 17, 49, "Input",
 CellID->313733645],
Cell[6742, 212, 528, 18, 39, "Output",
 CellID->23325278]
}, Open  ]],
Cell[CellGroupData[{
Cell[7307, 235, 478, 14, 49, "Input",
 CellID->158942447],
Cell[7788, 251, 287, 9, 39, "Output",
 CellID->73744121]
}, Open  ]],
Cell[CellGroupData[{
Cell[8112, 265, 102, 3, 26, "Input",
 CellID->785607203],
Cell[8217, 270, 549, 18, 49, "Output",
 CellID->489630688]
}, Open  ]]
}, Open  ]],
Cell[8793, 292, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8861, 297, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[9134, 311, 591, 17, 58, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[9740, 331, 23, 0, 70, "FooterCell"]
}
]
*)

