(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     17964,        564]
NotebookOptionsPosition[     12084,        404]
NotebookOutlinePosition[     16278,        502]
CellTagsIndexPosition[     16193,        497]
WindowTitle->QAReplace
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QAReplaceRepeated\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAReplaceRepeated"], "\<\"QASelectDefault\"\
\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QASelectDefault"], \
"\<\"QAAddReplacementRules\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAAddReplacementRules"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/QAReplace\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAReplace"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAReplace.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]},
             Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$34671], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAReplace", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAReplace", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QAReplace", "[", 
       RowBox[{
        StyleBox["ex", "TI"], ",", " ", 
        StyleBox["rules", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]replaces in the expression ex by applying one named set \
of Replacement Rules."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QAReplace", "[", 
       RowBox[{
        StyleBox["ex", "TI"], ",", " ", 
        RowBox[{"{", " ", 
         StyleBox["rules", "TI"], " ", "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]replaces in the expression ex by applying one or more \
named sets of Replacement Rules."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       RowBox[{"QAReplace", "[", 
        StyleBox["rules", "TI"], "]"}], "[", 
       StyleBox["ex", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]is the operator form of the function, can easily be \
used in evaluation chains."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->278451723],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
QAReplace is used instead of ReplaceAll ( /. ). A few replacement rules are \
pre-defined by Quantum Algebra.\
\>", "Notes",
 CellID->1067943069],

Cell["The meaning of the parameters is as follows:", "Notes",
 CellID->419725181],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"ex\"\>", "Notes"], 
     StyleBox["\<\"The expression on which the replacement is to be applied\"\
\>", "Notes"]},
    {
     StyleBox["\<\"rules\"\>", "Notes"], 
     StyleBox[
      RowBox[{
       RowBox[{
       "One", " ", "name", " ", "or", " ", "one", " ", "or", " ", "more", " ",
         "names", " ", "in", " ", "braces"}], ",", " ", 
       RowBox[{
       "each", " ", "for", " ", "one", " ", "named", " ", "set", " ", "of", 
        " ", "replacement", " ", "rules"}]}], "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False]], "Notes",
 CellID->12012038]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->183983202],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->3210721],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->91566771],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[24]:=",
 CellID->180883658],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[24]:=",
 CellID->202214556],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[24]:=",
 CellID->80434097],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[24]:=",
 CellID->237572696]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Selects", " ", "the", " ", "default", " ", "set"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"QASelectDefault", "[", "\"\<KleinGordon\>\"", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->25991509],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Adds", " ", "a", " ", "replacement", " ", "rule", " ", "under", " ", 
    "the", " ", "name", " ", "\"\<sample\>\""}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QAAddReplacementRules", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", "\[RuleDelayed]", " ", "3"}], "}"}], ",", 
     "\"\<sample\>\""}], "]"}], ";"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->104380238],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Defines", " ", "an", " ", "expression"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"ex", " ", "=", " ", 
   RowBox[{"3", " ", "x", " ", "y"}]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->412025834],

Cell[BoxData[
 RowBox[{"3", " ", "x", " ", "y"}]], "Output",
 ImageSize->{31, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->324466645]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Applies", " ", "the", " ", "rules", " ", "defined", " ", "before"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"ex", "//", 
   RowBox[{"QAReplace", "[", "\"\<sample\>\"", "]"}]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->92929731],

Cell[BoxData[
 RowBox[{"9", " ", "y"}]], "Output",
 ImageSize->{21, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->156700847]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAReplaceRepeated"]],
    "paclet:QuantumAlgebra/ref/QAReplaceRepeated"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QASelectDefault"]],"paclet:QuantumAlgebra/ref/QASelectDefault"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAAddReplacementRules"]],
    "paclet:QuantumAlgebra/ref/QAAddReplacementRules"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAReplace",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 7.2658114}", 
    "history" -> {"2.0.1", "2.1.1", "", ""}, "context" -> 
    "QuantumAlgebra`RulesSupplement`", 
    "keywords" -> {
     "QAReplace QAReplaceRepeated QASelectDefault QAAddReplacementRules"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAReplace[ex, rules] replaces in the expression ex by applying one named \
set of Replacement Rules. QAReplace[ex, { rules }] replaces in the expression \
ex by applying one or more named sets of Replacement Rules. \
QAReplace[rules][ex] is the operator form of the function, can easily be used \
in evaluation chains.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "QAReplace", "titlemodifier" -> "", "windowtitle" -> "QAReplace", "type" -> 
    "Symbol", "uri" -> "QuantumAlgebra/ref/QAReplace"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7451, 223, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->183983202]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 16050, 490}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[581, 21, 3302, 79, 50, "AnchorBarGrid",
 CellID->1],
Cell[3886, 102, 286, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4197, 117, 1156, 33, 196, "Usage"],
Cell[CellGroupData[{
Cell[5378, 154, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->278451723],
Cell[6119, 180, 31, 0, 70, "SectionHeaderSpacer"],
Cell[6153, 182, 155, 4, 70, "Notes",
 CellID->1067943069],
Cell[6311, 188, 81, 1, 70, "Notes",
 CellID->419725181],
Cell[6395, 191, 1007, 26, 70, "Notes",
 CellID->12012038]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7451, 223, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->183983202],
Cell[CellGroupData[{
Cell[7863, 242, 193, 6, 25, "ExampleSection",
 CellID->3210721],
Cell[CellGroupData[{
Cell[8081, 252, 238, 7, 43, "Input",
 CellID->91566771],
Cell[CellGroupData[{
Cell[8344, 263, 144, 2, 22, "Print",
 CellID->180883658],
Cell[8491, 267, 154, 3, 22, "Print",
 CellID->202214556],
Cell[8648, 272, 158, 3, 22, "Print",
 CellID->80434097],
Cell[8809, 277, 161, 3, 22, "Print",
 CellID->237572696]
}, Open  ]]
}, Open  ]],
Cell[8997, 284, 267, 7, 43, "Input",
 CellID->25991509],
Cell[9267, 293, 461, 14, 43, "Input",
 CellID->104380238],
Cell[CellGroupData[{
Cell[9753, 311, 266, 8, 43, "Input",
 CellID->412025834],
Cell[10022, 321, 190, 6, 35, "Output",
 CellID->324466645]
}, Open  ]],
Cell[CellGroupData[{
Cell[10249, 332, 304, 9, 43, "Input",
 CellID->92929731],
Cell[10556, 343, 180, 6, 35, "Output",
 CellID->156700847]
}, Open  ]]
}, Open  ]],
Cell[10763, 353, 31, 0, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10831, 358, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[11104, 372, 938, 27, 70, "SeeAlso",
 CellID->1038487239]
}, Open  ]],
Cell[12057, 402, 23, 0, 70, "FooterCell"]
}
]
*)

