(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18158,        562]
NotebookOptionsPosition[     12197,        401]
NotebookOutlinePosition[     16474,        500]
CellTagsIndexPosition[     16389,        495]
WindowTitle->QAReplaceRepeated
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QAReplace\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAReplace"], "\<\"QASelectDefault\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QASelectDefault"], \
"\<\"QAAddReplacementRules\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAAddReplacementRules"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/QAReplaceRepeated\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAReplaceRepeated"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAReplaceRepeated.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$35199], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAReplaceRepeated", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAReplaceRepeated", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QAReplaceRepeated", "[", 
       RowBox[{
        StyleBox["ex", "TI"], ",", " ", 
        StyleBox["rules", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]replaces in the expression ex by applying one named \
set of Replacement Rules repeatedly.\n      ",
     Cell[BoxData[
      RowBox[{"QAReplaceRepeated", "[", 
       RowBox[{
        StyleBox["ex", "TI"], ",", " ", 
        RowBox[{"{", " ", 
         StyleBox["rules", "TI"], " ", "}"}]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]replaces in the expression ex by applying one or more \
named sets of Replacement Rules  repeatedly.\n      ",
     Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"QAReplaceRepeated", "[", 
         StyleBox["rules", "TI"], "]"}], "[", 
        StyleBox["ex", "TI"], "]"}], " "}]], "InlineFormula"],
     "\[LineSeparator]is the operator form of the function, can easily be \
used in evaluation chains."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->613396292],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
QAReplaceRepeated is used instead of ReplaceRepeated ( //. ). It performs \
replacements until no more changes take place. A few replacement rules are \
pre-defined by Quantum Algebra.\
\>", "Notes",
 CellID->158025085],

Cell["The meaning of the parameters is as follows:", "Notes",
 CellID->5835511],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"ex\"\>", "Notes"], 
     StyleBox["\<\"The expression on which the replacement is to be applied\"\
\>", "Notes"]},
    {
     StyleBox["\<\"rules\"\>", "Notes"], 
     StyleBox[
      RowBox[{
       RowBox[{
       "One", " ", "name", " ", "or", " ", "one", " ", "or", " ", "more", " ",
         "names", " ", "in", " ", "braces"}], ",", " ", 
       RowBox[{
       "each", " ", "for", " ", "one", " ", "named", " ", "set", " ", "of", 
        " ", "replacement", " ", "rules"}]}], "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False]], "Notes",
 CellID->21380985]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->586499312],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->64883650],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->91566771],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[24]:=",
 CellID->180883658],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[24]:=",
 CellID->202214556],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[24]:=",
 CellID->80434097],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[24]:=",
 CellID->237572696]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Selects", " ", "the", " ", "default", " ", "set"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"QASelectDefault", "[", "\"\<Dirac\>\"", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->25991509],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Adds", " ", "a", " ", "replacement", " ", "rule", " ", "under", " ", 
    "the", " ", "name", " ", "\"\<sample\>\""}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QAAddReplacementRules", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", "\[RuleDelayed]", " ", "3"}], "}"}], ",", 
     "\"\<sample\>\""}], "]"}], ";"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->104380238],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Defines", " ", "an", " ", "expression"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"ex", " ", "=", " ", 
   RowBox[{"3", " ", "x", " ", "y"}]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->412025834],

Cell[BoxData[
 RowBox[{"3", " ", "x", " ", "y"}]], "Output",
 ImageSize->{31, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->324466645]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Applies", " ", "the", " ", "rules", " ", "defined", " ", "before"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"ex", "//", 
   RowBox[{"QAReplaceRepeated", "[", "\"\<sample\>\"", "]"}]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->92929731],

Cell[BoxData[
 RowBox[{"9", " ", "y"}]], "Output",
 ImageSize->{21, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->156700847]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAReplace"]],"paclet:QuantumAlgebra/ref/QAReplace"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QASelectDefault"]],"paclet:QuantumAlgebra/ref/QASelectDefault"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAAddReplacementRules"]],
    "paclet:QuantumAlgebra/ref/QAAddReplacementRules"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAReplaceRepeated",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 9.1348281}", 
    "history" -> {"2.0.1", "2.1.1", "", ""}, "context" -> 
    "QuantumAlgebra`RulesSupplement`", 
    "keywords" -> {
     "QAReplace QAReplaceRepeated QASelectDefault QAAddReplacementRules"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAReplaceRepeated[ex, rules] replaces in the expression ex by applying \
one named set of Replacement Rules repeatedly. QAReplaceRepeated[ex, { rules \
}] replaces in the expression ex by applying one or more named sets of \
Replacement Rules repeatedly. QAReplaceRepeated[rules][ex] is the operator \
form of the function, can easily be used in evaluation chains.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "QAReplaceRepeated", 
    "titlemodifier" -> "", "windowtitle" -> "QAReplaceRepeated", "type" -> 
    "Symbol", "uri" -> "QuantumAlgebra/ref/QAReplaceRepeated"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7582, 221, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->586499312]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 16246, 488}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[589, 21, 3332, 79, 50, "AnchorBarGrid",
 CellID->1],
Cell[3924, 102, 294, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4243, 117, 1169, 30, 156, "Usage"],
Cell[CellGroupData[{
Cell[5437, 151, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->613396292],
Cell[6178, 177, 31, 0, 70, "SectionHeaderSpacer"],
Cell[6212, 179, 229, 5, 70, "Notes",
 CellID->158025085],
Cell[6444, 186, 79, 1, 70, "Notes",
 CellID->5835511],
Cell[6526, 189, 1007, 26, 70, "Notes",
 CellID->21380985]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7582, 221, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->586499312],
Cell[CellGroupData[{
Cell[7994, 240, 194, 6, 25, "ExampleSection",
 CellID->64883650],
Cell[CellGroupData[{
Cell[8213, 250, 238, 7, 43, "Input",
 CellID->91566771],
Cell[CellGroupData[{
Cell[8476, 261, 144, 2, 22, "Print",
 CellID->180883658],
Cell[8623, 265, 154, 3, 22, "Print",
 CellID->202214556],
Cell[8780, 270, 158, 3, 22, "Print",
 CellID->80434097],
Cell[8941, 275, 161, 3, 22, "Print",
 CellID->237572696]
}, Open  ]]
}, Open  ]],
Cell[9129, 282, 261, 7, 43, "Input",
 CellID->25991509],
Cell[9393, 291, 461, 14, 43, "Input",
 CellID->104380238],
Cell[CellGroupData[{
Cell[9879, 309, 266, 8, 43, "Input",
 CellID->412025834],
Cell[10148, 319, 190, 6, 35, "Output",
 CellID->324466645]
}, Open  ]],
Cell[CellGroupData[{
Cell[10375, 330, 312, 9, 43, "Input",
 CellID->92929731],
Cell[10690, 341, 180, 6, 35, "Output",
 CellID->156700847]
}, Open  ]]
}, Open  ]],
Cell[10897, 351, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10965, 356, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[11238, 370, 917, 26, 70, "SeeAlso",
 CellID->1038487239]
}, Open  ]],
Cell[12170, 399, 23, 0, 70, "FooterCell"]
}
]
*)

