(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18184,        570]
NotebookOptionsPosition[     12430,        409]
NotebookOutlinePosition[     16469,        506]
CellTagsIndexPosition[     16384,        501]
WindowTitle->QAResetNotScriptedSymbols
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QAAddNotScriptedSymbols\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAAddNotScriptedSymbols"], \
"\<\"QAGetNotScriptedSymbols\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAGetNotScriptedSymbols"], \
"\<\"QAReset\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAReset"], "\<\"QAResetAssumptions\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAResetAssumptions"], \
"\<\"QAResetExplicitIntegrationVariables\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAResetExplicitIntegrationVariables"], \
"\<\"QAResetReplacementRules\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAResetReplacementRules"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"QuantumAlgebra/ref/QAResetNotScriptedSymbols\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QAResetNotScriptedSymbols"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QAResetNotScriptedSymbols.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$37289], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QAResetNotScriptedSymbols", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QAResetNotScriptedSymbols", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       RowBox[{"QAResetNotScriptedSymbols", "[", 
        StyleBox["set", "TI"], "]"}], " "}]], "InlineFormula"],
     "\[LineSeparator]resets the set of Symbols not to be used as scripted \
symbols."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->166393315],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
The demonstration given here (see below) is exemplary for a series of \
function sets. With the Add function, we add to the default set, with Get we \
query the default set and with Reset we can reset it to an empty set.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
An exception is the set of replacement rules. The predefined rules cannot be \
reset.\
\>", "Notes",
 CellID->406958900]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->26314229],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->641095240],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->412563583],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[32]:=",
 CellID->348259150],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[32]:=",
 CellID->146934814],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[32]:=",
 CellID->373116702],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[32]:=",
 CellID->39711198]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Selects", " ", "\"\<Test\>\"", " ", "as", " ", "the", " ", "default", " ",
     "set"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QASelectDefault", "[", "\"\<Test\>\"", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->606669950],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Adds", " ", "to", " ", "the", " ", "list", " ", "of", " ", "not", " ", 
    "scripted", " ", "symbols"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QAAddNotScriptedSymbols", "[", 
   RowBox[{"{", "\[Mu]", "}"}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->134475427],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{"\<\"Test\"\>", "\[Rule]", 
   RowBox[{"{", "\[Mu]", "}"}]}], "\[RightAssociation]"}]], "Output",
 ImageSize->{94, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->636714805]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Resets", " ", "the", " ", "list"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"QAResetNotScriptedSymbols", "[", "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->182595387],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{"\<\"Test\"\>", "\[Rule]", 
   RowBox[{"{", "}"}]}], "\[RightAssociation]"}]], "Output",
 ImageSize->{87, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->636964476]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Queries", " ", "the", " ", "list"}], " ", "\[Rule]", " ", 
    RowBox[{"it", " ", "is", " ", "now", " ", "empty", " ", "again"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QAGetNotScriptedSymbols", "[", "]"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->98407742],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 ImageSize->{18, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->7122392]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAAddNotScriptedSymbols"]],
    "paclet:QuantumAlgebra/ref/QAAddNotScriptedSymbols"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAGetNotScriptedSymbols"]],
    "paclet:QuantumAlgebra/ref/QAGetNotScriptedSymbols"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAReset"]],"paclet:QuantumAlgebra/ref/QAReset"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAResetAssumptions"]],
    "paclet:QuantumAlgebra/ref/QAResetAssumptions"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAResetExplicitIntegrationVariables"]],
    "paclet:QuantumAlgebra/ref/QAResetExplicitIntegrationVariables"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAResetReplacementRules"]],
    "paclet:QuantumAlgebra/ref/QAResetReplacementRules"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QAResetNotScriptedSymbols",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 14.6560531}", 
    "history" -> {"2.1.1", "", "", ""}, "context" -> 
    "QuantumAlgebra`Agreements`", 
    "keywords" -> {
     "QAResetNotScriptedSymbols QAAddNotScriptedSymbols \
QAGetNotScriptedSymbols"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QAResetNotScriptedSymbols[set] resets the set of Symbols not to be used \
as scripted symbols.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "QAResetNotScriptedSymbols", "titlemodifier" -> "", "windowtitle" -> 
    "QAResetNotScriptedSymbols", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QAResetNotScriptedSymbols"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6414, 188, 386, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->26314229]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 16242, 494}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[597, 21, 3796, 88, 50, "AnchorBarGrid",
 CellID->1],
Cell[4396, 111, 302, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4723, 126, 443, 13, 80, "Usage"],
Cell[CellGroupData[{
Cell[5191, 143, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->166393315],
Cell[5932, 169, 31, 0, 70, "SectionHeaderSpacer"],
Cell[5966, 171, 266, 5, 70, "Notes",
 CellID->1067943069],
Cell[6235, 178, 130, 4, 70, "Notes",
 CellID->406958900]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6414, 188, 386, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->26314229],
Cell[CellGroupData[{
Cell[6825, 207, 195, 6, 25, "ExampleSection",
 CellID->641095240],
Cell[CellGroupData[{
Cell[7045, 217, 239, 7, 43, "Input",
 CellID->412563583],
Cell[CellGroupData[{
Cell[7309, 228, 144, 2, 22, "Print",
 CellID->348259150],
Cell[7456, 232, 154, 3, 22, "Print",
 CellID->146934814],
Cell[7613, 237, 159, 3, 22, "Print",
 CellID->373116702],
Cell[7775, 242, 160, 3, 22, "Print",
 CellID->39711198]
}, Open  ]]
}, Open  ]],
Cell[7962, 249, 299, 8, 43, "Input",
 CellID->606669950],
Cell[CellGroupData[{
Cell[8286, 261, 341, 9, 43, "Input",
 CellID->134475427],
Cell[8630, 272, 283, 8, 35, "Output",
 CellID->636714805]
}, Open  ]],
Cell[CellGroupData[{
Cell[8950, 285, 239, 7, 43, "Input",
 CellID->182595387],
Cell[9192, 294, 274, 8, 35, "Output",
 CellID->636964476]
}, Open  ]],
Cell[CellGroupData[{
Cell[9503, 307, 346, 9, 43, "Input",
 CellID->98407742],
Cell[9852, 318, 173, 6, 35, "Output",
 CellID->7122392]
}, Open  ]]
}, Open  ]],
Cell[10052, 328, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10120, 333, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[10393, 347, 1995, 57, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[12403, 407, 23, 0, 70, "FooterCell"]
}
]
*)

