(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18947,        602]
NotebookOptionsPosition[     13406,        455]
NotebookOutlinePosition[     17626,        552]
CellTagsIndexPosition[     17541,        547]
WindowTitle->QASeries
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Operator\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Operator"], "\<\"Commutator\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/ref/Commutator"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/QASeries\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QASeries"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QASeries.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$38903], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QASeries", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QASeries", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QASeries", "[", 
       RowBox[{
        StyleBox["expr", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          TemplateBox[{Cell[
             TextData["A"]],"paclet:ref/A"},
           "RefLink",
           BaseStyle->{"InlineFormula"}], ",", 
          TemplateBox[{Cell[
             TextData["B"]],"paclet:ref/B"},
           "RefLink",
           BaseStyle->{"InlineFormula"}], ",", 
          StyleBox["n", "TI"]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]expands the operator expr depending only on A, in power \
series of A around the operator B up to order n. The operator B must be of \
the form c ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["Operator"]],"paclet:QuantumAlgebra/ref/Operator"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", "1", "]"}]], "InlineFormula"],
     " or ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["Operator"]],"paclet:QuantumAlgebra/ref/Operator"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", "0", "]"}]], "InlineFormula"],
     " (zero). "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       RowBox[{"QASeries", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           TemplateBox[{Cell[
              TextData["Exp"]],"paclet:ref/Exp"},
            "RefLink",
            BaseStyle->{"InlineFormula"}], "[", 
           TemplateBox[{Cell[
              TextData["A"]],"paclet:ref/A"},
            "RefLink",
            BaseStyle->{"InlineFormula"}], "]"}], " ", "**", " ", 
          TemplateBox[{Cell[
             TextData["B"]],"paclet:ref/B"},
           "RefLink",
           BaseStyle->{"InlineFormula"}], " ", "**", " ", 
          RowBox[{
           TemplateBox[{Cell[
              TextData["Exp"]],"paclet:ref/Exp"},
            "RefLink",
            BaseStyle->{"InlineFormula"}], "[", 
           RowBox[{"-", 
            TemplateBox[{Cell[
               TextData["A"]],"paclet:ref/A"},
             "RefLink",
             BaseStyle->{"InlineFormula"}]}], "]"}]}], ",", " ", 
         StyleBox["n", "TI"]}], "]"}], " "}]], "InlineFormula"],
     "\[LineSeparator]expands the first argument as a series expansion in \
terms of operators A and B up to n terms. ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["QASeries"]],"paclet:QuantumAlgebra/ref/QASeries"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     " does not return a series object, but a polynomial on operator A."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->176155710],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1714863],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->381283919],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->531019051],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->75600276],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->528940572],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[8]:=",
 CellID->533846200]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"First", " ", "define", " ", "an", " ", "operator"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"exp", "=", 
   RowBox[{"Exp", "[", 
    RowBox[{"\[ImaginaryI]", " ", 
     OverscriptBox["X", "^"]}], "]"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->502779820],

Cell[BoxData[
 SuperscriptBox["\[ExponentialE]", 
  RowBox[{"\[ImaginaryI]", " ", 
   OverscriptBox["X", "^"]}]]], "Output",
 ImageSize->{24, 21},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->350181647]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Then", " ", "determine", " ", "the", " ", "power", " ", "series"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QASeries", "[", 
   RowBox[{"exp", ",", 
    RowBox[{"{", 
     RowBox[{
      OverscriptBox["X", "^"], ",", 
      OverscriptBox["1", "^"], ",", "4"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->372477953],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["\[ExponentialE]", "\[ImaginaryI]"], " ", 
   OverscriptBox["1", "^"]}], "+", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SuperscriptBox["\[ExponentialE]", "\[ImaginaryI]"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       OverscriptBox["1", "^"]}], "+", 
      OverscriptBox["X", "^"]}], ")"}]}], 
   TagBox[
    RowBox[{"1", "!"}],
    HoldForm]], "-", 
  FractionBox[
   RowBox[{
    SuperscriptBox["\[ExponentialE]", "\[ImaginaryI]"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        OverscriptBox["1", "^"]}], "+", 
       OverscriptBox["X", "^"]}], ")"}], "2"]}], 
   TagBox[
    RowBox[{"2", "!"}],
    HoldForm]], "-", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SuperscriptBox["\[ExponentialE]", "\[ImaginaryI]"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        OverscriptBox["1", "^"]}], "+", 
       OverscriptBox["X", "^"]}], ")"}], "3"]}], 
   TagBox[
    RowBox[{"3", "!"}],
    HoldForm]], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox["\[ExponentialE]", "\[ImaginaryI]"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        OverscriptBox["1", "^"]}], "+", 
       OverscriptBox["X", "^"]}], ")"}], "4"]}], 
   TagBox[
    RowBox[{"4", "!"}],
    HoldForm]]}]], "Output",
 ImageSize->{394, 40},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->345256416]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Apply", " ", "the", " ", "other", " ", "form", " ", "of", " ", "series"}],
    " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QASeries", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{"\[ImaginaryI]", " ", 
       OverscriptBox["X", "^"]}], "]"}], "\[CenterDot]", 
     OverscriptBox["Q", "^"], "\[CenterDot]", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", 
       OverscriptBox["X", "^"]}], "]"}]}], ",", "3"}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->784330253],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SubscriptBox[
     RowBox[{"[", 
      RowBox[{
       OverscriptBox["X", "^"], ",", 
       OverscriptBox["Q", "^"]}], "]"}], "-"]}], 
   TagBox[
    RowBox[{"1", "!"}],
    HoldForm]], "-", 
  FractionBox[
   SubscriptBox[
    RowBox[{"[", 
     RowBox[{
      OverscriptBox["X", "^"], ",", 
      SubscriptBox[
       RowBox[{"[", 
        RowBox[{
         OverscriptBox["X", "^"], ",", 
         OverscriptBox["Q", "^"]}], "]"}], "-"]}], "]"}], "-"], 
   TagBox[
    RowBox[{"2", "!"}],
    HoldForm]], "+", 
  FractionBox[
   OverscriptBox["Q", "^"], 
   TagBox[
    RowBox[{"0", "!"}],
    HoldForm]]}]], "Output",
 ImageSize->{196, 39},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->12261877]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Operator"]],"paclet:QuantumAlgebra/ref/Operator"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Commutator"]],"paclet:QuantumAlgebra/ref/Commutator"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QASeries",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 19.1470469}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {"QASeries Operator Commutator"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QASeries[expr, {A, B, n}] expands the operator expr depending only on A, \
in power series of A around the operator B up to order n. The operator B must \
be of the form c Operator[1] or Operator[0] (zero). QASeries[Exp[A] ** B ** \
Exp[-A], n] expands the first argument as a series expansion in terms of \
operators A and B up to n terms. QASeries does not return a series object, \
but a polynomial on operator A.", "synonyms" -> {}, "tabletags" -> {}, 
    "title" -> "QASeries", "titlemodifier" -> "", "windowtitle" -> "QASeries",
     "type" -> "Symbol", "uri" -> "QuantumAlgebra/ref/QASeries"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6842, 193, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->176155710]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 17398, 540}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[580, 21, 3140, 75, 50, "AnchorBarGrid",
 CellID->1],
Cell[3723, 98, 285, 11, 44, "ObjectNameGrid"],
Cell[4011, 111, 2806, 78, 176, "Usage"],
Cell[CellGroupData[{
Cell[6842, 193, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->176155710],
Cell[CellGroupData[{
Cell[7254, 212, 193, 6, 25, "ExampleSection",
 CellID->1714863],
Cell[CellGroupData[{
Cell[7472, 222, 239, 7, 43, "Input",
 CellID->381283919],
Cell[CellGroupData[{
Cell[7736, 233, 143, 2, 22, "Print",
 CellID->531019051],
Cell[7882, 237, 152, 3, 22, "Print",
 CellID->75600276],
Cell[8037, 242, 158, 3, 22, "Print",
 CellID->528940572],
Cell[8198, 247, 160, 3, 22, "Print",
 CellID->533846200]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8407, 256, 328, 10, 49, "Input",
 CellID->502779820],
Cell[8738, 268, 254, 8, 42, "Output",
 CellID->350181647]
}, Open  ]],
Cell[CellGroupData[{
Cell[9029, 281, 405, 13, 49, "Input",
 CellID->372477953],
Cell[9437, 296, 1530, 56, 61, "Output",
 CellID->345256416]
}, Open  ]],
Cell[CellGroupData[{
Cell[11004, 357, 601, 18, 49, "Input",
 CellID->784330253],
Cell[11608, 377, 828, 34, 60, "Output",
 CellID->12261877]
}, Open  ]]
}, Open  ]],
Cell[12463, 415, 31, 0, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12531, 420, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[12804, 434, 560, 16, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[13379, 453, 23, 0, 70, "FooterCell"]
}
]
*)

