(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     26322,        801]
NotebookOptionsPosition[     20055,        640]
NotebookOutlinePosition[     24741,        743]
CellTagsIndexPosition[     24656,        738]
WindowTitle->QASet
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QAClear\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAClear"], "\<\"Commutator\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Commutator"], "\<\"Ket\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/ref/Ket"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/QASet\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QASet"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QASet.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$40059], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QASet", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QASet", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QASet", "[", 
       RowBox[{
        SubscriptBox[
         StyleBox["expr", "TI"], 
         StyleBox["1", "TR"]], " ", "=", " ", 
        SubscriptBox[
         StyleBox["expr", "TI"], 
         StyleBox["2", "TR"]]}], "]"}]], "InlineFormula"],
     " and"
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QASet", "[", 
       RowBox[{
        SubscriptBox[
         StyleBox["expr", "TI"], 
         StyleBox["1", "TR"]], " ", ":=", " ", 
        SubscriptBox[
         StyleBox["expr", "TI"], 
         StyleBox["2", "TR"]]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]where expr1 and expr2 involve quantum objects like \
operators, bras, kets, ... . First evaluates the Set and SetDelayed \
operations as given in its argument. After that, QASet tries to set up \
definitions that can be deduced from the first relation. \[LineSeparator]For \
example if we evaluate ",
     Cell[BoxData[
      RowBox[{"QASet", "[", " ", 
       RowBox[{
        RowBox[{
         TemplateBox[{Cell[
            TextData["Commutator"]],"paclet:QuantumAlgebra/ref/Commutator"},
          "RefLink",
          BaseStyle->{"InlineFormula"}], "[", 
         RowBox[{
          TemplateBox[{Cell[
             TextData["A"]],"paclet:ref/A"},
           "RefLink",
           BaseStyle->{"InlineFormula"}], ",", 
          TemplateBox[{Cell[
             TextData["B"]],"paclet:ref/B"},
           "RefLink",
           BaseStyle->{"InlineFormula"}]}], "]"}], " ", "=", " ", 
        TemplateBox[{Cell[
           TextData["C"]],"paclet:ref/C"},
         "RefLink",
         BaseStyle->{"InlineFormula"}]}], " ", "]"}]], "InlineFormula"],
     " then the argument is evaluated in the usual way. But from this set it \
can be deduced that ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["Commutator"]],"paclet:QuantumAlgebra/ref/Commutator"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", 
       RowBox[{
        TemplateBox[{Cell[
           TextData["B"]],"paclet:ref/B"},
         "RefLink",
         BaseStyle->{"InlineFormula"}], ",", 
        TemplateBox[{Cell[
           TextData["A"]],"paclet:ref/A"},
         "RefLink",
         BaseStyle->{"InlineFormula"}]}], "]"}]], "InlineFormula"],
     " = -C, so QASet also does this assignment. \[LineSeparator]QASet can \
handle the following definitions: "
    }]]},
   {"", Cell[TextData[Cell[BoxData[
     RowBox[{"QASet", "[", " ", 
      RowBox[{
       RowBox[{"Com", "[", 
        RowBox[{"A", ",", " ", "B"}], "]"}], " ", "=", " ", "expr"}], "]"}]], 
     "InlineFormula"]]]},
   {"", Cell[TextData[Cell[BoxData[
     RowBox[{"QASet", "[", " ", 
      RowBox[{
       RowBox[{
        TemplateBox[{Cell[
           TextData["Com"]],"paclet:ref/Com"},
         "RefLink",
         BaseStyle->{"InlineFormula"}], "[", 
        RowBox[{
         TemplateBox[{Cell[
            TextData["A"]],"paclet:ref/A"},
          "RefLink",
          BaseStyle->{"InlineFormula"}], ",", 
         RowBox[{
          TemplateBox[{Cell[
             TextData["Com"]],"paclet:ref/Com"},
           "RefLink",
           BaseStyle->{"InlineFormula"}], "[", 
          RowBox[{
           TemplateBox[{Cell[
              TextData["A"]],"paclet:ref/A"},
            "RefLink",
            BaseStyle->{"InlineFormula"}], ",", 
           TemplateBox[{Cell[
              TextData["B"]],"paclet:ref/B"},
            "RefLink",
            BaseStyle->{"InlineFormula"}]}], "]"}]}], "]"}], " ", "=", " ", 
       StyleBox["expr", "TI"]}], " ", "]"}]], "InlineFormula"]]]},
   {"", Cell[TextData[Cell[BoxData[
     RowBox[{"QASet", "[", " ", 
      RowBox[{
       RowBox[{
        TemplateBox[{Cell[
           TextData["Com"]],"paclet:ref/Com"},
         "RefLink",
         BaseStyle->{"InlineFormula"}], "[", 
        RowBox[{
         RowBox[{
          TemplateBox[{Cell[
             TextData["Com"]],"paclet:ref/Com"},
           "RefLink",
           BaseStyle->{"InlineFormula"}], "[", 
          RowBox[{
           TemplateBox[{Cell[
              TextData["A"]],"paclet:ref/A"},
            "RefLink",
            BaseStyle->{"InlineFormula"}], ",", 
           TemplateBox[{Cell[
              TextData["B"]],"paclet:ref/B"},
            "RefLink",
            BaseStyle->{"InlineFormula"}]}], "]"}], ",", 
         RowBox[{
          TemplateBox[{Cell[
             TextData["Com"]],"paclet:ref/Com"},
           "RefLink",
           BaseStyle->{"InlineFormula"}], "[", 
          RowBox[{
           TemplateBox[{Cell[
              TextData["C"]],"paclet:ref/C"},
            "RefLink",
            BaseStyle->{"InlineFormula"}], ",", 
           TemplateBox[{Cell[
              TextData["D"]],"paclet:ref/D"},
            "RefLink",
            BaseStyle->{"InlineFormula"}]}], "]"}]}], "]"}], " ", "=", " ", 
       StyleBox["expr", "TI"]}], " ", "]"}]], "InlineFormula"]]]},
   {"", Cell[TextData[Cell[BoxData[
     RowBox[{"QASet", "[", " ", 
      RowBox[{
       RowBox[{
        RowBox[{
         TemplateBox[{Cell[
            TextData["Com"]],"paclet:ref/Com"},
          "RefLink",
          BaseStyle->{"InlineFormula"}], "[", 
         RowBox[{
          TemplateBox[{Cell[
             TextData["A"]],"paclet:ref/A"},
           "RefLink",
           BaseStyle->{"InlineFormula"}], ",", 
          RowBox[{
           TemplateBox[{Cell[
              TextData["Com"]],"paclet:ref/Com"},
            "RefLink",
            BaseStyle->{"InlineFormula"}], "[", 
           RowBox[{
            TemplateBox[{Cell[
               TextData["A"]],"paclet:ref/A"},
             "RefLink",
             BaseStyle->{"InlineFormula"}], ",", 
            TemplateBox[{Cell[
               TextData["B"]],"paclet:ref/B"},
             "RefLink",
             BaseStyle->{"InlineFormula"}]}], "]"}]}], "]"}], " ", "=", " ", 
        "0"}], ",", " ", 
       RowBox[{
        RowBox[{
         TemplateBox[{Cell[
            TextData["Com"]],"paclet:ref/Com"},
          "RefLink",
          BaseStyle->{"InlineFormula"}], "[", 
         RowBox[{
          TemplateBox[{Cell[
             TextData["B"]],"paclet:ref/B"},
           "RefLink",
           BaseStyle->{"InlineFormula"}], ",", 
          RowBox[{
           TemplateBox[{Cell[
              TextData["Com"]],"paclet:ref/Com"},
            "RefLink",
            BaseStyle->{"InlineFormula"}], "[", 
           RowBox[{
            TemplateBox[{Cell[
               TextData["A"]],"paclet:ref/A"},
             "RefLink",
             BaseStyle->{"InlineFormula"}], ",", 
            TemplateBox[{Cell[
               TextData["B"]],"paclet:ref/B"},
             "RefLink",
             BaseStyle->{"InlineFormula"}]}], "]"}]}], "]"}], " ", "=", " ", 
        "0"}]}], " ", "]"}]], "InlineFormula"]]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QASet", "[", " ", 
       RowBox[{
        RowBox[{
         TemplateBox[{Cell[
            TextData["A"]],"paclet:ref/A"},
          "RefLink",
          BaseStyle->{"InlineFormula"}], " ", "**", " ", 
         RowBox[{
          TemplateBox[{Cell[
             TextData["Ket"]],"paclet:ref/Ket"},
           "RefLink",
           BaseStyle->{"InlineFormula"}], "[", 
          StyleBox["n", "TI"], "]"}]}], " ", "=", " ", 
        RowBox[{
         StyleBox["a", "TI"], " ", 
         RowBox[{
          TemplateBox[{Cell[
             TextData["Ket"]],"paclet:ref/Ket"},
           "RefLink",
           BaseStyle->{"InlineFormula"}], "[", 
          StyleBox["n", "TI"], "]"}]}]}], " ", "]"}]], "InlineFormula"],
     "\[LineSeparator]where A, B, C, D are operators and Com means ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["Commutator"]],"paclet:QuantumAlgebra/ref/Commutator"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     ". Also := can be used  instead of = if necessary. For a full discussion \
see QuantumAlgebra.nb Section 8. "
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, None, None, None, {None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->101360478],

Cell["", "SectionHeaderSpacer"],

Cell["Use QAClear to remove a definition established with QASet", "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->175295144],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->7944612],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->158584138],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[48]:=",
 CellID->860005776],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[48]:=",
 CellID->64219092],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[48]:=",
 CellID->147949717],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[48]:=",
 CellID->8362696]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Define", " ", "a", " ", "relation", " ", "with", " ", "QASet"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QASet", "[", 
   RowBox[{
    RowBox[{
     OverscriptBox["H", "^"], "\[CenterDot]", 
     TagBox[
      RowBox[{
       AdjustmentBox["\[VerticalSeparator]",
        BoxMargins->{{-0.4, 0.}, {0, 0}}], 
       AdjustmentBox[
        TagBox["\[Psi]",
         QuantumAlgebra`QuantumNotation`KetArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0], "\[RightAngleBracket]"}],
      QuantumAlgebra`Ket,
      BaseStyle->"KetWrapper"]}], "=", 
    RowBox[{"En", " ", 
     TagBox[
      RowBox[{
       AdjustmentBox["\[VerticalSeparator]",
        BoxMargins->{{-0.4, 0.}, {0, 0}}], 
       AdjustmentBox[
        TagBox["\[Psi]",
         QuantumAlgebra`QuantumNotation`KetArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0], "\[RightAngleBracket]"}],
      QuantumAlgebra`Ket,
      BaseStyle->"KetWrapper"]}]}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->4392825],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Try", " ", "an", " ", "expression", " ", "with", " ", "right", " ", 
    "hand", " ", "side"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   OverscriptBox["H", "^"], "\[CenterDot]", 
   TagBox[
    RowBox[{
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{-0.4, 0.}, {0, 0}}], 
     AdjustmentBox[
      TagBox["\[Psi]",
       QuantumAlgebra`QuantumNotation`KetArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], "\[RightAngleBracket]"}],
    QuantumAlgebra`Ket,
    BaseStyle->"KetWrapper"]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->552250],

Cell[BoxData[
 RowBox[{"En", " ", 
  TagBox[
   RowBox[{
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{-0.4, 0.}, {0, 0}}], 
    AdjustmentBox[
     TagBox["\[Psi]",
      QuantumAlgebra`QuantumNotation`KetArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], "\[RightAngleBracket]"}],
   QuantumAlgebra`Ket,
   BaseStyle->"KetWrapper"]}]], "Output",
 ImageSize->{46, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->99786640]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Delete", " ", "relation", " ", "and", " ", "try", " ", "again"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QAClear", "[", 
   RowBox[{
    RowBox[{
     OverscriptBox["H", "^"], "\[CenterDot]", 
     TagBox[
      RowBox[{
       AdjustmentBox["\[VerticalSeparator]",
        BoxMargins->{{-0.4, 0.}, {0, 0}}], 
       AdjustmentBox[
        TagBox["\[Psi]",
         QuantumAlgebra`QuantumNotation`KetArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0], "\[RightAngleBracket]"}],
      QuantumAlgebra`Ket,
      BaseStyle->"KetWrapper"]}], "=."}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->102362766],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  OverscriptBox["H", "^"], "\[CenterDot]", 
  TagBox[
   RowBox[{
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{-0.4, 0.}, {0, 0}}], 
    AdjustmentBox[
     TagBox["\[Psi]",
      QuantumAlgebra`QuantumNotation`KetArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], "\[RightAngleBracket]"}],
   QuantumAlgebra`Ket,
   BaseStyle->"KetWrapper"]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->55344160],

Cell[BoxData[
 RowBox[{
  OverscriptBox["H", "^"], "\[CenterDot]", 
  TagBox[
   RowBox[{
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{-0.4, 0.}, {0, 0}}], 
    AdjustmentBox[
     TagBox["\[Psi]",
      QuantumAlgebra`QuantumNotation`KetArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], "\[RightAngleBracket]"}],
   QuantumAlgebra`Ket,
   BaseStyle->"KetWrapper"]}]], "Output",
 ImageSize->{47, 20},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->93407129]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QAClear"]],"paclet:QuantumAlgebra/ref/QAClear"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Commutator"]],"paclet:QuantumAlgebra/ref/Commutator"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Ket"]],"paclet:QuantumAlgebra/ref/Ket"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QASet",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 23.1264081}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {"QASet QAClear"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QASet[expr1 = expr2] and QASet[expr1 := expr2] where expr1 and expr2 \
involve quantum objects like operators, bras, kets, ... . First evaluates the \
Set and SetDelayed operations as given in its argument. After that, QASet \
tries to set up definitions that can be deduced from the first relation. For \
example if we evaluate QASet[Commutator[A, B] = C ] then the argument is \
evaluated in the usual way. But from this set it can be deduced that \
Commutator[B, A] = -C, so QASet also does this assignment. QASet can handle \
the following definitions: QASet[Com[A, B] = expr] QASet[Com[A, Com[A, B]] = \
expr ] QASet[Com[Com[A, B], Com[C, D]] = expr ] QASet[Com[A, Com[A, B]] = 0, \
Com[B, Com[A, B]] = 0 ] QASet[A ** Ket[n] = a Ket[n] ] where A, B, C, D are \
operators and Com means Commutator. Also := can be used instead of = if \
necessary. For a full discussion see QuantumAlgebra.nb Section 8. ", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "QASet", "titlemodifier" -> 
    "", "windowtitle" -> "QASet", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QASet"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[13261, 387, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->175295144]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 24512, 731}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[577, 21, 3216, 77, 50, "AnchorBarGrid",
 CellID->1],
Cell[3796, 100, 282, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[4103, 115, 8214, 233, 458, "Usage"],
Cell[CellGroupData[{
Cell[12342, 352, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->101360478],
Cell[13083, 378, 31, 0, 70, "SectionHeaderSpacer"],
Cell[13117, 380, 95, 1, 70, "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13261, 387, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->175295144],
Cell[CellGroupData[{
Cell[13673, 406, 193, 6, 25, "ExampleSection",
 CellID->7944612],
Cell[CellGroupData[{
Cell[13891, 416, 239, 7, 43, "Input",
 CellID->158584138],
Cell[CellGroupData[{
Cell[14155, 427, 144, 2, 22, "Print",
 CellID->860005776],
Cell[14302, 431, 153, 3, 22, "Print",
 CellID->64219092],
Cell[14458, 436, 159, 3, 70, "Print",
 CellID->147949717],
Cell[14620, 441, 159, 3, 70, "Print",
 CellID->8362696]
}, Open  ]]
}, Open  ]],
Cell[14806, 448, 1078, 33, 70, "Input",
 CellID->4392825],
Cell[CellGroupData[{
Cell[15909, 485, 643, 20, 70, "Input",
 CellID->552250],
Cell[16555, 507, 504, 17, 37, "Output",
 CellID->99786640]
}, Open  ]],
Cell[17074, 527, 696, 21, 70, "Input",
 CellID->102362766],
Cell[CellGroupData[{
Cell[17795, 552, 449, 15, 70, "Input",
 CellID->55344160],
Cell[18247, 569, 537, 18, 41, "Output",
 CellID->93407129]
}, Open  ]]
}, Open  ]],
Cell[18811, 591, 31, 0, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18879, 596, 270, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[19152, 610, 861, 25, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[20028, 638, 23, 0, 70, "FooterCell"]
}
]
*)

