(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15114,        485]
NotebookOptionsPosition[      9665,        333]
NotebookOutlinePosition[     13551,        426]
CellTagsIndexPosition[     13466,        421]
WindowTitle->QASum
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[
    Cell[BoxData[
     ActionMenuBox[
      FrameBox[
       InterpretationBox[Cell[TextData[{
         "URL",
         StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
          StripOnInput->False]
        }]],
        TextCell[
         Row[{"URL", 
           Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
       StripOnInput->False], {"\<\"QuantumAlgebra/ref/QASum\"\>":>
      None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["QuantumAlgebra/ref/QASum"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QASum.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
           Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
            If[
             TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$43200], 
             "http://reference.wolfram.com/system-modeler/", 
             "http://reference.wolfram.com/language/"], 
            "QuantumAlgebra/ref/QASum", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic,
      MenuStyle->"URLMenu"]],
     LineSpacing->{1.4, 0}]], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QASum", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QASum", "[", 
       RowBox[{
        StyleBox["ex", "TI"], ",", " ", 
        StyleBox["var", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]defines and eventually simplifies a Summation in the \
context of Quantum Algebra."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    InterpretationBox[
     StyleBox[
      GraphicsBox[{},
       BaselinePosition->Baseline,
       ImageSize->{6, 0}],
      CacheGraphics->False],
     Spacer[6]]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->849989014],

Cell["", "SectionHeaderSpacer"],

Cell["The following parameters are required:", "Notes",
 CellID->1067943069],

Cell[TextData[Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"\\!\\(\\*\\nStyleBox[\\\"ex\\\", \\\"TI\\\"]\\)\"\>", 
      "Notes"], 
     StyleBox[
      RowBox[{"\<\"The expression about which to sum\"\>", " ", "up"}], 
      "Notes"]},
    {
     StyleBox["\<\"\\!\\(\\*\\nStyleBox[\\\"var\\\", \\\"TI\\\"]\\)\"\>", 
      "Notes"], 
     StyleBox["\<\"The summation variable\"\>", "Notes"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{"Text"}}, "Rows" -> {{"Text"}}},
   GridBoxSpacings->{"Columns" -> {{2}}, "Rows" -> {{1}}}],
  "Grid"]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False]], "Notes",
 CellID->222135989],

Cell["\<\
Remark: The Summation defines no range and no dimension like the Integration. \
The range is always meant to be 'All discrete indices' and the dimension is \
always implicit. But like QAIntegrate the variable represents a set of \
(implicit) subscripted or super-scripted components in the abstract summation \
space.\
\>", "Notes",
 CellID->533705198]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->29394532],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->788266391],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->647522450],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[34]:=",
 CellID->669215056],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[34]:=",
 CellID->374652901],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[34]:=",
 CellID->52347957],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[34]:=",
 CellID->115452859]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Define", " ", "a", " ", "sum", " ", "in", " ", "full", " ", "form"}], " ",
    "*)"}], "\[IndentingNewLine]", 
  RowBox[{"ex", "=", 
   RowBox[{"QASum", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "^", "2"}], ",", "x"}], "]"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->121809105],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[Sum]", "x"], 
  SubsuperscriptBox["x", "1", "2"]}]], "Output",
 ImageSize->{33, 34},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->9572337]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Display", " ", "the", " ", "FullForm", " ", "where", " ", "you", " ", 
    "can", " ", "see", " ", "the", " ", 
    RowBox[{"script", "'"}], "s", " ", "internal", " ", "format"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"ex", "//", "FullForm"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->224643332],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"QASum", "[", 
    RowBox[{
     RowBox[{"Power", "[", 
      RowBox[{
       RowBox[{"QASimplescript", "[", 
        RowBox[{"x", ",", "1", ",", "False"}], "]"}], ",", "2"}], "]"}], ",", 
     "x"}], "]"}],
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 ImageSize->{321, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//FullForm=",
 CellID->249626177]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Define", " ", "a", " ", "sum", " ", "with", " ", "skew", " ", "symmetric",
     " ", "integrand"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QASum", "[", 
   RowBox[{
    RowBox[{
     SubscriptBox["x", "1"], "^", "3"}], ",", "x"}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->496706337],

Cell[BoxData["0"], "Output",
 ImageSize->{11, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->453619485]
}, Open  ]],

Cell["\<\
The second sum evaluates to 0, because the summation expression is skew \
symmetric and the summation range is Infinity.\
\>", "ExampleText",
 CellID->168276617]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QASum",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 34.3234727}", 
    "history" -> {"2.0.1", "2.1.1", "", ""}, "context" -> 
    "QuantumAlgebra`RulesSupplement`", "keywords" -> {"QASum"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Quantum Algebra Package Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QASum[ex, var] defines and eventually simplifies a Summation in the \
context of Quantum Algebra.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "QASum", "titlemodifier" -> "", "windowtitle" -> "QASum", "type" -> 
    "Symbol", "uri" -> "QuantumAlgebra/ref/QASum"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5807, 178, 386, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->29394532]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13324, 414}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[577, 21, 2302, 54, 50, "AnchorBarGrid",
 CellID->1],
Cell[2882, 77, 282, 11, 44, "ObjectNameGrid"],
Cell[CellGroupData[{
Cell[3189, 92, 478, 14, 80, "Usage"],
Cell[CellGroupData[{
Cell[3692, 110, 738, 24, 31, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->849989014],
Cell[4433, 136, 31, 0, 70, "SectionHeaderSpacer"],
Cell[4467, 138, 76, 1, 70, "Notes",
 CellID->1067943069],
Cell[4546, 141, 847, 22, 70, "Notes",
 CellID->222135989],
Cell[5396, 165, 362, 7, 70, "Notes",
 CellID->533705198]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5807, 178, 386, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->29394532],
Cell[CellGroupData[{
Cell[6218, 197, 195, 6, 25, "ExampleSection",
 CellID->788266391],
Cell[CellGroupData[{
Cell[6438, 207, 239, 7, 43, "Input",
 CellID->647522450],
Cell[CellGroupData[{
Cell[6702, 218, 144, 2, 22, "Print",
 CellID->669215056],
Cell[6849, 222, 154, 3, 22, "Print",
 CellID->374652901],
Cell[7006, 227, 158, 3, 22, "Print",
 CellID->52347957],
Cell[7167, 232, 161, 3, 22, "Print",
 CellID->115452859]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7377, 241, 365, 12, 43, "Input",
 CellID->121809105],
Cell[7745, 255, 234, 8, 55, "Output",
 CellID->9572337]
}, Open  ]],
Cell[CellGroupData[{
Cell[8016, 268, 373, 10, 43, "Input",
 CellID->224643332],
Cell[8392, 280, 472, 17, 49, "Output",
 CellID->249626177]
}, Open  ]],
Cell[CellGroupData[{
Cell[8901, 302, 363, 11, 43, "Input",
 CellID->496706337],
Cell[9267, 315, 158, 5, 35, "Output",
 CellID->453619485]
}, Open  ]],
Cell[9440, 323, 171, 4, 47, "ExampleText",
 CellID->168276617]
}, Open  ]]
}, Open  ]],
Cell[9638, 331, 23, 0, 41, "FooterCell"]
}
]
*)

