(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     17603,        547]
NotebookOptionsPosition[     12244,        400]
NotebookOutlinePosition[     16289,        497]
CellTagsIndexPosition[     16204,        492]
WindowTitle->QuantumConstantExpressionQ
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Analyze\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Analyze"], "\<\"BraExpressionQ\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/BraExpressionQ"], "\<\"KetExpressionQ\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/KetExpressionQ"], \
"\<\"OperatorExpressionQ\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/OperatorExpressionQ"], \
"\<\"QuantumFreeQ\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QuantumFreeQ"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"QuantumAlgebra/ref/QuantumConstantExpressionQ\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/QuantumConstantExpressionQ"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/ref/\
QuantumConstantExpressionQ.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$44192], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/ref/QuantumConstantExpressionQ", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QuantumConstantExpressionQ", "ObjectName"],
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{8, 0}],
    CacheGraphics->False],
   Spacer[8]]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QuantumConstantExpressionQ", "[", 
       StyleBox["ex", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]tests ex for being a Quantum Constant."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->569949709],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->196507891],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"<<", "\"\<QuantumAlgebra`\>\""}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->123008308],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellLabel->"During evaluation of In[20]:=",
 CellID->55647916],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellLabel->"During evaluation of In[20]:=",
 CellID->8041907],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellLabel->"During evaluation of In[20]:=",
 CellID->40445480],

Cell[BoxData["\<\"For proper styling you should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellLabel->"During evaluation of In[20]:=",
 CellID->49957355]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Define", " ", "a", " ", "Quantum", " ", "Constant"}], " ", "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{"const", "=", 
   RowBox[{"Pi", "+", 
    TagBox[
     RowBox[{"\[LeftAngleBracket]", 
      AdjustmentBox[
       RowBox[{
        TagBox["Q",
         QuantumAlgebra`QuantumNotation`BraKetArgs,
         BaseStyle->"BraKetArg"], "\[VerticalSeparator]", 
        TagBox["R",
         QuantumAlgebra`QuantumNotation`BraKetArgs,
         BaseStyle->"BraKetArg"]}],
       BoxBaselineShift->0], "\[RightAngleBracket]"}],
     QuantumAlgebra`BraKet,
     BaseStyle->"BraKetWrapper"], "+", 
    RowBox[{
     TagBox[
      RowBox[{"\[LeftAngleBracket]", 
       AdjustmentBox[
        TagBox["Q",
         QuantumAlgebra`QuantumNotation`BraArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0], 
       AdjustmentBox["\[VerticalSeparator]",
        BoxMargins->{{0., -0.2}, {0, 0}}]}],
      QuantumAlgebra`Bra,
      BaseStyle->"BraWrapper"], "\[CenterDot]", 
     OverscriptBox["H", "^"], "\[CenterDot]", 
     TagBox[
      RowBox[{
       AdjustmentBox["\[VerticalSeparator]",
        BoxMargins->{{-0.4, 0.}, {0, 0}}], 
       AdjustmentBox[
        TagBox["R",
         QuantumAlgebra`QuantumNotation`KetArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0], "\[RightAngleBracket]"}],
      QuantumAlgebra`Ket,
      BaseStyle->"KetWrapper"]}]}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->24996983],

Cell[BoxData[
 RowBox[{"\[Pi]", "+", 
  TagBox[
   RowBox[{"\[LeftAngleBracket]", 
    AdjustmentBox[
     RowBox[{
      TagBox["Q",
       QuantumAlgebra`QuantumNotation`BraKetArgs,
       BaseStyle->"BraKetArg"], "\[VerticalSeparator]", 
      TagBox["R",
       QuantumAlgebra`QuantumNotation`BraKetArgs,
       BaseStyle->"BraKetArg"]}],
     BoxBaselineShift->0], "\[RightAngleBracket]"}],
   QuantumAlgebra`BraKet,
   BaseStyle->"BraKetWrapper"], "+", 
  RowBox[{
   TagBox[
    RowBox[{"\[LeftAngleBracket]", 
     AdjustmentBox[
      TagBox["Q",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], 
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{0., -0.2}, {0, 0}}]}],
    QuantumAlgebra`Bra,
    BaseStyle->"BraWrapper"], "\[CenterDot]", 
   OverscriptBox["H", "^"], "\[CenterDot]", 
   TagBox[
    RowBox[{
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{-0.4, 0.}, {0, 0}}], 
     AdjustmentBox[
      TagBox["R",
       QuantumAlgebra`QuantumNotation`KetArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], "\[RightAngleBracket]"}],
    QuantumAlgebra`Ket,
    BaseStyle->"KetWrapper"]}]}]], "Output",
 ImageSize->{156, 20},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->307287080]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Check", " ", "it"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QuantumConstantExpressionQ", "[", "const", "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->62764070],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->419522421]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Check", " ", "a", " ", "malformed", " ", "expression"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"QuantumConstantExpressionQ", "[", 
   RowBox[{"const", "+", 
    OverscriptBox["1", "^"]}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->119020917],

Cell[BoxData["False"], "Output",
 ImageSize->{39, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->80652646]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Analyze"]],"paclet:QuantumAlgebra/ref/Analyze"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["BraExpressionQ"]],"paclet:QuantumAlgebra/ref/BraExpressionQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["KetExpressionQ"]],"paclet:QuantumAlgebra/ref/KetExpressionQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OperatorExpressionQ"]],
    "paclet:QuantumAlgebra/ref/OperatorExpressionQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QuantumFreeQ"]],"paclet:QuantumAlgebra/ref/QuantumFreeQ"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->291696822]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QuantumConstantExpressionQ",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 37.8470521}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> 
    "QuantumAlgebra`Analyze`", 
    "keywords" -> {
     "Analyze BraExpressionQ KetExpressionQ OperatorExpressionQ \
QuantumConstantExpressionQ QuantumFreeQ"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Symbol", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "QuantumConstantExpressionQ[ex] tests ex for being a Quantum Constant.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "QuantumConstantExpressionQ", "titlemodifier" -> "", "windowtitle" -> 
    "QuantumConstantExpressionQ", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/QuantumConstantExpressionQ"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4920, 136, 387, 15, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->569949709]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 16061, 485}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[598, 21, 3594, 85, 50, "AnchorBarGrid",
 CellID->1],
Cell[4195, 108, 303, 11, 44, "ObjectNameGrid"],
Cell[4501, 121, 394, 11, 80, "Usage"],
Cell[CellGroupData[{
Cell[4920, 136, 387, 15, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->569949709],
Cell[CellGroupData[{
Cell[5332, 155, 195, 6, 25, "ExampleSection",
 CellID->196507891],
Cell[CellGroupData[{
Cell[5552, 165, 239, 7, 43, "Input",
 CellID->123008308],
Cell[CellGroupData[{
Cell[5816, 176, 143, 2, 22, "Print",
 CellID->55647916],
Cell[5962, 180, 152, 3, 22, "Print",
 CellID->8041907],
Cell[6117, 185, 158, 3, 22, "Print",
 CellID->40445480],
Cell[6278, 190, 160, 3, 22, "Print",
 CellID->49957355]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6487, 199, 1495, 45, 47, "Input",
 CellID->24996983],
Cell[7985, 246, 1345, 43, 41, "Output",
 CellID->307287080]
}, Open  ]],
Cell[CellGroupData[{
Cell[9367, 294, 230, 6, 43, "Input",
 CellID->62764070],
Cell[9600, 302, 161, 5, 35, "Output",
 CellID->419522421]
}, Open  ]],
Cell[CellGroupData[{
Cell[9798, 312, 320, 9, 49, "Input",
 CellID->119020917],
Cell[10121, 323, 161, 5, 35, "Output",
 CellID->80652646]
}, Open  ]]
}, Open  ]],
Cell[10309, 332, 31, 0, 29, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10377, 337, 270, 12, 30, "SeeAlsoSection",
 CellID->1255426704],
Cell[10650, 351, 1552, 44, 58, "SeeAlso",
 CellID->291696822]
}, Open  ]],
Cell[12217, 398, 23, 0, 70, "FooterCell"]
}
]
*)

