(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     76278,       2441]
NotebookOptionsPosition[     63841,       2050]
NotebookOutlinePosition[     68044,       2146]
CellTagsIndexPosition[     68001,       2143]
WindowTitle->Quantum Algebra Basics
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["QUANTUM ALGEBRA PACKAGE TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Functions",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Functions", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Bra\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Bra"], "\<\"BraKet\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/BraKet"], "\<\"Ket\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Ket"], "\<\"Operator\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/Operator"], "\<\"QACommutatorExpand\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QACommutatorExpand"], "\<\"QAExpandAll\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QAExpandAll"], "\<\"QASet\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/QASet"], "\<\"SetNotebookStyles\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/SetNotebookStyles"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialFunction"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"QuantumAlgebra/tutorial/Basics\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/tutorial/Basics"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/QuantumAlgebra/\
tutorial/Basics.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$50031], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "QuantumAlgebra/tutorial/Basics", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Quantum Algebra Basics", "Title",
 CellID->509267359],

Cell[BoxData[GridBox[{
   {
    TemplateBox[{
     Cell["Provide Required Input"],
      "paclet:QuantumAlgebra/tutorial/Basics#934999218",GraphicsBox[
       TagBox[
        RasterBox[
        RawArray["UnsignedInteger8",{{{128, 128, 128, 32}, {128, 128, 128, 
          16}, {128, 128, 128, 0}, {128, 128, 128, 0}, {128, 128, 128, 0}, {
          128, 128, 128, 0}, {128, 128, 128, 0}, {128, 128, 128, 48}}, {{128, 
          128, 128, 48}, {128, 128, 128, 239}, {128, 128, 128, 112}, {128, 
          128, 128, 0}, {128, 128, 128, 0}, {128, 128, 128, 16}, {128, 128, 
          128, 143}, {128, 128, 128, 239}}, {{128, 128, 128, 0}, {128, 128, 
          128, 64}, {128, 128, 128, 223}, {128, 128, 128, 191}, {128, 128, 
          128, 112}, {128, 128, 128, 223}, {128, 128, 128, 191}, {128, 128, 
          128, 32}}, {{128, 128, 128, 32}, {128, 128, 128, 16}, {128, 128, 
          128, 16}, {128, 128, 128, 175}, {128, 128, 128, 255}, {128, 128, 
          128, 127}, {128, 128, 128, 0}, {128, 128, 128, 48}}, {{128, 128, 
          128, 48}, {128, 128, 128, 239}, {128, 128, 128, 112}, {128, 128, 
          128, 0}, {128, 128, 128, 16}, {128, 128, 128, 16}, {128, 128, 128, 
          143}, {128, 128, 128, 239}}, {{128, 128, 128, 0}, {128, 128, 128, 
          64}, {128, 128, 128, 223}, {128, 128, 128, 191}, {128, 128, 128, 
          112}, {128, 128, 128, 223}, {128, 128, 128, 191}, {128, 128, 128, 
          32}}, {{128, 128, 128, 0}, {128, 128, 128, 0}, {128, 128, 128, 
          16}, {128, 128, 128, 175}, {128, 128, 128, 255}, {128, 128, 128, 
          127}, {128, 128, 128, 0}, {128, 128, 128, 0}}, {{128, 128, 128, 
          0}, {128, 128, 128, 0}, {128, 128, 128, 0}, {128, 128, 128, 0}, {
          128, 128, 128, 16}, {128, 128, 128, 0}, {128, 128, 128, 0}, {128, 
          128, 128, 0}}}], {{0, 8}, {8, 0}}, {0, 255}, ColorFunction -> 
         RGBColor], 
        BoxForm`ImageTag[
        "Byte", ColorSpace -> "RGB", Interleaving -> True, Magnification -> 
         Automatic, MetaInformation -> 
         Association[{
           "Comments" -> Association[{"Software" -> "Adobe ImageReady"}]}]], 
        Selectable -> False], DefaultBaseStyle -> "ImageGraphics", 
       ImageSizeRaw -> {8, 8}, PlotRange -> {{0, 8}, {0, 8}}, 
       ImageSize -> {8, 9}],GraphicsBox[
       TagBox[
        RasterBox[
        RawArray["UnsignedInteger8",{{{229, 95, 28, 32}, {229, 95, 28, 16}, {
          229, 95, 28, 0}, {229, 95, 28, 0}, {229, 95, 28, 0}, {229, 95, 28, 
          0}, {229, 95, 28, 0}, {229, 95, 28, 48}}, {{229, 95, 28, 48}, {229, 
          95, 28, 239}, {229, 95, 28, 112}, {229, 95, 28, 0}, {229, 95, 28, 
          0}, {229, 95, 28, 16}, {229, 95, 28, 143}, {229, 95, 28, 239}}, {{
          229, 95, 28, 0}, {229, 95, 28, 64}, {229, 95, 28, 223}, {229, 95, 
          28, 191}, {229, 95, 28, 112}, {229, 95, 28, 223}, {229, 95, 28, 
          191}, {229, 95, 28, 32}}, {{229, 95, 28, 32}, {229, 95, 28, 16}, {
          229, 95, 28, 16}, {229, 95, 28, 175}, {229, 95, 28, 255}, {229, 95, 
          28, 127}, {229, 95, 28, 0}, {229, 95, 28, 48}}, {{229, 95, 28, 
          48}, {229, 95, 28, 239}, {229, 95, 28, 112}, {229, 95, 28, 0}, {229,
           95, 28, 16}, {229, 95, 28, 16}, {229, 95, 28, 143}, {229, 95, 28, 
          239}}, {{229, 95, 28, 0}, {229, 95, 28, 64}, {229, 95, 28, 223}, {
          229, 95, 28, 191}, {229, 95, 28, 112}, {229, 95, 28, 223}, {229, 95,
           28, 191}, {229, 95, 28, 32}}, {{229, 95, 28, 0}, {229, 95, 28, 
          0}, {229, 95, 28, 16}, {229, 95, 28, 175}, {229, 95, 28, 255}, {229,
           95, 28, 127}, {229, 95, 28, 0}, {229, 95, 28, 0}}, {{229, 95, 28, 
          0}, {229, 95, 28, 0}, {229, 95, 28, 0}, {229, 95, 28, 0}, {229, 95, 
          28, 16}, {229, 95, 28, 0}, {229, 95, 28, 0}, {229, 95, 28, 0}}}], {{
         0, 8}, {8, 0}}, {0, 255}, ColorFunction -> RGBColor], 
        BoxForm`ImageTag[
        "Byte", ColorSpace -> "RGB", Interleaving -> True, Magnification -> 
         Automatic, MetaInformation -> 
         Association[{
           "XMP" -> Association[{
              "BasicSchema" -> 
               Association[{
                 "CreatorTool" -> "Adobe Photoshop CS5 Macintosh"}], 
               "MediaManagementSchema" -> 
               Association[{
                 "DerivedFrom" -> 
                  Association[{
                    "DerivedFrom" -> 
                    Association[{
                    "InstanceID" -> 
                    "xmp.iid:AA75CDB8059711E28ADB8BB95CCA5C5A", "DocumentID" -> 
                    "xmp.did:AA75CDB9059711E28ADB8BB95CCA5C5A"}]}], 
                  "DocumentID" -> "xmp.did:AA75CDBB059711E28ADB8BB95CCA5C5A", 
                  "InstanceID" -> 
                  "xmp.iid:AA75CDBA059711E28ADB8BB95CCA5C5A"}], 
               "RightsManagementSchema" -> 
               Association[{
                 "DerivedFrom" -> 
                  Association[{
                    "DerivedFrom" -> 
                    Association[{
                    "InstanceID" -> 
                    "xmp.iid:AA75CDB8059711E28ADB8BB95CCA5C5A", "DocumentID" -> 
                    "xmp.did:AA75CDB9059711E28ADB8BB95CCA5C5A"}]}]}], 
               "PagedTextSchema" -> 
               Association[{
                 "DerivedFrom" -> 
                  Association[{
                    "DerivedFrom" -> 
                    Association[{
                    "InstanceID" -> 
                    "xmp.iid:AA75CDB8059711E28ADB8BB95CCA5C5A", "DocumentID" -> 
                    "xmp.did:AA75CDB9059711E28ADB8BB95CCA5C5A"}]}]}]}], 
            "Comments" -> 
            Association[{
              "Software" -> "Adobe ImageReady", "XML:com.adobe.xmp" -> 
               "<?xpacket begin=\:feff id=W5M0MpCehiHzreSzNTczkc9d?> \
<x:xmpmeta xmlns:x=adobe:ns:meta/ x:xmptk=Adobe XMP Core 5.0-c060 61.134777, \
2010/02/12-17:32:00> <rdf:RDF \
xmlns:rdf=http://www.w3.org/1999/02/22-rdf-syntax-ns#> <rdf:Description \
rdf:about= xmlns:xmp=http://ns.adobe.com/xap/1.0/ \
xmlns:xmpMM=http://ns.adobe.com/xap/1.0/mm/ \
xmlns:stRef=http://ns.adobe.com/xap/1.0/sType/ResourceRef# \
xmp:CreatorTool=Adobe Photoshop CS5 Macintosh \
xmpMM:InstanceID=xmp.iid:AA75CDBA059711E28ADB8BB95CCA5C5A \
xmpMM:DocumentID=xmp.did:AA75CDBB059711E28ADB8BB95CCA5C5A> <xmpMM:DerivedFrom \
stRef:instanceID=xmp.iid:AA75CDB8059711E28ADB8BB95CCA5C5A \
stRef:documentID=xmp.did:AA75CDB9059711E28ADB8BB95CCA5C5A/> \
</rdf:Description> </rdf:RDF> </x:xmpmeta> <?xpacket end=r?>"}]}]], 
        Selectable -> False], DefaultBaseStyle -> "ImageGraphics", 
       ImageSizeRaw -> {8, 8}, PlotRange -> {{0, 8}, {0, 8}}, 
       ImageSize -> {8, 9}]},
     "GrayLinkWithIcon",
     BaseStyle->{"TutorialJumpBoxLink"}], 
    TemplateBox[{
     Cell["A Few Simple Calculations"],
      "paclet:QuantumAlgebra/tutorial/Basics#587363850",GraphicsBox[
       TagBox[
        RasterBox[
        RawArray["UnsignedInteger8",{{{128, 128, 128, 32}, {128, 128, 128, 
          16}, {128, 128, 128, 0}, {128, 128, 128, 0}, {128, 128, 128, 0}, {
          128, 128, 128, 0}, {128, 128, 128, 0}, {128, 128, 128, 48}}, {{128, 
          128, 128, 48}, {128, 128, 128, 239}, {128, 128, 128, 112}, {128, 
          128, 128, 0}, {128, 128, 128, 0}, {128, 128, 128, 16}, {128, 128, 
          128, 143}, {128, 128, 128, 239}}, {{128, 128, 128, 0}, {128, 128, 
          128, 64}, {128, 128, 128, 223}, {128, 128, 128, 191}, {128, 128, 
          128, 112}, {128, 128, 128, 223}, {128, 128, 128, 191}, {128, 128, 
          128, 32}}, {{128, 128, 128, 32}, {128, 128, 128, 16}, {128, 128, 
          128, 16}, {128, 128, 128, 175}, {128, 128, 128, 255}, {128, 128, 
          128, 127}, {128, 128, 128, 0}, {128, 128, 128, 48}}, {{128, 128, 
          128, 48}, {128, 128, 128, 239}, {128, 128, 128, 112}, {128, 128, 
          128, 0}, {128, 128, 128, 16}, {128, 128, 128, 16}, {128, 128, 128, 
          143}, {128, 128, 128, 239}}, {{128, 128, 128, 0}, {128, 128, 128, 
          64}, {128, 128, 128, 223}, {128, 128, 128, 191}, {128, 128, 128, 
          112}, {128, 128, 128, 223}, {128, 128, 128, 191}, {128, 128, 128, 
          32}}, {{128, 128, 128, 0}, {128, 128, 128, 0}, {128, 128, 128, 
          16}, {128, 128, 128, 175}, {128, 128, 128, 255}, {128, 128, 128, 
          127}, {128, 128, 128, 0}, {128, 128, 128, 0}}, {{128, 128, 128, 
          0}, {128, 128, 128, 0}, {128, 128, 128, 0}, {128, 128, 128, 0}, {
          128, 128, 128, 16}, {128, 128, 128, 0}, {128, 128, 128, 0}, {128, 
          128, 128, 0}}}], {{0, 8}, {8, 0}}, {0, 255}, ColorFunction -> 
         RGBColor], 
        BoxForm`ImageTag[
        "Byte", ColorSpace -> "RGB", Interleaving -> True, Magnification -> 
         Automatic, MetaInformation -> 
         Association[{
           "Comments" -> Association[{"Software" -> "Adobe ImageReady"}]}]], 
        Selectable -> False], DefaultBaseStyle -> "ImageGraphics", 
       ImageSizeRaw -> {8, 8}, PlotRange -> {{0, 8}, {0, 8}}, 
       ImageSize -> {8, 9}],GraphicsBox[
       TagBox[
        RasterBox[
        RawArray["UnsignedInteger8",{{{229, 95, 28, 32}, {229, 95, 28, 16}, {
          229, 95, 28, 0}, {229, 95, 28, 0}, {229, 95, 28, 0}, {229, 95, 28, 
          0}, {229, 95, 28, 0}, {229, 95, 28, 48}}, {{229, 95, 28, 48}, {229, 
          95, 28, 239}, {229, 95, 28, 112}, {229, 95, 28, 0}, {229, 95, 28, 
          0}, {229, 95, 28, 16}, {229, 95, 28, 143}, {229, 95, 28, 239}}, {{
          229, 95, 28, 0}, {229, 95, 28, 64}, {229, 95, 28, 223}, {229, 95, 
          28, 191}, {229, 95, 28, 112}, {229, 95, 28, 223}, {229, 95, 28, 
          191}, {229, 95, 28, 32}}, {{229, 95, 28, 32}, {229, 95, 28, 16}, {
          229, 95, 28, 16}, {229, 95, 28, 175}, {229, 95, 28, 255}, {229, 95, 
          28, 127}, {229, 95, 28, 0}, {229, 95, 28, 48}}, {{229, 95, 28, 
          48}, {229, 95, 28, 239}, {229, 95, 28, 112}, {229, 95, 28, 0}, {229,
           95, 28, 16}, {229, 95, 28, 16}, {229, 95, 28, 143}, {229, 95, 28, 
          239}}, {{229, 95, 28, 0}, {229, 95, 28, 64}, {229, 95, 28, 223}, {
          229, 95, 28, 191}, {229, 95, 28, 112}, {229, 95, 28, 223}, {229, 95,
           28, 191}, {229, 95, 28, 32}}, {{229, 95, 28, 0}, {229, 95, 28, 
          0}, {229, 95, 28, 16}, {229, 95, 28, 175}, {229, 95, 28, 255}, {229,
           95, 28, 127}, {229, 95, 28, 0}, {229, 95, 28, 0}}, {{229, 95, 28, 
          0}, {229, 95, 28, 0}, {229, 95, 28, 0}, {229, 95, 28, 0}, {229, 95, 
          28, 16}, {229, 95, 28, 0}, {229, 95, 28, 0}, {229, 95, 28, 0}}}], {{
         0, 8}, {8, 0}}, {0, 255}, ColorFunction -> RGBColor], 
        BoxForm`ImageTag[
        "Byte", ColorSpace -> "RGB", Interleaving -> True, Magnification -> 
         Automatic, MetaInformation -> 
         Association[{
           "XMP" -> Association[{
              "BasicSchema" -> 
               Association[{
                 "CreatorTool" -> "Adobe Photoshop CS5 Macintosh"}], 
               "MediaManagementSchema" -> 
               Association[{
                 "DerivedFrom" -> 
                  Association[{
                    "DerivedFrom" -> 
                    Association[{
                    "InstanceID" -> 
                    "xmp.iid:AA75CDB8059711E28ADB8BB95CCA5C5A", "DocumentID" -> 
                    "xmp.did:AA75CDB9059711E28ADB8BB95CCA5C5A"}]}], 
                  "DocumentID" -> "xmp.did:AA75CDBB059711E28ADB8BB95CCA5C5A", 
                  "InstanceID" -> 
                  "xmp.iid:AA75CDBA059711E28ADB8BB95CCA5C5A"}], 
               "RightsManagementSchema" -> 
               Association[{
                 "DerivedFrom" -> 
                  Association[{
                    "DerivedFrom" -> 
                    Association[{
                    "InstanceID" -> 
                    "xmp.iid:AA75CDB8059711E28ADB8BB95CCA5C5A", "DocumentID" -> 
                    "xmp.did:AA75CDB9059711E28ADB8BB95CCA5C5A"}]}]}], 
               "PagedTextSchema" -> 
               Association[{
                 "DerivedFrom" -> 
                  Association[{
                    "DerivedFrom" -> 
                    Association[{
                    "InstanceID" -> 
                    "xmp.iid:AA75CDB8059711E28ADB8BB95CCA5C5A", "DocumentID" -> 
                    "xmp.did:AA75CDB9059711E28ADB8BB95CCA5C5A"}]}]}]}], 
            "Comments" -> 
            Association[{
              "Software" -> "Adobe ImageReady", "XML:com.adobe.xmp" -> 
               "<?xpacket begin=\:feff id=W5M0MpCehiHzreSzNTczkc9d?> \
<x:xmpmeta xmlns:x=adobe:ns:meta/ x:xmptk=Adobe XMP Core 5.0-c060 61.134777, \
2010/02/12-17:32:00> <rdf:RDF \
xmlns:rdf=http://www.w3.org/1999/02/22-rdf-syntax-ns#> <rdf:Description \
rdf:about= xmlns:xmp=http://ns.adobe.com/xap/1.0/ \
xmlns:xmpMM=http://ns.adobe.com/xap/1.0/mm/ \
xmlns:stRef=http://ns.adobe.com/xap/1.0/sType/ResourceRef# \
xmp:CreatorTool=Adobe Photoshop CS5 Macintosh \
xmpMM:InstanceID=xmp.iid:AA75CDBA059711E28ADB8BB95CCA5C5A \
xmpMM:DocumentID=xmp.did:AA75CDBB059711E28ADB8BB95CCA5C5A> <xmpMM:DerivedFrom \
stRef:instanceID=xmp.iid:AA75CDB8059711E28ADB8BB95CCA5C5A \
stRef:documentID=xmp.did:AA75CDB9059711E28ADB8BB95CCA5C5A/> \
</rdf:Description> </rdf:RDF> </x:xmpmeta> <?xpacket end=r?>"}]}]], 
        Selectable -> False], DefaultBaseStyle -> "ImageGraphics", 
       ImageSizeRaw -> {8, 8}, PlotRange -> {{0, 8}, {0, 8}}, 
       ImageSize -> {8, 9}]},
     "GrayLinkWithIcon",
     BaseStyle->{"TutorialJumpBoxLink"}]}
  }]], "TutorialJumpBox"],

Cell["\<\
This tutorial introduces some of the basic principles how to enter Quantum \
objects and how to perform operations on them.\
\>", "Text",
 CellID->1534169418],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Preparation of a Session", "Section"]], "Subsection",
 CellID->65243614],

Cell["\<\
First one must load the QuantumAlgebra application by using the Needs command.\
\>", "Text",
 CellID->55229358],

Cell["This loads the package", "MathCaption",
 CellID->229374591],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QuantumAlgebra`\>\"", "]"}]], "Input",
 CellLabel->"In[16]:=",
 CellID->379718389],

Cell[TextData[{
 "This command normally - in a ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " front end session - loads the required context into the notebook. \
Additionally a few commands are performed to prepare the session. This \
includes the definition of notations and input aliases."
}], "Text",
 CellID->165222698],

Cell["\<\
You should invoke the command SetNotebookStyles[] once per Notebook. The \
required display styles are assigned to the notebook.\
\>", "Text",
 CellID->484100602],

Cell["\<\
After this is done, you are ready to input Quantum expressions and work with \
them.\
\>", "Text",
 CellID->520459910],

Cell["Sets required styles in the private style sheet", "MathCaption",
 CellID->437090803],

Cell[BoxData[
 RowBox[{"SetNotebookStyles", "[", "]"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->545952833],

Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["SetNotebookStyles",
      BaseStyle->"Link",
      ButtonData->"paclet:QuantumAlgebra/ref/SetNotebookStyles"], "[", "]"}], 
    Cell["Sets the required styles for proper display of objects", 
     "TableText"]}
  }]], "DefinitionBox",
 CellID->2096742444],

Cell["Function Call to set Notebook Styles.", "Caption",
 CellID->369353387]
}, Open  ]],

Cell[CellGroupData[{

Cell["Provide Required Input", "Section",
 CellID->934999218],

Cell["\<\
After the session is prepared one can input Quantum objects and work with \
them.\
\>", "Text",
 CellID->313602936],

Cell["\<\
The basic Quantum objects supported by the package are Bra, Ket, BraKet, \
Operator.\
\>", "Text",
 CellID->156195064],

Cell["\<\
Supported input methods are the textual fullform input and the input by using \
the input aliases. By providing an input alias you can generate a \
2-dimensional template where the required information is to be placed in \
placeholders.\
\>", "Text",
 CellID->880376275],

Cell["\<\
Remark: Operators with indices can be entered in FullForm only.\
\>", "Text",
 CellID->147943834],

Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["Bra",
      BaseStyle->"Link",
      ButtonData->"paclet:QuantumAlgebra/ref/Bra"], "[", "m", "]"}], Cell[
    "Used to enter a Bra in FullForm", "TableText"]},
   {
    RowBox[{
     ButtonBox["Ket",
      BaseStyle->"Link",
      ButtonData->"paclet:QuantumAlgebra/ref/Ket"], "[", "n", "]"}], Cell[
    "Used to enter a Ket in FullForm", "TableText"]},
   {
    RowBox[{
     ButtonBox["BraKet",
      BaseStyle->"Link",
      ButtonData->"paclet:QuantumAlgebra/ref/BraKet"], "[", 
     RowBox[{
      RowBox[{"{", "m", "}"}], ",", 
      RowBox[{"{", "n", "}"}]}], "]"}], Cell[
    "Used to enter a BraKet in FullForm", "TableText"]},
   {
    RowBox[{
     ButtonBox["Operator",
      BaseStyle->"Link",
      ButtonData->"paclet:QuantumAlgebra/ref/Operator"], "[", 
     RowBox[{"H", ",", 
      RowBox[{"{", "}"}], ",", 
      RowBox[{"{", "j", "}"}]}], "]"}], 
    RowBox[{
     RowBox[{
     "Used", " ", "to", " ", "enter", " ", "an", " ", "Operator", " ", "in", 
      " ", "FullForm"}], ",", 
     RowBox[{"here", " ", "with", " ", "index"}]}]},
   {
    RowBox[{
     ButtonBox["Operator",
      BaseStyle->"Link",
      ButtonData->"paclet:QuantumAlgebra/ref/Operator"], "[", 
     RowBox[{"H", ",", "\"\<H\>\"", ",", 
      RowBox[{"{", "}"}], ",", 
      RowBox[{"{", "}"}]}], "]"}], 
    RowBox[{
    "Used", " ", "to", " ", "enter", " ", "an", " ", "Hermitian", " ", 
     "Operator"}]}
  }]], "DefinitionBox",
 CellID->502616482],

Cell["FullForm of Quantum Objects.", "Caption",
 CellID->433915648],

Cell["Input Aliases as printed out during Needs", "MathCaption",
 CellID->6003686],

Cell[BoxData["\<\"ALIASES:\\nESC op ESC - Operator without index\\nESC hop \
ESC - Hermitian Operator without index\\nESC ket ESC - Ket without \
index\\nESC ketd ESC - Ket with subscript(s)\\nESC ketu ESC - Ket with \
superscript(s)\\nESC ketdu ESC - Ket with subscript(s) & superscript(s)\\nESC \
bra ESC - Ket without index\\nESC dbra ESC - Bra with subscript(s)\\nESC ubra \
ESC - Bra with superscript(s)\\nESC dubra ESC - Bra with subscript(s) & \
superscript(s)\\nESC (du)braket(du) ESC - Bra with (left and / or right) \
subscript(s) and / or superscript(s).\"\>"], "Output",
 ImageSize->{390, 207},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->8336969],

Cell["Sample FullForm input - an Operator and a Ket", "MathCaption",
 CellID->836781195],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Operator", "[", 
  RowBox[{"V", ",", 
   RowBox[{"{", "i", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellID->9767984],

Cell[BoxData[
 SubscriptBox[
  OverscriptBox["V", "^"], "i"]], "Output",
 ImageSize->{17, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->326111295]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ket", "[", 
  RowBox[{"m", ",", 
   RowBox[{"{", "i", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellID->295000522],

Cell[BoxData[
 TagBox[
  SubscriptBox[
   RowBox[{
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{-0.4, 0}, {0, 0}}], 
    AdjustmentBox[
     TagBox["m",
      QuantumAlgebra`QuantumNotation`KetArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], "\[RightAngleBracket]"}], 
   TagBox[
    AdjustmentBox[
     TagBox["i",
      QuantumAlgebra`QuantumNotation`KetArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0],
    QuantumAlgebra`QuantumNotation`UDScript,
    BaseStyle->"RIndex"]],
  Ket,
  BaseStyle->"KetWrapper"]], "Output",
 ImageSize->{39, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->176623231]
}, Open  ]],

Cell["\<\
Sample input with input alias - unfilled templates: a Bra and a BraKet\
\>", "MathCaption",
 CellID->473867497],

Cell[BoxData[
 TagBox[
  RowBox[{
   SuperscriptBox["\[InvisiblePrefixScriptBase]", 
    TagBox[
     AdjustmentBox[
      TagBox["\[Placeholder]",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"LIndex"]], 
   RowBox[{"\[LeftAngleBracket]", 
    AdjustmentBox[
     TagBox["\[SelectionPlaceholder]",
      QuantumAlgebra`QuantumNotation`BraArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], 
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{0, -0.2}, {0, 0}}]}]}],
  Bra,
  BaseStyle->"BraWrapper"]], "Input",
 CellID->253465109],

Cell[BoxData[
 TagBox[
  RowBox[{
   SubscriptBox["\[InvisiblePrefixScriptBase]", 
    TagBox[
     AdjustmentBox[
      TagBox["\[Placeholder]",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"LIndex"]], 
   SubscriptBox[
    RowBox[{"\[LeftAngleBracket]", 
     AdjustmentBox[
      RowBox[{
       TagBox["\[SelectionPlaceholder]",
        QuantumAlgebra`QuantumNotation`BraKetArgs,
        BaseStyle->"BraKetArg"], "\[VerticalSeparator]", 
       TagBox["\[SelectionPlaceholder]",
        QuantumAlgebra`QuantumNotation`BraKetArgs,
        BaseStyle->"BraKetArg"]}],
      BoxBaselineShift->0], "\[RightAngleBracket]"}], 
    TagBox[
     AdjustmentBox[
      TagBox["\[SelectionPlaceholder]",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"RIndex"]]}],
  BraKet,
  BaseStyle->"BraKetWrapper"]], "Input",
 CellID->178066247],

Cell["Sample input with input alias - with information filled in", \
"MathCaption",
 CellID->56436755],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{
   SuperscriptBox["\[InvisiblePrefixScriptBase]", 
    TagBox[
     AdjustmentBox[
      TagBox["k",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"LIndex"]], 
   RowBox[{"\[LeftAngleBracket]", 
    AdjustmentBox[
     TagBox["n",
      QuantumAlgebra`QuantumNotation`BraArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], 
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{0, -0.2}, {0, 0}}]}]}],
  Bra,
  BaseStyle->"BraWrapper"]], "Input",
 CellID->212963039],

Cell[BoxData[
 TagBox[
  RowBox[{
   SuperscriptBox["\[InvisiblePrefixScriptBase]", 
    TagBox[
     AdjustmentBox[
      TagBox["k",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"LIndex"]], 
   RowBox[{"\[LeftAngleBracket]", 
    AdjustmentBox[
     TagBox["n",
      QuantumAlgebra`QuantumNotation`BraArgs,
      BaseStyle->"BraKetArg"],
     BoxBaselineShift->0], 
    AdjustmentBox["\[VerticalSeparator]",
     BoxMargins->{{0, -0.2}, {0, 0}}]}]}],
  Bra,
  BaseStyle->"BraWrapper"]], "Output",
 ImageSize->{32, 19},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->35879172]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{
   SubscriptBox["\[InvisiblePrefixScriptBase]", 
    TagBox[
     AdjustmentBox[
      TagBox["i",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"LIndex"]], 
   SubscriptBox[
    RowBox[{"\[LeftAngleBracket]", 
     AdjustmentBox[
      RowBox[{
       TagBox["m",
        QuantumAlgebra`QuantumNotation`BraKetArgs,
        BaseStyle->"BraKetArg"], "\[VerticalSeparator]", 
       TagBox["n",
        QuantumAlgebra`QuantumNotation`BraKetArgs,
        BaseStyle->"BraKetArg"]}],
      BoxBaselineShift->0], "\[RightAngleBracket]"}], 
    TagBox[
     AdjustmentBox[
      TagBox["j",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"RIndex"]]}],
  BraKet,
  BaseStyle->"BraKetWrapper"]], "Input",
 CellID->77836706],

Cell[BoxData[
 TagBox[
  RowBox[{
   SubscriptBox["\[InvisiblePrefixScriptBase]", 
    TagBox[
     AdjustmentBox[
      TagBox["i",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"LIndex"]], 
   SubscriptBox[
    RowBox[{"\[LeftAngleBracket]", 
     AdjustmentBox[
      RowBox[{
       TagBox["m",
        QuantumAlgebra`QuantumNotation`BraKetArgs,
        BaseStyle->"BraKetArg"], "\[VerticalSeparator]", 
       TagBox["n",
        QuantumAlgebra`QuantumNotation`BraKetArgs,
        BaseStyle->"BraKetArg"]}],
      BoxBaselineShift->0], "\[RightAngleBracket]"}], 
    TagBox[
     AdjustmentBox[
      TagBox["j",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"RIndex"]]}],
  BraKet,
  BaseStyle->"BraKetWrapper"]], "Output",
 ImageSize->{59, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellID->17954646]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["A Few Simple Calculations", "Section",
 CellID->587363850],

Cell["\<\
This section demonstrates in a few simple samples, how calculations can be \
done in QuantumAlgebra.\
\>", "Text",
 CellID->374249813],

Cell[CellGroupData[{

Cell["Orthonormalized BraKet Sample", "Subsection",
 CellID->33620847],

Cell["\<\
The first sample demonstrates, how a BraKet can be assigned a function to \
calculate its value and what the result multiplying a Bra and a Ket then is.\
\>", "Text",
 CellID->735022179],

Cell[BoxData[GridBox[{
   {"CenterDot", 
    RowBox[{
    "Used", " ", "to", " ", "multiply", " ", "Bra", " ", "and", " ", "Ket", 
     " ", 
     RowBox[{"(", 
      RowBox[{"Alias", ":", " ", 
       RowBox[{"ESC", " ", ".", " ", "ESC"}]}], ")"}]}]}
  }]], "DefinitionBox",
 CellID->358456651],

Cell["\<\
Multiplication Operator to concatenate Bras, Kets and (optionally) Operators.\
\>", "Caption",
 CellID->1891092685],

Cell["Definition and Usage of BraKets", "MathCaption",
 CellID->169278472],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Orthonormalized", " ", "BraKet"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   TagBox[
    RowBox[{
     SubscriptBox["\[InvisiblePrefixScriptBase]", 
      TagBox[
       AdjustmentBox[
        TagBox["i_",
         QuantumAlgebra`QuantumNotation`BraArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0],
       QuantumAlgebra`QuantumNotation`UDScript,
       BaseStyle->"LIndex"]], 
     SubscriptBox[
      RowBox[{"\[LeftAngleBracket]", 
       AdjustmentBox[
        RowBox[{
         TagBox["m_",
          QuantumAlgebra`QuantumNotation`BraKetArgs,
          BaseStyle->"BraKetArg"], "\[VerticalSeparator]", 
         TagBox["n_",
          QuantumAlgebra`QuantumNotation`BraKetArgs,
          BaseStyle->"BraKetArg"]}],
        BoxBaselineShift->0], "\[RightAngleBracket]"}], 
      TagBox[
       AdjustmentBox[
        TagBox["j_",
         QuantumAlgebra`QuantumNotation`BraArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0],
       QuantumAlgebra`QuantumNotation`UDScript,
       BaseStyle->"RIndex"]]}],
    BraKet,
    BaseStyle->"BraKetWrapper"], ":=", 
   RowBox[{
    RowBox[{"KroneckerDelta", "[", 
     RowBox[{"i", ",", "j"}], "]"}], " ", 
    RowBox[{"KroneckerDelta", "[", 
     RowBox[{"m", ",", "n"}], "]"}]}]}]}]], "Input",
 CellLabel->"In[31]:=",
 CellID->223821793],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Equal", " ", "indices", " ", "and", " ", "labels", " ", "yield", " ", 
    "1"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   TagBox[
    RowBox[{
     SubscriptBox["\[InvisiblePrefixScriptBase]", 
      TagBox[
       AdjustmentBox[
        TagBox["1",
         QuantumAlgebra`QuantumNotation`BraArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0],
       QuantumAlgebra`QuantumNotation`UDScript,
       BaseStyle->"LIndex"]], 
     RowBox[{"\[LeftAngleBracket]", 
      AdjustmentBox[
       TagBox["n",
        QuantumAlgebra`QuantumNotation`BraArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0], 
      AdjustmentBox["\[VerticalSeparator]",
       BoxMargins->{{0, -0.2}, {0, 0}}]}]}],
    Bra,
    BaseStyle->"BraWrapper"], "\[CenterDot]", 
   TagBox[
    SubscriptBox[
     RowBox[{
      AdjustmentBox["\[VerticalSeparator]",
       BoxMargins->{{-0.4, 0}, {0, 0}}], 
      AdjustmentBox[
       TagBox["n",
        QuantumAlgebra`QuantumNotation`KetArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0], "\[RightAngleBracket]"}], 
     TagBox[
      AdjustmentBox[
       TagBox["1",
        QuantumAlgebra`QuantumNotation`KetArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0],
      QuantumAlgebra`QuantumNotation`UDScript,
      BaseStyle->"RIndex"]],
    Ket,
    BaseStyle->"KetWrapper"]}]}]], "Input",
 CellLabel->"In[32]:=",
 CellID->628528297],

Cell[BoxData["1"], "Output",
 ImageSize->{11, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[32]=",
 CellID->19540070]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{
    SubscriptBox["\[InvisiblePrefixScriptBase]", 
     TagBox[
      AdjustmentBox[
       TagBox["j",
        QuantumAlgebra`QuantumNotation`BraArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0],
      QuantumAlgebra`QuantumNotation`UDScript,
      BaseStyle->"LIndex"]], 
    RowBox[{"\[LeftAngleBracket]", 
     AdjustmentBox[
      TagBox["2",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], 
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{0, -0.2}, {0, 0}}]}]}],
   Bra,
   BaseStyle->"BraWrapper"], "\[CenterDot]", 
  TagBox[
   SubscriptBox[
    RowBox[{
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{-0.4, 0}, {0, 0}}], 
     AdjustmentBox[
      TagBox["2",
       QuantumAlgebra`QuantumNotation`KetArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], "\[RightAngleBracket]"}], 
    TagBox[
     AdjustmentBox[
      TagBox["j",
       QuantumAlgebra`QuantumNotation`KetArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"RIndex"]],
   Ket,
   BaseStyle->"KetWrapper"]}]], "Input",
 CellLabel->"In[33]:=",
 CellID->829276182],

Cell[BoxData["1"], "Output",
 ImageSize->{11, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[33]=",
 CellID->356632697]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Else", " ", "yields", " ", "0"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   TagBox[
    RowBox[{
     SubscriptBox["\[InvisiblePrefixScriptBase]", 
      TagBox[
       AdjustmentBox[
        TagBox["2",
         QuantumAlgebra`QuantumNotation`BraArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0],
       QuantumAlgebra`QuantumNotation`UDScript,
       BaseStyle->"LIndex"]], 
     RowBox[{"\[LeftAngleBracket]", 
      AdjustmentBox[
       TagBox["n",
        QuantumAlgebra`QuantumNotation`BraArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0], 
      AdjustmentBox["\[VerticalSeparator]",
       BoxMargins->{{0, -0.2}, {0, 0}}]}]}],
    Bra,
    BaseStyle->"BraWrapper"], "\[CenterDot]", 
   TagBox[
    SubscriptBox[
     RowBox[{
      AdjustmentBox["\[VerticalSeparator]",
       BoxMargins->{{-0.4, 0}, {0, 0}}], 
      AdjustmentBox[
       TagBox["n",
        QuantumAlgebra`QuantumNotation`KetArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0], "\[RightAngleBracket]"}], 
     TagBox[
      AdjustmentBox[
       TagBox["3",
        QuantumAlgebra`QuantumNotation`KetArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0],
      QuantumAlgebra`QuantumNotation`UDScript,
      BaseStyle->"RIndex"]],
    Ket,
    BaseStyle->"KetWrapper"]}]}]], "Input",
 CellLabel->"In[34]:=",
 CellID->528025387],

Cell[BoxData["0"], "Output",
 ImageSize->{11, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[34]=",
 CellID->209030887]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{
    SubscriptBox["\[InvisiblePrefixScriptBase]", 
     TagBox[
      AdjustmentBox[
       TagBox["3",
        QuantumAlgebra`QuantumNotation`BraArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0],
      QuantumAlgebra`QuantumNotation`UDScript,
      BaseStyle->"LIndex"]], 
    RowBox[{"\[LeftAngleBracket]", 
     AdjustmentBox[
      TagBox["5",
       QuantumAlgebra`QuantumNotation`BraArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], 
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{0, -0.2}, {0, 0}}]}]}],
   Bra,
   BaseStyle->"BraWrapper"], "\[CenterDot]", 
  TagBox[
   SubscriptBox[
    RowBox[{
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{-0.4, 0}, {0, 0}}], 
     AdjustmentBox[
      TagBox["4",
       QuantumAlgebra`QuantumNotation`KetArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], "\[RightAngleBracket]"}], 
    TagBox[
     AdjustmentBox[
      TagBox["3",
       QuantumAlgebra`QuantumNotation`KetArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0],
     QuantumAlgebra`QuantumNotation`UDScript,
     BaseStyle->"RIndex"]],
   Ket,
   BaseStyle->"KetWrapper"]}]], "Input",
 CellLabel->"In[35]:=",
 CellID->693483989],

Cell[BoxData["0"], "Output",
 ImageSize->{11, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[35]=",
 CellID->391276511]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Different", " ", "symbols"}], " ", "-", " ", 
    RowBox[{
    "Mathematica", " ", "cannot", " ", "make", " ", "assertions", " ", 
     "about", " ", "equality"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   TagBox[
    RowBox[{
     SubscriptBox["\[InvisiblePrefixScriptBase]", 
      TagBox[
       AdjustmentBox[
        TagBox["j",
         QuantumAlgebra`QuantumNotation`BraArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0],
       QuantumAlgebra`QuantumNotation`UDScript,
       BaseStyle->"LIndex"]], 
     RowBox[{"\[LeftAngleBracket]", 
      AdjustmentBox[
       TagBox["k",
        QuantumAlgebra`QuantumNotation`BraArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0], 
      AdjustmentBox["\[VerticalSeparator]",
       BoxMargins->{{0, -0.2}, {0, 0}}]}]}],
    Bra,
    BaseStyle->"BraWrapper"], "\[CenterDot]", 
   TagBox[
    SubscriptBox[
     RowBox[{
      AdjustmentBox["\[VerticalSeparator]",
       BoxMargins->{{-0.4, 0}, {0, 0}}], 
      AdjustmentBox[
       TagBox["l",
        QuantumAlgebra`QuantumNotation`KetArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0], "\[RightAngleBracket]"}], 
     TagBox[
      AdjustmentBox[
       TagBox["j",
        QuantumAlgebra`QuantumNotation`KetArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0],
      QuantumAlgebra`QuantumNotation`UDScript,
      BaseStyle->"RIndex"]],
    Ket,
    BaseStyle->"KetWrapper"]}]}]], "Input",
 CellLabel->"In[36]:=",
 CellID->597996886],

Cell[BoxData[
 RowBox[{"KroneckerDelta", "[", 
  RowBox[{"k", ",", "l"}], "]"}]], "Output",
 ImageSize->{141, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[36]=",
 CellID->22716009]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The Harmonic Oscillator Sample", "Subsection",
 CellID->30976998],

Cell["\<\
The Quantum Mechanical Oscillator is one of the most important yet simple \
systems in Quantum Theory. We try to demonstrate the application of Quantum \
Algebra to analyze and calculate this system.\
\>", "Text",
 CellID->415773475],

Cell["\<\
First we define a simplification function, which can be used as appropriate.\
\>", "Text",
 CellID->862903444],

Cell[BoxData[GridBox[{
   {
    ButtonBox["QASet",
     BaseStyle->"Link",
     ButtonData->"paclet:QuantumAlgebra/ref/QASet"], Cell[
    "Defines the given rule and derived rules.", "TableText"]},
   {
    ButtonBox["QACommutatorExpand",
     BaseStyle->"Link",
     ButtonData->"paclet:QuantumAlgebra/ref/QACommutatorExpand"], Cell[
    "Replaces Commutators by their definition.", "TableText"]},
   {
    ButtonBox["QAExpandAll",
     BaseStyle->"Link",
     ButtonData->"paclet:QuantumAlgebra/ref/QAExpandAll"], Cell[
    "Combines some expand functions of QA.", "TableText"]}
  }]], "DefinitionBox",
 CellID->151152663],

Cell["A few functions used in this example.", "Caption",
 CellID->99518789],

Cell["A simplification function making assumptions", "MathCaption",
 CellID->285879248],

Cell[BoxData[
 RowBox[{
  RowBox[{"FullSimplifyAss", "[", "exp_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"FullSimplify", "[", 
     RowBox[{"exp", ",", 
      RowBox[{"Assumptions", "\[Rule]", 
       RowBox[{
        RowBox[{"m", ">", "0"}], "&&", 
        RowBox[{"\[HBar]", ">", "0"}], "&&", 
        RowBox[{"\[Omega]", ">", "0"}]}]}]}], "]"}], "//", "Expand"}], "//", 
   "PowerExpand"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->459423626],

Cell["\<\
Next we define the Quantum Mechanical Oscillator by introducing its \
Hamiltonian. Then we define the important Commutation relation for Location \
and Momentum Operators. Finally we define the Location and Momentum Operators \
as Hermitian.\
\>", "Text",
 CellID->224802088],

Cell["Hamiltonian, Commutation Relations and Hermitian", "MathCaption",
 CellID->190116851],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Hamilton", " ", "Operator", " ", "defined", " ", "in", " ", "terms", " ", 
   "of", " ", "Location", " ", "and", " ", "Momentum", " ", "Operator"}], " ",
   "*)"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->95552490],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  OverscriptBox["H", "^"], "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", "2"}], "/", "m"}], " ", 
    RowBox[{
     OverscriptBox["p", "^"], "^", "2"}]}], "+", 
   RowBox[{"m", " ", 
    RowBox[{
     RowBox[{"\[Omega]", "^", "2"}], "/", "2"}], " ", 
    RowBox[{
     OverscriptBox["x", "^"], "^", "2"}]}]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->275423488],

Cell[BoxData[
 RowBox[{
  FractionBox[
   SuperscriptBox[
    OverscriptBox["p", "^"], "2"], 
   RowBox[{"2", " ", "m"}]], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", "m", " ", 
   SuperscriptBox["\[Omega]", "2"], " ", 
   SuperscriptBox[
    OverscriptBox["x", "^"], "2"]}]}]], "Output",
 ImageSize->{92, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->18531809]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Defines", " ", "the", " ", "Commutation", " ", "Relation", " ", "between", 
   " ", "Location", " ", "and", " ", "Momentum"}], " ", "*)"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->21827284],

Cell[BoxData[
 RowBox[{"QASet", "[", 
  RowBox[{
   SubscriptBox[
    RowBox[{"[", 
     RowBox[{
      OverscriptBox["x", "^"], ",", 
      OverscriptBox["p", "^"]}], "]"}], "-"], "=", 
   RowBox[{"\[ImaginaryI]", " ", "\[HBar]", " ", 
    OverscriptBox["1", "^"]}]}], "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->218097565],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Location", " ", "Operator", " ", 
   OverscriptBox["x", "^"], " ", "is", " ", "Hermitian"}], " ", 
  "*)"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->75068386],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   OverscriptBox["x", "^"], "\[Dagger]"], "=", 
  OverscriptBox["x", "^"]}]], "Input",
 CellLabel->"In[9]:=",
 CellID->64153344],

Cell[BoxData[
 OverscriptBox["x", "^"]], "Output",
 ImageSize->{11, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]=",
 CellID->10298058]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "The", " ", "same", " ", "yields", " ", "true", " ", "for", " ", "the", " ",
    "Momentum", " ", "Operator", " ", 
   OverscriptBox["p", "^"]}], " ", "*)"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->191018353],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   OverscriptBox["p", "^"], "\[Dagger]"], "=", 
  OverscriptBox["p", "^"]}]], "Input",
 CellLabel->"In[11]:=",
 CellID->498544831],

Cell[BoxData[
 OverscriptBox["p", "^"]], "Output",
 ImageSize->{11, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]=",
 CellID->54067020]
}, Open  ]],

Cell[TextData[{
 "Next we introduce a few rules. They are all based on the definition of the \
so called Creation Operator and its counter part - the Annihilation Operator. \
Whereas Rule 1 can substitute Annihilation and Creation Operators by Location \
and Momentum, Rule 2 can do the opposite. Rules 3 and 4 are rules derived \
from Commutator definition for the Annihilation and Creation Operators. Rules \
5 and 6 introduce the so called Number Operator ",
 Cell[BoxData[
  OverscriptBox["N", "^"]]],
 ". "
}], "Text",
 CellID->232292278],

Cell["Definition of required rules", "MathCaption",
 CellID->323211167],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "We", " ", "define", " ", "rules", " ", "where", " ", "a", " ", 
   "Commutator", " ", "definition", " ", "is", " ", "solved", " ", "after", 
   " ", "one", " ", "of", " ", "the", " ", "both", " ", "products", " ", "of",
    " ", "the", " ", "contributing", " ", "Operators"}], " ", "*)"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->717936233],

Cell[BoxData[
 RowBox[{
  RowBox[{"commutatorRules", "[", 
   RowBox[{"op1_Operator", ",", "op2_Operator"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"commutator", "=", 
       SubscriptBox[
        RowBox[{"[", 
         RowBox[{"op1", ",", "op2"}], "]"}], "-"]}], ",", "rule1", ",", 
      "rule2"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rule1", "=", 
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{"commutator", "\[Equal]", 
         RowBox[{"(", 
          RowBox[{"commutator", "//", "QACommutatorExpand"}], ")"}]}], ",", 
        RowBox[{"op1", "\[CenterDot]", "op2"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rule2", "=", 
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{"commutator", "\[Equal]", 
         RowBox[{"(", 
          RowBox[{"commutator", "//", "QACommutatorExpand"}], ")"}]}], ",", 
        RowBox[{"op2", "\[CenterDot]", "op1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"rule1", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{"rule2", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellLabel->"In[15]:=",
 CellID->322602097],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "From", " ", "our", " ", "start", " ", "rule", " ", "we", " ", "derive", 
   " ", "a", " ", "second", " ", "rule", " ", "by", " ", "Hermitian", " ", 
   "operation", " ", "and", " ", "unify", " ", "them", " ", "in", " ", "a", 
   " ", "List"}], " ", "*)"}]], "Input",
 InitializationCell->True,
 CellLabel->"In[16]:=",
 CellID->51631347],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule1", "=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"rule", ",", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Hermitian", "[", "#", "]"}], "&"}], ",", "rule"}], "]"}]}], 
    "}"}], "//", "FullSimplifyAss"}]}]], "Input",
 CellLabel->"In[17]:=",
 CellID->354816522],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox[
     OverscriptBox["a", "^"], "\[Dagger]"], "\[Rule]", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", 
        OverscriptBox["p", "^"]}], 
       RowBox[{
        SqrtBox["2"], " ", 
        SqrtBox["m"], " ", 
        SqrtBox["\[Omega]"], " ", 
        SqrtBox["\[HBar]"]}]]}], "+", 
     FractionBox[
      RowBox[{
       SqrtBox["m"], " ", 
       SqrtBox["\[Omega]"], " ", 
       OverscriptBox["x", "^"]}], 
      RowBox[{
       SqrtBox["2"], " ", 
       SqrtBox["\[HBar]"]}]]}]}], ",", 
   RowBox[{
    OverscriptBox["a", "^"], "\[Rule]", 
    RowBox[{
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", 
       OverscriptBox["p", "^"]}], 
      RowBox[{
       SqrtBox["2"], " ", 
       SqrtBox["m"], " ", 
       SqrtBox["\[Omega]"], " ", 
       SqrtBox["\[HBar]"]}]], "+", 
     FractionBox[
      RowBox[{
       SqrtBox["m"], " ", 
       SqrtBox["\[Omega]"], " ", 
       OverscriptBox["x", "^"]}], 
      RowBox[{
       SqrtBox["2"], " ", 
       SqrtBox["\[HBar]"]}]]}]}]}], "}"}]], "Output",
 ImageSize->{442, 41},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[17]=",
 CellID->147246005]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Rule", " ", "2", " ", "solves", " ", "the", " ", "rules", " ", "in", " ", 
   "Rule", " ", "1", " ", "after", " ", "Location", " ", "and", " ", 
   "Momentum", " ", "operators"}], " ", "*)"}]], "Input",
 CellLabel->"In[18]:=",
 CellID->13352499],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule2", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{"rule1", "/.", 
       RowBox[{"Rule", "\[Rule]", "Equal"}]}], ",", 
      RowBox[{"{", 
       RowBox[{
        OverscriptBox["x", "^"], ",", 
        OverscriptBox["p", "^"]}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "//", "FullSimplifyAss"}]}]], "Input",
 CellLabel->"In[19]:=",
 CellID->117576209],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    OverscriptBox["x", "^"], "\[Rule]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SqrtBox["\[HBar]"], " ", 
       OverscriptBox["a", "^"]}], 
      RowBox[{
       SqrtBox["2"], " ", 
       SqrtBox["m"], " ", 
       SqrtBox["\[Omega]"]}]], "+", 
     FractionBox[
      RowBox[{
       SqrtBox["\[HBar]"], " ", 
       SuperscriptBox[
        OverscriptBox["a", "^"], "\[Dagger]"]}], 
      RowBox[{
       SqrtBox["2"], " ", 
       SqrtBox["m"], " ", 
       SqrtBox["\[Omega]"]}]]}]}], ",", 
   RowBox[{
    OverscriptBox["p", "^"], "\[Rule]", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", 
        SqrtBox["m"], " ", 
        SqrtBox["\[Omega]"], " ", 
        SqrtBox["\[HBar]"], " ", 
        OverscriptBox["a", "^"]}], 
       SqrtBox["2"]]}], "+", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", 
       SqrtBox["m"], " ", 
       SqrtBox["\[Omega]"], " ", 
       SqrtBox["\[HBar]"], " ", 
       SuperscriptBox[
        OverscriptBox["a", "^"], "\[Dagger]"]}], 
      SqrtBox["2"]]}]}]}], "}"}]], "Output",
 ImageSize->{462, 41},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[19]=",
 CellID->32445800]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "From", " ", "the", " ", "commutatorRules", " ", "derives", " ", "rules", 
   " ", "for", " ", "Creation", " ", "and", " ", "Annihilation", " ", 
   "Operator"}], " ", "*)"}]], "Input",
 CellLabel->"In[20]:=",
 CellID->220241553],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule3", "=", 
  RowBox[{
   RowBox[{"commutatorRules", "[", 
    RowBox[{
     OverscriptBox["a", "^"], ",", 
     SuperscriptBox[
      OverscriptBox["a", "^"], "\[Dagger]"]}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellLabel->"In[21]:=",
 CellID->545649329],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["a", "^"], "\[CenterDot]", 
   SuperscriptBox[
    OverscriptBox["a", "^"], "\[Dagger]"]}], "\[Rule]", 
  RowBox[{
   SubscriptBox[
    RowBox[{"[", 
     RowBox[{
      OverscriptBox["a", "^"], ",", 
      SuperscriptBox[
       OverscriptBox["a", "^"], "\[Dagger]"]}], "]"}], "-"], "+", 
   RowBox[{
    SuperscriptBox[
     OverscriptBox["a", "^"], "\[Dagger]"], "\[CenterDot]", 
    OverscriptBox["a", "^"]}]}]}]], "Output",
 ImageSize->{147, 19},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[21]=",
 CellID->95657832]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule4", "=", 
  RowBox[{
   RowBox[{"commutatorRules", "[", 
    RowBox[{
     OverscriptBox["a", "^"], ",", 
     SuperscriptBox[
      OverscriptBox["a", "^"], "\[Dagger]"]}], "]"}], "[", 
   RowBox[{"[", "2", "]"}], "]"}]}]], "Input",
 CellLabel->"In[22]:=",
 CellID->24585273],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox[
    OverscriptBox["a", "^"], "\[Dagger]"], "\[CenterDot]", 
   OverscriptBox["a", "^"]}], "\[Rule]", 
  RowBox[{
   RowBox[{"-", 
    SubscriptBox[
     RowBox[{"[", 
      RowBox[{
       OverscriptBox["a", "^"], ",", 
       SuperscriptBox[
        OverscriptBox["a", "^"], "\[Dagger]"]}], "]"}], "-"]}], "+", 
   RowBox[{
    OverscriptBox["a", "^"], "\[CenterDot]", 
    SuperscriptBox[
     OverscriptBox["a", "^"], "\[Dagger]"]}]}]}]], "Output",
 ImageSize->{155, 19},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[22]=",
 CellID->480176075]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule5", "=", 
  RowBox[{
   OverscriptBox["N", "^"], "\[Rule]", 
   RowBox[{
    SuperscriptBox[
     OverscriptBox["a", "^"], "\[Dagger]"], "\[CenterDot]", 
    OverscriptBox["a", "^"]}]}]}]], "Input",
 CellLabel->"In[23]:=",
 CellID->821536295],

Cell[BoxData[
 RowBox[{
  OverscriptBox["N", "^"], "\[Rule]", 
  RowBox[{
   SuperscriptBox[
    OverscriptBox["a", "^"], "\[Dagger]"], "\[CenterDot]", 
   OverscriptBox["a", "^"]}]}]], "Output",
 ImageSize->{59, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[23]=",
 CellID->328404901]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule6", "=", 
  RowBox[{
   RowBox[{
    SuperscriptBox[
     OverscriptBox["a", "^"], "\[Dagger]"], "\[CenterDot]", 
    OverscriptBox["a", "^"]}], "\[Rule]", 
   OverscriptBox["N", "^"]}]}]], "Input",
 CellLabel->"In[24]:=",
 CellID->109799321],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox[
    OverscriptBox["a", "^"], "\[Dagger]"], "\[CenterDot]", 
   OverscriptBox["a", "^"]}], "\[Rule]", 
  OverscriptBox["N", "^"]}]], "Output",
 ImageSize->{59, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[24]=",
 CellID->282921413]
}, Open  ]],

Cell["\<\
Rule 7 derives a Commutator rule for the Annihilation and Creation Operators.\
\>", "Text",
 CellID->44274564],

Cell["\<\
After this the Hamiltonian is simplified using both Operator definitions.\
\>", "Text",
 CellID->387315635],

Cell["\<\
And finally a Eigenvalue - Eigenket - Relation is adopted for the Number \
Operator.\
\>", "Text",
 CellID->36085739],

Cell["Commutator rule for the Annihilation and Creation Operators", \
"MathCaption",
 CellID->432252910],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rule7", "=", 
  RowBox[{
   SubscriptBox[
    RowBox[{"[", 
     RowBox[{
      OverscriptBox["a", "^"], ",", 
      SuperscriptBox[
       OverscriptBox["a", "^"], "\[Dagger]"]}], "]"}], "-"], "\[Rule]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SubscriptBox[
       RowBox[{"[", 
        RowBox[{
         OverscriptBox["a", "^"], ",", 
         SuperscriptBox[
          OverscriptBox["a", "^"], "\[Dagger]"]}], "]"}], "-"], "/.", 
      "rule1"}], "//", "QACommutatorExpand"}], ")"}]}]}]], "Input",
 CellLabel->"In[25]:=",
 CellID->7061275],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   RowBox[{"[", 
    RowBox[{
     OverscriptBox["a", "^"], ",", 
     SuperscriptBox[
      OverscriptBox["a", "^"], "\[Dagger]"]}], "]"}], "-"], "\[Rule]", 
  OverscriptBox["1", "^"]}]], "Output",
 ImageSize->{79, 21},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[25]=",
 CellID->16010193]
}, Open  ]],

Cell["Simplified Hamiltonian", "MathCaption",
 CellID->202005193],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        OverscriptBox["H", "^"], "/.", "rule2"}], "//", "QAPowerExpand"}], "//",
       "FullSimplifyAss"}], ")"}], "/.", "rule3"}], "/.", "rule7"}], "//", 
  "QAExpandAll"}]], "Input",
 CellLabel->"In[26]:=",
 CellID->118653171],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Omega]", " ", "\[HBar]", " ", 
   RowBox[{
    SuperscriptBox[
     OverscriptBox["a", "^"], "\[Dagger]"], "\[CenterDot]", 
    OverscriptBox["a", "^"]}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", "\[Omega]", " ", "\[HBar]", " ", 
   OverscriptBox["1", "^"]}]}]], "Output",
 ImageSize->{110, 30},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[26]=",
 CellID->36448407]
}, Open  ]],

Cell["Eigenvalue - Eigenket - Relation for the Number Operator", "MathCaption",
 CellID->211679826],

Cell[BoxData[
 RowBox[{"QASet", "[", 
  RowBox[{
   RowBox[{
    OverscriptBox["N", "^"], "\[CenterDot]", 
    TagBox[
     RowBox[{
      AdjustmentBox["\[VerticalSeparator]",
       BoxMargins->{{-0.4, 0}, {0, 0}}], 
      AdjustmentBox[
       TagBox["n_",
        QuantumAlgebra`QuantumNotation`KetArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0], "\[RightAngleBracket]"}],
     Ket,
     BaseStyle->"KetWrapper"]}], "=", 
   RowBox[{"n", " ", 
    TagBox[
     RowBox[{
      AdjustmentBox["\[VerticalSeparator]",
       BoxMargins->{{-0.4, 0}, {0, 0}}], 
      AdjustmentBox[
       TagBox["n",
        QuantumAlgebra`QuantumNotation`KetArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0], "\[RightAngleBracket]"}],
     Ket,
     BaseStyle->"KetWrapper"]}]}], "]"}]], "Input",
 CellLabel->"In[28]:=",
 CellID->428358388],

Cell["\<\
Finally we derive the meaning of the Annihilation and Creation Operators, \
respectively.\
\>", "Text",
 CellID->295719031],

Cell[TextData[{
 "It becomes apparent that Annihilation / Creation Operator, applied to an \
Eigenket of ",
 Cell[BoxData[
  OverscriptBox["N", "^"]]],
 " give a new Eigenket with Eigenvalue decreased / increased by one. It also \
justifies the term Number Operator for ",
 Cell[BoxData[
  RowBox[{
   OverscriptBox["N", "^"], "."}]]]
}], "Text",
 CellID->459929078],

Cell["With this demonstration we conclude this little sample.", "Text",
 CellID->40677064],

Cell["Meaning of Annihilation and Creation Operators", "MathCaption",
 CellID->38873772],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        OverscriptBox["N", "^"], "\[CenterDot]", 
        SuperscriptBox[
         OverscriptBox["a", "^"], "\[Dagger]"], "\[CenterDot]", 
        TagBox[
         RowBox[{
          AdjustmentBox["\[VerticalSeparator]",
           BoxMargins->{{-0.4, 0}, {0, 0}}], 
          AdjustmentBox[
           TagBox["n",
            QuantumAlgebra`QuantumNotation`KetArgs,
            BaseStyle->"BraKetArg"],
           BoxBaselineShift->0], "\[RightAngleBracket]"}],
         Ket,
         BaseStyle->"KetWrapper"]}], "/.", "rule5"}], ")"}], "/.", "rule3"}], 
    ")"}], "/.", "rule6"}], "/.", "rule7"}]], "Input",
 CellLabel->"In[29]:=",
 CellID->202420052],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox[
    OverscriptBox["a", "^"], "\[Dagger]"], "\[CenterDot]", 
   TagBox[
    RowBox[{
     AdjustmentBox["\[VerticalSeparator]",
      BoxMargins->{{-0.4, 0}, {0, 0}}], 
     AdjustmentBox[
      TagBox["n",
       QuantumAlgebra`QuantumNotation`KetArgs,
       BaseStyle->"BraKetArg"],
      BoxBaselineShift->0], "\[RightAngleBracket]"}],
    Ket,
    BaseStyle->"KetWrapper"]}], "+", 
  RowBox[{"n", " ", 
   RowBox[{
    SuperscriptBox[
     OverscriptBox["a", "^"], "\[Dagger]"], "\[CenterDot]", 
    TagBox[
     RowBox[{
      AdjustmentBox["\[VerticalSeparator]",
       BoxMargins->{{-0.4, 0}, {0, 0}}], 
      AdjustmentBox[
       TagBox["n",
        QuantumAlgebra`QuantumNotation`KetArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0], "\[RightAngleBracket]"}],
     Ket,
     BaseStyle->"KetWrapper"]}]}]}]], "Output",
 ImageSize->{123, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[29]=",
 CellID->705456028]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        OverscriptBox["N", "^"], "\[CenterDot]", 
        OverscriptBox["a", "^"], "\[CenterDot]", 
        TagBox[
         RowBox[{
          AdjustmentBox["\[VerticalSeparator]",
           BoxMargins->{{-0.4, 0}, {0, 0}}], 
          AdjustmentBox[
           TagBox["n",
            QuantumAlgebra`QuantumNotation`KetArgs,
            BaseStyle->"BraKetArg"],
           BoxBaselineShift->0], "\[RightAngleBracket]"}],
         Ket,
         BaseStyle->"KetWrapper"]}], "/.", "rule5"}], ")"}], "/.", "rule4"}], 
    ")"}], "/.", "rule6"}], "/.", "rule7"}]], "Input",
 CellLabel->"In[30]:=",
 CellID->311576446],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"(", 
    RowBox[{
     OverscriptBox["a", "^"], "\[CenterDot]", 
     TagBox[
      RowBox[{
       AdjustmentBox["\[VerticalSeparator]",
        BoxMargins->{{-0.4, 0}, {0, 0}}], 
       AdjustmentBox[
        TagBox["n",
         QuantumAlgebra`QuantumNotation`KetArgs,
         BaseStyle->"BraKetArg"],
        BoxBaselineShift->0], "\[RightAngleBracket]"}],
      Ket,
      BaseStyle->"KetWrapper"]}], ")"}]}], "+", 
  RowBox[{"n", " ", 
   RowBox[{
    OverscriptBox["a", "^"], "\[CenterDot]", 
    TagBox[
     RowBox[{
      AdjustmentBox["\[VerticalSeparator]",
       BoxMargins->{{-0.4, 0}, {0, 0}}], 
      AdjustmentBox[
       TagBox["n",
        QuantumAlgebra`QuantumNotation`KetArgs,
        BaseStyle->"BraKetArg"],
       BoxBaselineShift->0], "\[RightAngleBracket]"}],
     Ket,
     BaseStyle->"KetWrapper"]}]}]}]], "Output",
 ImageSize->{133, 20},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[30]=",
 CellID->397069319]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Related Guides"
}], "TutorialMoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData["XXXX"], "Input",
 CellID->490174459],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  InterpretationBox[
   StyleBox[
    GraphicsBox[{},
     BaselinePosition->Baseline,
     ImageSize->{6, 0}],
    CacheGraphics->False],
   Spacer[6]]]],
 "Related Tutorials"
}], "RelatedTutorialsSection",
 WholeCellGroupOpener->True,
 CellID->415694126],

Cell["", "SectionHeaderSpacer"],

Cell["Advanced Concepts", "RelatedTutorials",
 CellID->806871991]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Quantum Algebra Basics",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "TutorialColor", 
  "LinkTrails" -> GridBox[{{
      RowBox[{
        ButtonBox[
        "Mathematica", ButtonData -> 
         "paclet:QuantumAlgebra/guide/QuantumAlgebra", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "ExampleCounter" -> 1, "NeedPlatMsgIn" -> None, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2020, 4, 28, 10, 5, 56.6916713}", 
    "history" -> {"1.0.0", "", "", ""}, "context" -> "QuantumAlgebra`", 
    "keywords" -> {"QuantumAlgebra"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Quantum Algebra Package Tutorial", "language" -> "en", "paclet" -> 
    "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "This tutorial introduces some of the basic principles how to enter \
Quantum objects and how to perform operations on them. First one must load \
the QuantumAlgebra application by using the Needs command. This loads the \
package", "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$49872, "title" -> 
    "Quantum Algebra Basics", "titlemodifier" -> "", "windowtitle" -> 
    "Quantum Algebra Basics", "type" -> "Tutorial", "uri" -> 
    "QuantumAlgebra/tutorial/Basics"}, "SearchTextTranslated" -> ""},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["Input"], CellContext -> Notebook], 
   Cell[
    StyleData["Output"], CellContext -> Notebook], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 3785, 88, 50, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4404, 113, 59, 1, 47, "Title",
 CellID->509267359],
Cell[4466, 116, 13451, 236, 42, "TutorialJumpBox"],
Cell[17920, 354, 168, 4, 48, "Text",
 CellID->1534169418],
Cell[CellGroupData[{
Cell[18113, 362, 96, 1, 54, "Subsection",
 CellID->65243614],
Cell[18212, 365, 121, 3, 30, "Text",
 CellID->55229358],
Cell[18336, 370, 65, 1, 31, "MathCaption",
 CellID->229374591],
Cell[18404, 373, 124, 3, 26, "Input",
 CellID->379718389],
Cell[18531, 378, 331, 8, 66, "Text",
 CellID->165222698],
Cell[18865, 388, 172, 4, 48, "Text",
 CellID->484100602],
Cell[19040, 394, 128, 4, 30, "Text",
 CellID->520459910],
Cell[19171, 400, 90, 1, 31, "MathCaption",
 CellID->437090803],
Cell[19264, 403, 108, 3, 26, "Input",
 CellID->545952833],
Cell[19375, 408, 312, 9, 58, "DefinitionBox",
 CellID->2096742444],
Cell[19690, 419, 76, 1, 31, "Caption",
 CellID->369353387]
}, Open  ]],
Cell[CellGroupData[{
Cell[19803, 425, 61, 1, 62, "Section",
 CellID->934999218],
Cell[19867, 428, 125, 4, 30, "Text",
 CellID->313602936],
Cell[19995, 434, 128, 4, 30, "Text",
 CellID->156195064],
Cell[20126, 440, 280, 6, 70, "Text",
 CellID->880376275],
Cell[20409, 448, 107, 3, 70, "Text",
 CellID->147943834],
Cell[20519, 453, 1503, 47, 70, "DefinitionBox",
 CellID->502616482],
Cell[22025, 502, 67, 1, 70, "Caption",
 CellID->433915648],
Cell[22095, 505, 82, 1, 70, "MathCaption",
 CellID->6003686],
Cell[22180, 508, 689, 11, 228, "Output",
 CellID->8336969],
Cell[22872, 521, 88, 1, 70, "MathCaption",
 CellID->836781195],
Cell[CellGroupData[{
Cell[22985, 526, 155, 5, 70, "Input",
 CellID->9767984],
Cell[23143, 533, 179, 6, 39, "Output",
 CellID->326111295]
}, Open  ]],
Cell[CellGroupData[{
Cell[23359, 544, 152, 5, 70, "Input",
 CellID->295000522],
Cell[23514, 551, 675, 24, 37, "Output",
 CellID->176623231]
}, Open  ]],
Cell[24204, 578, 121, 3, 70, "MathCaption",
 CellID->473867497],
Cell[24328, 583, 677, 22, 70, "Input",
 CellID->253465109],
Cell[25008, 607, 1073, 33, 70, "Input",
 CellID->178066247],
Cell[26084, 642, 102, 2, 70, "MathCaption",
 CellID->56436755],
Cell[CellGroupData[{
Cell[26211, 648, 642, 22, 70, "Input",
 CellID->212963039],
Cell[26856, 672, 729, 25, 40, "Output",
 CellID->35879172]
}, Open  ]],
Cell[CellGroupData[{
Cell[27622, 702, 993, 33, 70, "Input",
 CellID->77836706],
Cell[28618, 737, 1081, 36, 39, "Output",
 CellID->17954646]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29748, 779, 64, 1, 70, "Section",
 CellID->587363850],
Cell[29815, 782, 144, 4, 70, "Text",
 CellID->374249813],
Cell[CellGroupData[{
Cell[29984, 790, 70, 1, 70, "Subsection",
 CellID->33620847],
Cell[30057, 793, 196, 4, 70, "Text",
 CellID->735022179],
Cell[30256, 799, 295, 9, 70, "DefinitionBox",
 CellID->358456651],
Cell[30554, 810, 125, 3, 70, "Caption",
 CellID->1891092685],
Cell[30682, 815, 74, 1, 70, "MathCaption",
 CellID->169278472],
Cell[30759, 818, 1393, 44, 70, "Input",
 CellID->223821793],
Cell[CellGroupData[{
Cell[32177, 866, 1489, 49, 70, "Input",
 CellID->628528297],
Cell[33669, 917, 158, 5, 35, "Output",
 CellID->19540070]
}, Open  ]],
Cell[CellGroupData[{
Cell[33864, 927, 1278, 44, 70, "Input",
 CellID->829276182],
Cell[35145, 973, 159, 5, 35, "Output",
 CellID->356632697]
}, Open  ]],
Cell[CellGroupData[{
Cell[35341, 983, 1440, 48, 70, "Input",
 CellID->528025387],
Cell[36784, 1033, 159, 5, 35, "Output",
 CellID->209030887]
}, Open  ]],
Cell[CellGroupData[{
Cell[36980, 1043, 1278, 44, 70, "Input",
 CellID->693483989],
Cell[38261, 1089, 159, 5, 35, "Output",
 CellID->391276511]
}, Open  ]],
Cell[CellGroupData[{
Cell[38457, 1099, 1582, 51, 70, "Input",
 CellID->597996886],
Cell[40042, 1152, 222, 7, 35, "Output",
 CellID->22716009]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[40313, 1165, 71, 1, 70, "Subsection",
 CellID->30976998],
Cell[40387, 1168, 243, 5, 70, "Text",
 CellID->415773475],
Cell[40633, 1175, 120, 3, 70, "Text",
 CellID->862903444],
Cell[40756, 1180, 624, 17, 70, "DefinitionBox",
 CellID->151152663],
Cell[41383, 1199, 75, 1, 70, "Caption",
 CellID->99518789],
Cell[41461, 1202, 87, 1, 70, "MathCaption",
 CellID->285879248],
Cell[41551, 1205, 458, 14, 70, "Input",
 CellID->459423626],
Cell[42012, 1221, 285, 6, 70, "Text",
 CellID->224802088],
Cell[42300, 1229, 91, 1, 70, "MathCaption",
 CellID->190116851],
Cell[42394, 1232, 265, 7, 70, "Input",
 CellID->95552490],
Cell[CellGroupData[{
Cell[42684, 1243, 407, 15, 70, "Input",
 CellID->275423488],
Cell[43094, 1260, 421, 15, 56, "Output",
 CellID->18531809]
}, Open  ]],
Cell[43530, 1278, 240, 6, 70, "Input",
 CellID->21827284],
Cell[43773, 1286, 329, 11, 70, "Input",
 CellID->218097565],
Cell[44105, 1299, 206, 6, 70, "Input",
 CellID->75068386],
Cell[CellGroupData[{
Cell[44336, 1309, 170, 6, 70, "Input",
 CellID->64153344],
Cell[44509, 1317, 179, 6, 37, "Output",
 CellID->10298058]
}, Open  ]],
Cell[44703, 1326, 260, 7, 70, "Input",
 CellID->191018353],
Cell[CellGroupData[{
Cell[44988, 1337, 172, 6, 70, "Input",
 CellID->498544831],
Cell[45163, 1345, 180, 6, 37, "Output",
 CellID->54067020]
}, Open  ]],
Cell[45358, 1354, 543, 11, 70, "Text",
 CellID->232292278],
Cell[45904, 1367, 71, 1, 70, "MathCaption",
 CellID->323211167],
Cell[45978, 1370, 392, 8, 70, "Input",
 CellID->717936233],
Cell[46373, 1380, 1345, 39, 70, "Input",
 CellID->322602097],
Cell[47721, 1421, 385, 9, 70, "Input",
 InitializationCell->True,
 CellID->51631347],
Cell[CellGroupData[{
Cell[48131, 1434, 320, 11, 70, "Input",
 CellID->354816522],
Cell[48454, 1447, 1261, 47, 62, "Output",
 CellID->147246005]
}, Open  ]],
Cell[49730, 1497, 294, 7, 70, "Input",
 CellID->13352499],
Cell[CellGroupData[{
Cell[50049, 1508, 435, 14, 70, "Input",
 CellID->117576209],
Cell[50487, 1524, 1264, 46, 62, "Output",
 CellID->32445800]
}, Open  ]],
Cell[51766, 1573, 277, 7, 70, "Input",
 CellID->220241553],
Cell[CellGroupData[{
Cell[52068, 1584, 305, 10, 70, "Input",
 CellID->545649329],
Cell[52376, 1596, 611, 21, 40, "Output",
 CellID->95657832]
}, Open  ]],
Cell[CellGroupData[{
Cell[53024, 1622, 304, 10, 70, "Input",
 CellID->24585273],
Cell[53331, 1634, 637, 22, 40, "Output",
 CellID->480176075]
}, Open  ]],
Cell[CellGroupData[{
Cell[54005, 1661, 270, 9, 70, "Input",
 CellID->821536295],
Cell[54278, 1672, 326, 11, 39, "Output",
 CellID->328404901]
}, Open  ]],
Cell[CellGroupData[{
Cell[54641, 1688, 270, 9, 70, "Input",
 CellID->109799321],
Cell[54914, 1699, 326, 11, 39, "Output",
 CellID->282921413]
}, Open  ]],
Cell[55255, 1713, 120, 3, 70, "Text",
 CellID->44274564],
Cell[55378, 1718, 117, 3, 70, "Text",
 CellID->387315635],
Cell[55498, 1723, 127, 4, 70, "Text",
 CellID->36085739],
Cell[55628, 1729, 104, 2, 70, "MathCaption",
 CellID->432252910],
Cell[CellGroupData[{
Cell[55757, 1735, 577, 20, 70, "Input",
 CellID->7061275],
Cell[56337, 1757, 368, 13, 42, "Output",
 CellID->16010193]
}, Open  ]],
Cell[56720, 1773, 65, 1, 70, "MathCaption",
 CellID->202005193],
Cell[CellGroupData[{
Cell[56810, 1778, 339, 12, 70, "Input",
 CellID->118653171],
Cell[57152, 1792, 449, 14, 51, "Output",
 CellID->36448407]
}, Open  ]],
Cell[57616, 1809, 99, 1, 70, "MathCaption",
 CellID->211679826],
Cell[57718, 1812, 860, 29, 70, "Input",
 CellID->428358388],
Cell[58581, 1843, 133, 4, 70, "Text",
 CellID->295719031],
Cell[58717, 1849, 366, 11, 70, "Text",
 CellID->459929078],
Cell[59086, 1862, 90, 1, 70, "Text",
 CellID->40677064],
Cell[59179, 1865, 88, 1, 70, "MathCaption",
 CellID->38873772],
Cell[CellGroupData[{
Cell[59292, 1870, 769, 24, 70, "Input",
 CellID->202420052],
Cell[60064, 1896, 1031, 35, 39, "Output",
 CellID->705456028]
}, Open  ]],
Cell[CellGroupData[{
Cell[61132, 1936, 730, 23, 70, "Input",
 CellID->311576446],
Cell[61865, 1961, 1030, 35, 41, "Output",
 CellID->397069319]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[62956, 2003, 284, 12, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[63243, 2017, 31, 0, 70, "SectionHeaderSpacer"],
Cell[63277, 2019, 50, 1, 70, "Input",
 CellID->490174459],
Cell[63330, 2022, 31, 0, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63398, 2027, 287, 12, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[63688, 2041, 31, 0, 70, "SectionHeaderSpacer"],
Cell[63722, 2043, 65, 1, 70, "RelatedTutorials",
 CellID->806871991]
}, Open  ]]
}, Open  ]],
Cell[63814, 2048, 23, 0, 70, "FooterCell"]
}
]
*)

